/******************************************************************************/
/*                                                                            */
/*                       MC68000 INTERFACE (STARSCREAM)                       */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

#include "starcpu.h"

#define MAX_68000	(2)
#define MAX_PROGRAM	(4)
#define MAX_DATA	(32)

struct S68000CONTEXT            M68000_context[MAX_68000];

struct STARSCREAM_PROGRAMREGION M68000_programregion[MAX_68000][MAX_PROGRAM];

struct STARSCREAM_DATAREGION    M68000_dataregion_rb[MAX_68000][MAX_DATA];
struct STARSCREAM_DATAREGION    M68000_dataregion_rw[MAX_68000][MAX_DATA];
struct STARSCREAM_DATAREGION    M68000_dataregion_wb[MAX_68000][MAX_DATA];
struct STARSCREAM_DATAREGION    M68000_dataregion_ww[MAX_68000][MAX_DATA];

struct STARSCREAM_DATAREGION    MC68000A_memoryall[128];

/*
 *  Fill in the basic structures via these functions...
 */

void AddMemFetch (ULONG d0, ULONG d1, UBYTE *d2);
void AddReadByte (ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddReadWord (ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddWriteByte(ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddWriteWord(ULONG d0, ULONG d1, void *d2, UBYTE *d3);

void AddMemFetchMC68000B (ULONG d0, ULONG d1, UBYTE *d2);
void AddReadByteMC68000B (ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddReadWordMC68000B (ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddWriteByteMC68000B(ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddWriteWordMC68000B(ULONG d0, ULONG d1, void *d2, UBYTE *d3);

/*
 *  Set Memory pointers to our structures...
 */

void AddInitMemory(void);
void AddInitMemoryMC68000B(void);

void M68000A_load_update(void);
void M68000A_save_update(void);
void M68000B_load_update(void);
void M68000B_save_update(void);

void WriteStarScreamByte(ULONG address, UBYTE data);
UBYTE ReadStarScreamByte(ULONG address);

void Clear68000List(void);

/*
 *  Helper Functions for Starscream memory read/write structs
 *  ---------------------------------------------------------
 */

void Stop68000(ULONG address, UBYTE data);

UBYTE DefBadReadByte(ULONG address);
UWORD DefBadReadWord(ULONG address);
void DefBadWriteByte(ULONG address, UBYTE data);
void DefBadWriteWord(ULONG address, UWORD data);

/*
 *  Byte Swapping
 */

void ByteSwap(UBYTE *MEM, ULONG size);