/******************************************************************************/
/*                                                                            */
/*                             PRO ACTION REPLAY                              */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

enum {
   SEARCH_MODE_ABSOLUTE = 0,
   SEARCH_MODE_RELATIVE,
   SEARCH_MODE_SINGLE_BIT,
   SEARCH_MODE_SLOW,

   SEARCH_MODE_COUNT,
};

ULONG search_mode;

#define CHEAT_MAX	(256)

typedef struct CHEAT
{
   UBYTE name[256];		// cheat name/description
   UBYTE info[256];		// extra info (used to keep comments in cheats.cfg)
   ULONG address;		// 32-bit address in cpu memory map
   ULONG data;			// data to patch
   ULONG mask;			// data mask
   UBYTE active;		// active status
   UBYTE type;			// patch mode
} CHEAT;

int CheatCount;			// Number of Cheats in List
struct CHEAT CheatList[CHEAT_MAX]; // List of Current Game cheats

// Cheat data size

#define CHEAT_8BIT		(0x00)
#define CHEAT_16BIT		(0x01)
#define CHEAT_24BIT		(0x02)
#define CHEAT_32BIT		(0x03)

// Cheat bitmask enabled

#define CHEAT_MASKED		(0x04)

// Cheat only lasts one frame

#define CHEAT_1_TIME		(0x08)

char *get_search_mode_name(ULONG mode);

void update_arpro_cheats(void);

void start_arpro_search(UBYTE data);

void continue_arpro_search(UBYTE data);

ULONG get_search_range_start(ULONG addr);
ULONG get_search_range_end(ULONG addr);
UBYTE get_address_status(ULONG addr);

void reset_arpro(void);

void load_arpro_cheats(char *section);
void save_arpro_cheats(char *section);

ULONG *get_arpro_results(int num);

UBYTE gen_cpu_read_byte(ULONG address);
UBYTE gen_cpu_read_byte_2(ULONG address);
void gen_cpu_write_byte(ULONG address, UBYTE data);
void gen_cpu_write_byte_2(ULONG address, UBYTE data);

int match_all_count;		// total of all match_count
