/******************************************************************************/
/*                                                                            */
/*                              DEBUG FILE SUPPORT                            */
/*                                                                            */
/******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <stddef.h>
#include <stdarg.h>
#include <string.h>

#include "raine.h"
#include "debug.h"

#ifdef HACKS

int debug_mode;

static FILE *file_debug;

/*

write a string to the debug file. supports printf() sytle formatting.

*/

void print_debug(const char *format, ...)
{
   if(debug_mode){
      
      char debug_str[256];

      va_list ap;
      va_start(ap,format);
      vsprintf(debug_str,format,ap);
      va_end(ap);
      
      fprintf(file_debug, debug_str);
      //#ifndef RAINE_DOS
      fflush(file_debug);
      //#endif

   }
}

void open_debug(void)
{
   if(debug_mode){

      char str[256];

      sprintf(str,"%sdebug",dir_cfg.exe_path);
      mkdir(str);
#ifdef RAINE_DOS
      sprintf(str,"%sdebug/debug.txt",dir_cfg.exe_path);
#else
      sprintf(str,"%sdebug/debug_x.txt",dir_cfg.exe_path);
#endif
      if(!(file_debug=fopen(str,"w"))){
         printf("Unable to write to %s\n",str);
         exit(1);
      }
      print_debug( EMUNAME " " VERSION " Debug File (Illegal Mem accesses etc...)\n");
      print_debug("--------------------------------------------------------\n\n");
      
#ifdef MEMORY_DEBUG
      InitPurify();
#endif
      
   }
}

void close_debug(void)
{
   if(debug_mode){
      
#ifdef MEMORY_DEBUG
      DonePurify();
#endif
      fclose(file_debug);
      
   }
}

#endif
