/******************************************************************************/
/*                                                                            */
/*                             RAINE DATATYPES                                */
/*                                                                            */
/******************************************************************************/

#ifndef __DEFTYPES_H__
#define __DEFTYPES_H__

#ifdef RAINE_DOS

#define DEF_INLINE		inline	

#else

#define DEF_INLINE		_inline

#endif

#define UBYTE	unsigned char		//  8-bit unsigned
#define BYTE	signed char		//  8-bit signed
#define UWORD	unsigned short		// 16-bit unsigned
#define WORD	short			// 16-bit signed
#define ULONG	unsigned int		// 32-bit unsigned
#define LONG	int			// 32-bit signed
#define ULONG64	unsigned long long	// 64-bit unsigned
#define LONG64	long long		// 64-bit signed

#define CPTR	unsigned int		// 32-bit pointer

#define INT8	BYTE
#define INT16	WORD
#define INT32	LONG
#define INT64	LONG64

#define UINT8	UBYTE
#define UINT16	UWORD
#define UINT32	ULONG
#define UINT64	ULONG64

#define BOOL    int

#ifndef TRUE 
#define TRUE	-1
#define FALSE	0
#endif

#ifndef MIN
#define MIN(x,y)     (((x) < (y)) ? (x) : (y))
#define MAX(x,y)     (((x) > (y)) ? (x) : (y))
#define MID(x,y,z)   MAX((x), MIN((y), (z)))
#endif

#define ASCII_ID(a,b,c,d)     ((a<<24) | (b<<16) | (c<<8) | (d<<0))

typedef void mapper_direct(int bank, int cols);

#endif
