/******************************************************************************/
/*                                                                            */
/*                        RAINE FILE ACCESS/ZIP SUPPORT                       */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"
#include "games.h"

int load_file(char *filename, UBYTE *dest, ULONG size);
int save_file(char *filename, UBYTE *source, ULONG size);

/*

search for any alternative file names that a rom could have. this uses the
romlist data for any 'romof' games, if a rom matches on crc32 and size, we
assume it is a match.

*/

UBYTE *alt_names[8];
ULONG find_alternative_file_names(ROM_INFO *rom_info, DIR_INFO *dir_list);

int load_rom(UBYTE *rom, UBYTE *dest, ULONG size);
int load_rom_index(ULONG num, UBYTE *dest, ULONG size);

int load_rom_dir(DIR_INFO *dir_list, UBYTE *rom, UBYTE *dest, ULONG size, ULONG crc32);

int rom_size_dir(DIR_INFO *dir_list, UBYTE *rom, ULONG size, ULONG crc32);

#ifdef HACKS

void save_debug(UBYTE *name, UBYTE *src, ULONG size, ULONG mode);

#endif
