/******************************************************************************/
/*                                                                            */
/*           tc0004vcu: TAITO VIDEO CHIP UNIT (H-SYSTEM/AIR-SYSTEM)           */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

int tc0004vcu_layer_count;			// Init this to 0 each screen update.

typedef struct TC0004VCU			// Information about 1 chip
{
   UBYTE *RAM;					// Chip RAM address
   UBYTE *GFX_BG0;				// GFX BG0 and BG1
   UBYTE *GFX_BG0_MSK;				// GFX MASK BG0 and BG1
   UBYTE *GFX_FG0;				// GFX FG0
   ULONG tile_mask;				// Mask for tile number
   mapper_direct *mapper;			// Colour mapper
   ULONG bmp_x,bmp_y;				// Game screen offset (64,64)
   ULONG bmp_w,bmp_h;				// Game screen size (512,416)
   ULONG scr_x,scr_y;				// Scroll offset add (0,0)
} TC0004VCU;

struct TC0004VCU tc0004vcu;

void tc0004vcu_init(void);

void tc0004vcu_gfx_fg0_a_wb(ULONG addr, UBYTE data);
void tc0004vcu_gfx_fg0_a_ww(ULONG addr, UWORD data);
void tc0004vcu_gfx_fg0_b_wb(ULONG addr, UBYTE data);
void tc0004vcu_gfx_fg0_b_ww(ULONG addr, UWORD data);

void tc0004vcu_render_bg0(void);
void tc0004vcu_render_bg1(void);
void tc0004vcu_render_fg0(void);
void tc0004vcu_render_obj(void);
//void tc0004vcu_render_obj_low(void);
//void tc0004vcu_render_obj_high(void);
