/******************************************************************************/
/*                                                                            */
/*                  tc0006vcu: TAITO VIDEO CHIP (F3-SYSTEM)                   */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

int tc0006vcu_layer_count;

typedef struct TC0006VCU			// Information about 1 chip
{
   UBYTE *RAM;					// video ram
   UBYTE *RAM_SCR;				// ctrl ram
   UBYTE *GFX_FG;				//
   UBYTE *GFX_FG_MASK;				//
   UBYTE *GFX_BG;				//
   UBYTE *GFX_BG_MASK;				//
   ULONG tile_mask;                             //
   mapper_direct *mapper;			// Colour mapper
   ULONG bmp_x,bmp_y;				// Game screen offset (64,64)
   ULONG bmp_w,bmp_h;				// Game screen size (320,224)
   ULONG scr_x[5];				//
   ULONG scr_y[5];				//
   ULONG pal_ofs;				//
} TC0006VCU;

struct TC0006VCU tc0006vcu;

void init_tc0006vcu(void);

void debug_tc0006vcu(void);

void tc0006vcu_gfx_fg0_wb(ULONG addr, UBYTE data);
void tc0006vcu_gfx_fg0_ww(ULONG addr, UWORD data);

void tc0006vcu_render_layer(int layer);
void tc0006vcu_render_layer_1024(int layer);
void tc0006vcu_render_fg0(void);
