/******************************************************************************/
/*                                                                            */
/*                 tc0150rod: TAITO ROAD SCROLL EFFECT CHIP                   */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

typedef struct TC0150ROD			// Information about 1 chip
{
   UBYTE *RAM;					// RAM address
   UBYTE *GFX;					// GFX address
   UBYTE *PAL;					// PAL address (map rom)
   mapper_direct *mapper;			// Colour mapper
   ULONG bmp_x,bmp_y;				// Game screen offset (64,64)
   ULONG bmp_w,bmp_h;				// Game screen size (320,224)
   ULONG scr_x,scr_y;				// Scroll offset add (0,0)
} TC0150ROD;

struct TC0150ROD tc0150rod;

void tc0150rod_init_palette(void);

void tc0150rod_show_palette(void);

void tc0150rod_render(ULONG start, ULONG end);

void tc0150rod_render_flipy(ULONG start, ULONG end);
