/******************************************************************************/
/*                                                                            */
/*                  tc0180vcu: TAITO VIDEO CHIP (B-SYSTEM)                    */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

int tc0180vcu_layer_count;			// Init this to 0 each screen update.

typedef struct TC0180VCU			// Information about 1 chip
{
   UBYTE *RAM;					// Layer RAM address
   UBYTE *GFX_BG0;				// GFX BG0 and BG1
   UBYTE *GFX_BG0_MSK;				// GFX MASK BG0 and BG1
   UBYTE *GFX_BG2;				// GFX BG2
   UBYTE *GFX_BG2_MSK;				// GFX MASK BG2
   ULONG tile_mask;				// Mask for tile number
   ULONG bmp_x,bmp_y;				// Game screen offset (32,32)
   ULONG bmp_w,bmp_h;				// Game screen size (320,224)
   ULONG scr_x,scr_y;				// Scroll offset add (0,16)
   UBYTE col_mask;				//
   UBYTE col_bank[4];				//
   UBYTE *RAM_2;				// Further RAM address
} TC0180VCU;

struct TC0180VCU tc0180vcu;

void vcu_make_col_bankmap(UBYTE mask, UBYTE ofs_0, UBYTE ofs_1, UBYTE ofs_2, UBYTE ofs_3);

void vcu_debug_info(void);

void vcu_render_bg0(void);
void vcu_render_bg1(void);
void vcu_render_bg2(void);
void vcu_render_obj(ULONG num);

void vcu_render_bg0_r270(void);
void vcu_render_bg1_r270(void);
void vcu_render_bg2_r270(void);
void vcu_render_obj_r270(int pri);

/*

video_info interface

*/

extern struct VIDEO_INFO b_system_video;
extern struct VIDEO_INFO b_system_r180_video;

void draw_b_system(void);
