/******************************************************************************/
/*                                                                            */
/*            tc0220ioc: TAITO INPUT/OUTPUT CONTROL CHIP (F2 SYSTEM)          */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

#define TC0220_STOPCPU	(0x0001)		// Use tc0220ioc for frame sync
#define TC0220_QUIET	(0x0002)		// Don't report any errors

typedef struct TC0220IOC			// Information about 1 chip
{
   UBYTE *RAM;					// RAM address
   ULONG ctrl;					// Control Information
} TC0220IOC;

struct TC0220IOC tc0220ioc;

extern struct INPUT_INFO b_system_inputs[];
extern struct INPUT_INFO b_system_inputs_3_button[];

void reset_tc0220ioc(void);

// 'Normal' 68000 Interface

UBYTE tc0220ioc_rb(ULONG address);
UWORD tc0220ioc_rw(ULONG address);
void  tc0220ioc_wb(ULONG address, UBYTE data);
void  tc0220ioc_ww(ULONG address, UWORD data);

// 'Byteswapped' 68000 Interface (Gun Frontier)

UBYTE tc0220ioc_rb_bswap(ULONG address);
UWORD tc0220ioc_rw_bswap(ULONG address);
void  tc0220ioc_wb_bswap(ULONG address, UBYTE data);
void  tc0220ioc_ww_bswap(ULONG address, UWORD data);

// 'Port access' 68000 Interface (Master of Weapons)

UBYTE tc0220ioc_rb_port(ULONG address);
UWORD tc0220ioc_rw_port(ULONG address);
void  tc0220ioc_wb_port(ULONG address, UBYTE data);
void  tc0220ioc_ww_port(ULONG address, UWORD data);

// 'Normal' Z80 Interface (L-System)

UBYTE tc0220ioc_rb_z80(UWORD address);
void  tc0220ioc_wb_z80(UWORD address, UBYTE data);

// 'Port access' Z80 Interface (L-System)

UBYTE tc0220ioc_rb_z80_port(UWORD address);
void  tc0220ioc_wb_z80_port(UWORD address, UBYTE data);

