/*
 *  Stuff for the raine gui, mostly dialog data
 */

#include "raine.h"
#include "rgui.h"
#include "rguiproc.h"

PALETTE gui_pal;
BITMAP *gui_backdrop;

char gamename[80];
char screenname[80];
char soundname[80];

char langname[80];

int about_proc(int msg, DIALOG *d, int c);
int cycle_proc(int msg, DIALOG *d, int c);

int about_game_proc(int msg, DIALOG *d, int c);

int dir_edit_proc(int msg, DIALOG *d, int c);

int screen_select_proc(int msg, DIALOG *d, int c);

int raine_quit_proc(int msg, DIALOG *d, int c);

int game_play_proc(int msg, DIALOG *d, int c);

int game_radio_proc(int msg, DIALOG *d, int c);

int game_select_proc(int msg, DIALOG *d, int c);
char *listbox_getter(int index, int *list_size);

int dsw_select_proc(int msg, DIALOG *d, int c);
char *dswlist_getter(int index, int *list_size);
int dsw_edit_proc(int msg, DIALOG *d, int c);
void DoDSWEdit(void);
int dsw_reset_proc(int msg, DIALOG *d, int c);

int joy_calib_proc(int msg, DIALOG *d, int c);
char *joylist_getter(int index, int *list_size);
int joy_edit_proc(int msg, DIALOG *d, int c);
void DoJoyEdit(void);

int game_reset_proc(int msg, DIALOG *d, int c);

int cheatdata_edit_proc(int msg, DIALOG *d, int c);

void DoCheatEdit(void);
int cheat_edit_proc(int msg, DIALOG *d, int c);
int cheat_add_proc(int msg, DIALOG *d, int c);
int cheat_new_proc(int msg, DIALOG *d, int c);
int cheat_del_proc(int msg, DIALOG *d, int c);

int actionreplay_proc(int msg, DIALOG *d, int c);
char *cheatlist_getter(int index, int *list_size);

char *search_list_getter(int index, int *list_size);

int game_setup_proc(int msg, DIALOG *d, int c);

int control_setup_proc(int msg, DIALOG *d, int c);

int romdir_edit_proc(int msg, DIALOG *d, int c);

char romedit[4][256];

char *language_getter(int index, int *list_size);
int language_proc(int msg, DIALOG *d, int c);

int language_sel_proc(int msg, DIALOG *d, int c);

int sound_setup_proc(int msg, DIALOG *d, int c);
char *soundcardlist_getter(int index, int *list_size);

int key_select_proc(int msg, DIALOG *d, int c);
int joy_key_select_proc(int msg, DIALOG *d, int c);

int load_game_proc(int msg, DIALOG *d, int c);

int auto_select_proc(int msg, DIALOG *d, int c);
char *autolist_getter(int index, int *list_size);
int auto_edit_proc(int msg, DIALOG *d, int c);

char about0[64];
char about1[64];
char about2[64];
char about3[64];
char about4[64];
char about5[64];
char about6[64];
char about7[64];
char about8[64];
char about9[64];

DIALOG about_raine[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,   0,   240, 190,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "About Raine"},
   { d_bitmap_proc,      0,   0,   0,   0,    0,               0,                   0,    0,       0,    0,    NULL},
   { x_raine_button_proc,8,   166, 32,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'O',  D_EXIT,  0,    0,    "&Ok"},
   { d_ctext_proc,       120, 54,  1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about0},
   { d_ctext_proc,       120, 64,  1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about1},
   { d_ctext_proc,       120, 84,  1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about2},
   { d_ctext_proc,       120, 94,  1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about3},
   { d_ctext_proc,       120, 104, 1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about4},
   { d_ctext_proc,       120, 114, 1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about5},
   { d_ctext_proc,       120, 124, 1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about6},
   { d_ctext_proc,       120, 134, 1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about7},
   { d_ctext_proc,       120, 144, 1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about8},
   { d_ctext_proc,       120, 154, 1,   1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    about9},
   { cycle_proc,         70,  18,  93,  23,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL},
   { about_game_proc,    44,  166, 64,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'G',  D_EXIT,  0,    0,    "&Game Info"},
   { NULL,               0,   0,   0,   0,    0,    0,    0,    0,       0,    0,    NULL}
};

DIALOG about_game[] =
{
   /* (dialog proc)      (x)  (y)  (w)  (h) (fg) (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,  0,   0, 240, 186, GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Game Information"},
   { d_bitmap_proc,        0,   0,   0,   0,   0,   0,  0,    0,       0,    0,    NULL},
   { x_raine_button_proc,  8, 162,  32,  16, GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  'O',  D_EXIT,  0,    0,    "&Ok"},
   { d_raine_textbox_proc, 8,  54, 224, 102, GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL},
   { NULL,                 0,   0,   0,   0,   0,   0,  0,    0,       0,    0,    NULL}
};

char game_select_string1[256];

DIALOG game_select[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   240,  210,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Change Game"},
   { d_raine_list_proc,  48,   38,   224,  116,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  GUI_COL_TEXT_1,  0,    listbox_getter},
   { x_raine_button_proc,48,   194,  48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'L',  D_EXIT,  0,    0,    "&Load"},
   { x_raine_button_proc,48+56,194,  48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'C',  D_EXIT,  0,    0,    "&Cancel"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Select Game:"},
   { x_text_proc,        180,  160,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Game List:"},
   { game_radio_proc,    180,  170,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    1,    "Full"},
   { game_radio_proc,    180,  180,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    1,    "Available"},
   { game_radio_proc,    180,  190,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    1,    "Missing"},
   { romdir_edit_proc,   48+56,174,  48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Dirs"},
   { d_text_proc,        48,   160,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    game_select_string1},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

DIALOG romdir_edit_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   208,  96,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Directories"},
   { x_raine_button_proc,48,   82,   48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { x_raine_button_proc,104,  82,   48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'C',  D_EXIT,  0,    0,    "&Cancel"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Rom Directories:"},
   { d_edit_proc,        48,   38,   6*30, 8,    GUI_COL_TEXT_1,  253,  0,    0,       240,  0,    romedit[0]},
   { d_edit_proc,        48,   48,   6*30, 8,    GUI_COL_TEXT_1,  253,  0,    0,       240,  0,    romedit[1]},
   { d_edit_proc,        48,   58,   6*30, 8,    GUI_COL_TEXT_1,  253,  0,    0,       240,  0,    romedit[2]},
   { d_edit_proc,        48,   68,   6*30, 8,    GUI_COL_TEXT_1,  253,  0,    0,       240,  0,    romedit[3]},
   { dir_edit_proc,      232,  38,   8,    8,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    " "},
   { dir_edit_proc,      232,  48,   8,    8,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  1,    0,    " "},
   { dir_edit_proc,      232,  58,   8,    8,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  2,    0,    " "},
   { dir_edit_proc,      232,  68,   8,    8,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  3,    0,    " "},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

/*

keyboard controls

*/

int keys_radio_proc(int msg, DIALOG *d, int c);
int keys_radio_proc_2(int msg, DIALOG *d, int c);
int input_select_proc(int msg, DIALOG *d, int c);
char *inputlist_getter(int index, int *list_size);
int key_edit_proc(int msg, DIALOG *d, int c);
UBYTE read_new_keycode(void);

#define KEY_TYPE_LIST		5
#define KEY_VIEW_LIST		8

DIALOG input_select[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   272,  204,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Keyboard Setup"},
   { d_raine_list_proc,  48,   26+12,256,  112,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    inputlist_getter},
   { x_raine_button_proc,48,   174+16,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { key_edit_proc,      104,  174+16,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'E',  D_EXIT,  0,    0,    "&Edit"},
   { x_text_proc,        48,   156,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Keys for this game:"},
   { keys_radio_proc,    48,   166,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    1,    "Use Default settings"},
   { keys_radio_proc,    48,   176,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    1,    "Use Custom settings"},
   { x_text_proc,        180,  156,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Controls:"},
   { keys_radio_proc_2,  180,  166,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Default settings"},
   { keys_radio_proc_2,  180,  176,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Emulator settings"},
   { keys_radio_proc_2,  180,  186,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Custom for this game"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Keyboard Controls:"},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

/*

joystick controls

*/

int joy_keys_radio_proc(int msg, DIALOG *d, int c);
int joy_keys_radio_proc_2(int msg, DIALOG *d, int c);
int joy_select_proc(int msg, DIALOG *d, int c);
char *joy_inputlist_getter(int index, int *list_size);
int joy_key_edit_proc(int msg, DIALOG *d, int c);
UBYTE joy_read_new_keycode(void);

#define JOY_KEY_TYPE_LIST		5
#define JOY_KEY_VIEW_LIST		8

DIALOG joy_input_select[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   272,  204,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Joystick Setup"},
   { d_raine_list_proc,  48,   26+12,256,  112,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    joy_inputlist_getter},
   { x_raine_button_proc,48,   174+16,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { joy_key_edit_proc,  104,  174+16,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'E',  D_EXIT,  0,    0,    "&Edit"},
   { x_text_proc,        48,   156,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Joy for this game:"},
   { joy_keys_radio_proc,48,   166,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    1,    "Use Default settings"},
   { joy_keys_radio_proc,48,   176,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    1,    "Use Custom settings"},
   { x_text_proc,        180,  156,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Controls:"},
   { joy_keys_radio_proc_2,180,166,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Default settings"},
   { joy_keys_radio_proc_2,180,176,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Emulator settings"},
   { joy_keys_radio_proc_2,180,186,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Custom for this game"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Joystick Controls:"},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

DIALOG joy_select[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   240,  178+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Joystick Selection"},
   { d_raine_list_proc,  48,   26+12,224,  132,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    joylist_getter},
   { x_raine_button_proc,48,   164+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { joy_edit_proc,      104,  164+12,72,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'C',  D_EXIT,  0,    0,    "&Calibrate"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Choose Joystick:"},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

DIALOG auto_select[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   240,  158+16,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Autofire Setup"},
   { d_raine_list_proc,  48,   26+12,224,  112,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    autolist_getter},
   { x_raine_button_proc,48,   144+16,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { auto_edit_proc,     104,  144+16,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'E',  D_EXIT,  0,    0,    "&Edit"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Autofire Speeds:"},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

char cheateditname[256];
char cheateditaddress[256];
char cheateditdata[256];
char cheateditinfo[256];

DIALOG cheatdata_edit_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   224,  102,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Cheat Data"},
   { x_raine_button_proc,48,   88,   48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { x_raine_button_proc,104,  88,   48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'C',  D_EXIT,  0,    0,    "&Cancel"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Cheat Data:"},
   { x_text_proc,        48,   38,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Name:"},
   { d_edit_proc,        80,   38,   6*25, 8,    GUI_COL_TEXT_1,  253,  0,    0,       255,  0,    cheateditname},
   { x_text_proc,        48,   48,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Addr:"},
   { d_edit_proc,        80,   48,   6*9,  8,    GUI_COL_TEXT_1,  253,  0,    0,       8,    0,    cheateditaddress},
   { x_text_proc,        48,   58,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Data:"},
   { d_edit_proc,        80,   58,   6*9,  8,    GUI_COL_TEXT_1,  253,  0,    0,       8,    0,    cheateditdata},
   { x_text_proc,        48,   68,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Info:"},
   { d_edit_proc,        80,   68,   6*25, 8,    GUI_COL_TEXT_1,  253,  0,    0,       255,  0,    cheateditinfo},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

DIALOG actionreplay_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   240,  178+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Cheat Control"},
   { d_raine_list_proc,  48,   26+12,224,  112,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    cheatlist_getter},
   { x_raine_button_proc,48,   164+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { cheat_edit_proc,    48,   144+12,56,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'T',  D_EXIT,  0,    0,    "&Toggle"},
   { cheatdata_edit_proc,112,  144+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'E',  D_EXIT,  0,    0,    "&Edit"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Action Replay cheats:"},
   { x_raine_button_proc,216,  164+12,56,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'S',  D_EXIT,  0,    0,    "&Search>>"},
   { cheat_new_proc,     168,  144+12,32,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'N',  D_EXIT,  0,    0,    "&New"},
   { cheat_del_proc,     208,  144+12,56,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    "Delete"},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

int cheat_search_new_proc(int msg, DIALOG *d, int c);
int cheat_search_cont_proc(int msg, DIALOG *d, int c);

DIALOG search_main_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   240,  178+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Cheat Search"},
   { x_raine_button_proc,48,   164+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { cheat_search_new_proc,48, 144+12,64,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'S',  D_EXIT,  0,    0,    "New &Search"},
   { cheat_search_cont_proc,120,144+12,64, 16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'C',  D_EXIT,  0,    0,    "&Continue"},
   { d_raine_list_proc,  48,   26+12,224,  112,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    search_list_getter},
   { x_text_proc,        48,   26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Action Replay results:"},
   { x_raine_button_proc,216,  164+12,56,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'E',  D_EXIT,  0,    0,    "&Edit>>"},
   { cheat_add_proc,     192,  144+12,64,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'A',  D_EXIT,  0,    0,    "&Add Result"},
   { NULL,               0,    0,      0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

char *search_mode_getter(int index, int *list_size);

DIALOG search_mode_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   180,  80+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,   0,    0,       0,    0,    "New Search"},
   { x_text_proc,        48,   26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Choose Search Mode:"},
   { d_raine_list_proc,  48,   26+12,164,  32+4, GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    search_mode_getter},
   { x_raine_button_proc,48,   68+12, 48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { NULL,               0,    0,      0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

char byte_hex_data[8];
char byte_dec_data[8];
char byte_sgn_data[8];
char byte_asc_data[8];

DIALOG *byte_hex_dialog;
DIALOG *byte_dec_dialog;
DIALOG *byte_sgn_dialog;
DIALOG *byte_asc_dialog;

int byte_hex_edit_proc(int msg, DIALOG *d, int c);
int byte_dec_edit_proc(int msg, DIALOG *d, int c);
int byte_sgn_edit_proc(int msg, DIALOG *d, int c);
int byte_asc_edit_proc(int msg, DIALOG *d, int c);

DIALOG search_type_0a_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   180,  80+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,   0,    0,       0,    0,    "New Search"},
   { x_text_proc,        48,   26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Enter Search Byte:"},
   { x_text_proc,        48,   26+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Hex:"},
   { byte_hex_edit_proc, 48+(6*8),26+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  2,    0,    byte_hex_data},
   { x_text_proc,        48,   36+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Dec:"},
   { byte_dec_edit_proc, 48+(6*8),36+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  3,    0,    byte_dec_data},
   { x_text_proc,        48,   46+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Signed:"},
   { byte_sgn_edit_proc, 48+(6*8),46+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  4,    0,    byte_sgn_data},
   { x_text_proc,        48,   56+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Ascii:"},
   { byte_asc_edit_proc, 48+(6*8),56+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  1,    0,    byte_asc_data},
   { x_raine_button_proc,48,   68+12, 48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { NULL,               0,    0,      0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

DIALOG search_type_0b_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   180,  80+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,   0,    0,       0,    0,    "Continue Search"},
   { x_text_proc,        48,   26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Enter Search Byte:"},
   { x_text_proc,        48,   26+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Hex:"},
   { byte_hex_edit_proc, 48+(6*8),26+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  2,    0,    byte_hex_data},
   { x_text_proc,        48,   36+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Dec:"},
   { byte_dec_edit_proc, 48+(6*8),36+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  3,    0,    byte_dec_data},
   { x_text_proc,        48,   46+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Signed:"},
   { byte_sgn_edit_proc, 48+(6*8),46+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  4,    0,    byte_sgn_data},
   { x_text_proc,        48,   56+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Ascii:"},
   { byte_asc_edit_proc, 48+(6*8),56+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  1,    0,    byte_asc_data},
   { x_raine_button_proc,48,   68+12, 48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { NULL,               0,    0,      0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

DIALOG search_type_1a_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   160,  68,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "New Search"},
   { x_text_proc,        48,   26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Search initialized, use"},
   { x_text_proc,        48,   36,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "continue search when the"},
   { x_text_proc,        48,   46,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "search value has changed."},
   { x_raine_button_proc,48,   56,    48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { NULL,               0,    0,      0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

DIALOG search_type_1b_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   200,  80+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,   0,    0,       0,    0,    "Continue Search"},
   { x_text_proc,        48,   26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Enter difference from last byte:"},
   { x_text_proc,        48,   26+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Hex:"},
   { byte_hex_edit_proc, 48+(6*8),26+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  2,    0,    byte_hex_data},
   { x_text_proc,        48,   36+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Dec:"},
   { byte_dec_edit_proc, 48+(6*8),36+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  3,    0,    byte_dec_data},
   { x_text_proc,        48,   46+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Signed:"},
   { byte_sgn_edit_proc, 48+(6*8),46+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  4,    0,    byte_sgn_data},
   { x_text_proc,        48,   56+12,  0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Ascii:"},
   { byte_asc_edit_proc, 48+(6*8),56+12,6*6,8,   GUI_COL_TEXT_1,  253,  0,    D_EXIT,  1,    0,    byte_asc_data},
   { x_raine_button_proc,48,   68+12, 48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { NULL,               0,    0,      0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

#define search_type_2a_dialog search_type_1a_dialog

char *search_type_2b_getter(int index, int *list_size);

DIALOG search_type_2b_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   180,  80+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,   0,    0,       0,    0,    "Continue Search"},
   { x_text_proc,        48,   26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Bit status since last search:"},
   { d_raine_list_proc,  48,   26+12,164,  32+4, GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    search_type_2b_getter},
   { x_raine_button_proc,48,   68+12, 48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { NULL,               0,    0,      0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

#define search_type_3a_dialog search_type_1a_dialog

char *search_type_3b_getter(int index, int *list_size);

DIALOG search_type_3b_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    0,    180, 80+12,GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,   0,    0,       0,    0,    "Continue Search"},
   { x_text_proc,        8,    16,   0,   8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Byte status since last search:"},
   { d_raine_list_proc,  8,    28,   164, 32+4, GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    search_type_3b_getter},
   { x_raine_button_proc,8,    70,   48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { NULL,               0,    0,    0,   0,     0,    0,   0,   0,       0,    0,    NULL}
};

char *hex_view_getter(int index, int *list_size);

DIALOG hex_view_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    10,   284,  200+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "View Memory"},
   { x_raine_button_proc,8,    186+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { d_raine_list_proc,  8,    26+12,268,  156,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    hex_view_getter},
   { x_text_proc,        8,    26,     0,   8,   GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Memory Dump:"},
   { NULL,               0,    0,      0,   0,     0,    0,  0,    0,       0,    0,    NULL}
};

DIALOG dsw_select[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   272,  178+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Dipswitches"},
   { d_raine_list_proc,  48,   26+12,256,  100,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    dswlist_getter},
   { x_raine_button_proc,48,   164+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { dsw_edit_proc,      104,  164+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'E',  D_EXIT,  0,    0,    "&Edit"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Edit Dipswitch settings:"},
   { d_text_proc,        80+32,23+120,0,   8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "           87654321"},
   { d_text_proc,        80+32,23+130,0,   8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL },
   { d_text_proc,        80+32,23+140,0,   8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL },
   { dsw_reset_proc,     160,  164+12,96,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'F',  D_EXIT,  0,    0,    "&Factory Settings"},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

DIALOG language_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,40,   10,   240,  178+12,GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "ROM Switches"},
   { d_raine_list_proc,  48,   26+12,224,  100,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    language_getter},
   { x_raine_button_proc,48,   164+12,48,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Done"},
   { language_sel_proc,  102,  164+12,56,  16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'S',  D_EXIT,  0,    0,    "&Select"},
   { x_text_proc,        48,   26,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Change ROM Version:"},
   { x_text_proc,        48,   150,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Current:"},
   { d_text_proc,        48,   160,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    langname},
   { NULL,               0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL}
};

DIALOG key_editing[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)             (bg)                 (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    0,    160,  50,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Keyboard Input"},
   { x_ctext_proc,       80,   26,   0,    0,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Press New Key..."},
   { key_select_proc,    0,    0,    0,    0,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

DIALOG joy_key_editing[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)             (bg)                 (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    0,    160,  50,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Joystick Input"},
   { x_ctext_proc,       80,   26,   0,    0,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Push Joystick..."},
   { joy_key_select_proc,0,    0,    0,    0,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

DIALOG loading_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)             (bg)                 (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    0,    160,  50,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Load Game"},
   { x_ctext_proc,       80,   26,   0,    0,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Loading Game Files..."},
   { load_game_proc,     0,    0,    0,    0,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

DIALOG game_setup_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    0,    100,  140,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Game Setup"},
   { x_text_proc,        8,    16,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Select:"},
   { x_raine_button_proc,8,    96+20,48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'B',  D_EXIT,  0,    0,    "&Back"},
   { game_reset_proc,    8,    16+12,84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'R',  D_EXIT,  0,    0,    "&Reset Game"},
   { dsw_select_proc,    8,    36+12,84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'D',  D_EXIT,  0,    0,    "&Dipswitches"},
   { actionreplay_proc,  8,    56+12,84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'A',  D_EXIT,  0,    0,    "&Action Replay"},
   { language_proc,      8,    76+12,84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'V',  D_EXIT,  0,    0,    "ROM &Version"},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

#define SND_RATE_LIST		6
#define SND_3812_LIST		10

DIALOG sound_setup_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)             (bg)                 (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    0,    216,  190,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Sound Setup"},
   { d_raine_list_proc,  8,    28,   200,  80,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    D_EXIT,  0,    0,    soundcardlist_getter},
   { x_raine_button_proc,8,    166,  48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'O',  D_EXIT,  0,    0,    "&Ok"},
   { x_raine_button_proc,64,   166,  48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'C',  D_EXIT,  0,    0,    "&Cancel"},
   { x_text_proc,        8,    16,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Choose Sound Driver:"},
   { x_text_proc,        8,    114,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Sample Rate:"},
   { x_raine_radio_proc, 8,    124,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    1,    "11025"},
   { x_raine_radio_proc, 8,    134,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    1,    "22050"},
   { x_raine_radio_proc, 8,    144,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    1,    "44100"},
   { x_text_proc,        88,   114,  1,    1,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "YM3812:"},
   { x_raine_radio_proc, 88,   124,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Hardware"},
   { x_raine_radio_proc, 88,   134,  64,   9,    GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       1,    1,    "Software"},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

DIALOG control_setup_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,0,    0,    110,  140,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Controls"},
   { x_text_proc,        8,    16,   0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Select:"},
   { x_raine_button_proc,8,    116,  48,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'B',  D_EXIT,  0,    0,    "&Back"},
   { input_select_proc,  8,    16+12,94,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'K',  D_EXIT,  0,    0,    "&Keyboard Setup"},
   { joy_select_proc,    8,    36+12,94,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'J',  D_EXIT,  0,    0,    "&Joystick Setup"},
   { auto_select_proc,   8,    56+12,94,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'A',  D_EXIT,  0,    0,    "&Autofire Setup"},
   { joy_calib_proc,     8,    76+12,94,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'S',  D_EXIT,  0,    0,    "Joystick &Select"},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

DIALOG the_dialog[] =
{
   /* (dialog proc)      (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_bitmap_proc,      0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL},
   { d_raine_box_proc,   16,   160,  320-32,64,  GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL},
   { game_select_proc,   16,   36,   84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'G',  D_EXIT,  0,    0,    "Change &Game"},
   { raine_quit_proc,    16,   136,  84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'Q',  D_EXIT,  0,    0,    "&Quit Raine"},
   { game_play_proc,     16,   16,   84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'P',  D_EXIT,  0,    0,    "&Play Game"},
   { control_setup_proc, 16,   56,   84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'C',  D_EXIT,  0,    0,    "&Control Setup"},
   { screen_select_proc, 16,   76,   84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'S',  D_EXIT,  0,    0,    "&Screen Setup"},
   { about_proc,         24,   202,  18,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  '?',  D_EXIT,  0,    0,    "?!"},
   { game_setup_proc,    16,   116,  84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'M',  D_EXIT,  0,    0,    "Ga&me Setup"},
   { sound_setup_proc,   16,   96,   84,   16,   GUI_COL_TEXT_1,  GUI_BOX_COL_MIDDLE,  'O',  D_EXIT,  0,    0,    "S&ound Setup"},
   { d_text_proc,        24,   166,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Game:"},
   { d_text_proc,        24,   176,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Screen:"},
   { d_text_proc,        24,   186,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Sound:"},
   { d_text_proc,        24,   196,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    ""},
   { d_bitmap_proc,      268,  213,  32,   8,    0,    0,    0,    0,       0,    0,    NULL},
   { d_text_proc,        64,   166,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    gamename},
   { d_text_proc,        64,   176,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    screenname},
   { d_text_proc,        64,   186,  0,    8,    GUI_COL_TEXT_2,  GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    soundname},
   { d_raine_oxygen_proc,16,   160,  8,    8,    0,    0,    0,    0,       0,    0,    NULL},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

DIALOG load_problem[] =
{
   /* (dialog proc)      (x)  (y)  (w)  (h) (fg) (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_raine_window_proc,  0,   0, 316, 152, GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    "Error Report"},
   { x_raine_button_proc,  8, 128,  32,  16, GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  'O',  D_EXIT,  0,    0,    "&Ok"},
   { d_raine_textbox_proc, 8,  20, 300, 102, GUI_COL_TEXT_1, GUI_BOX_COL_MIDDLE,  0,    0,       0,    0,    NULL},
   { NULL,               0,    0,    0,    0,    0,               0,                   0,    0,       0,    0,    NULL}
};

extern DIALOG file_selector[];
extern DIALOG gfx_mode_dialog[];

DIALOG *raine_dialog_list[] =
{
   about_raine,
   about_game,
   game_select,
   romdir_edit_dialog,
   input_select,
   joy_input_select,
   joy_select,
   auto_select,
   cheatdata_edit_dialog,
   actionreplay_dialog,
   search_main_dialog,
   search_mode_dialog,
   search_type_0a_dialog,
   search_type_0b_dialog,
   search_type_1a_dialog,
   search_type_1b_dialog,
   search_type_2b_dialog,
   search_type_3b_dialog,
   dsw_select,
   language_dialog,
   key_editing,
   joy_key_editing,
   loading_dialog,
   game_setup_dialog,
   sound_setup_dialog,
   control_setup_dialog,
   the_dialog,
   load_problem,
   hex_view_dialog,
   file_selector,
   gfx_mode_dialog,
   NULL,
};

