/******************************************************************************/
/*                                                                            */
/*      INGAME (screen blit, eagle, message list, rdtsc profile, timer)       */
/*                                                                            */
/******************************************************************************/

#include "raine.h"

/*

ingame message list

*/

#ifdef RAINE_DOS
void print_ingame(int showtime, const char *format, ...) __attribute__ ((format (printf, 2, 3)));
#else
void print_ingame(int showtime, const char *format, ...);
#endif
void clear_ingame_message_list(void);

/*

bitmap handling

*/

void SetupScreenBitmap(void);

void BlitScreen(void);

void DestroyScreenBitmap(void);

void ReClipScreen(void);

void clear_game_screen(int pen);

#ifdef TRIPLE_BUFFER

void reset_triple_buffer(void);

#endif

// RDTSC Profiler
// --------------

int use_rdtsc;

enum profile_section
{
   PRO_FRAME = 0,
   PRO_CPU,
   PRO_SOUND,
   PRO_RENDER,
   PRO_BLIT,
   PRO_PAL,
   PRO_FREE,
   PRO_COUNT,			// End marker and list size
};

void ProfileStart(UBYTE mode);
void ProfileStop(UBYTE mode);
void UpdateProfile(void);

void switch_fps_mode(void);
void init_fps(void);

ULONG timer_next_update;	// timer_frame_count at next fps() update
ULONG timer_start_count;	// timer_frame_count at fps() start
ULONG render_start_count;	// render_frame_count at fps() start

ULONG cpu_frame_count;		// number of frames of cpu emulation
ULONG render_frame_count;	// number of frames of video emulation
ULONG skip_frame_count;		// number of frames since last video emulation

void start_ingame_timer(void);
void stop_ingame_timer(void);
ULONG read_ingame_timer(void);
void reset_ingame_timer(void);

void reset_layer_switches(void);
void check_layer_switches(void);
int add_layer_info(char *name);
int check_layer_enabled(int layer);
