/**************************************************************/
/*   M6295 control                                            */
/**************************************************************/

#ifndef __M6295_H__
#define __M6295_H__

#define M6295BF_MAX     (2)
#define M6295BF_CHANNEL (4)
#define M6295BF_NUMBUF  (1)

typedef struct M6295_ROM
{
   UBYTE *data;					// pointer to rom
   ULONG size;					// size of rom
} M6295_ROM;

struct M6295buffer_interface
{
   int num;					// number of chips
   int sample_rate[M6295BF_MAX];		// rate for each chip
   M6295_ROM *rom[M6295BF_MAX];			// list of roms
};

typedef struct M6295_SAMPLE
{
   ULONG len;                  			// length (in samples?)
   WORD *data;                        		// sample data (16 bit?)
} M6295_SAMPLE;

typedef struct M6295_ROM_DECODE
{
   struct M6295_SAMPLE samp[0x80];		// decoded sample list
   unsigned int *decode_table;			// decoded table
   signed short *decode_rom;			// decoded rom
} M6295_ROM_DECODE;

typedef struct m6295rec
{
  int rate;
  int command;
  unsigned int offset[M6295BF_CHANNEL], req_len[M6295BF_CHANNEL];
  signed short *req_buf[M6295BF_CHANNEL];
  unsigned int add;
  int  bank, bankmax;
  M6295_ROM_DECODE *rom_decode;
} M6295Rec;

int M6295buffer_sh_start( struct M6295buffer_interface *interface );
void M6295buffer_sh_stop( void );
void M6295buffer_request( int num, int code );
int  M6295buffer_status( int num );
void M6295buffer_bankswitch( int num, int bank );
void M6295buffer_UpdateOne( int num, void *buffer, int length );

#endif
/**************** end of file ****************/
