/******************************************************************************/
/*                                                                            */
/*                          SAMPLE SUPPORT FOR RAINE                          */
/*                                                                            */
/*                        modified by Hiromitsu Shioya                        */
/*                        change SEAL library 09/20/98                        */
/*                                                                            */
/******************************************************************************/

#include <time.h>
#include <audio.h>
#include "raine.h"
#include "sasound.h"

#include "games.h"

#include <sys/time.h>
typedef long uclock_t;
struct timeval tv;
struct timezone tz;
long uclock(void)
{
	gettimeofday(&tv,&tz);
	return tv.tv_usec;
}
#define UCLOCKS_PER_SEC 1000
#define print_debug printf

/*

dump channels (debug)

*/

//#define DUMP_CHANNELS

#ifdef DUMP_CHANNELS
FILE *stream_out[NUMVOICES];
#endif

/*

mame seal interface. syncs works better, but it is much slower, blame
seal or your pc for this. the sample rate seal streams play at is nearly
always different from the one it *should* be running at.

*/

#define MAME_SOUND

/*
 *  Volume Section
 */

#define VOLUME_MIN	(0)			// Minimum volume
#define VOLUME_MAX	(255)			// Maximum volume

/*
 *  Panning Section
 */

#define PAN_LEFT	(0)			// Left panning
#define PAN_CENTRE	(128)			// Central panning
#define PAN_RIGHT	(255)			// Right panning

/*
 *  Sample Control Section
 */

#define CPU_FPS		(60)			// Frames per second of emulated hardware

/*
 *  Other stuff
 */

#define UPDATE_60_FPS				// Turn off the counting stuff. Emulation
						// speed stays more constant this way.

UBYTE No_FM;				// fm.c control

static int samp_modeb_timer;

SoundRec      *SndMachine = NULL, snd_entry;

/* audio related stuff */

HAC         hVoice[NUMVOICES];
LPAUDIOWAVE lpWave[NUMVOICES];
int         Volumi[NUMVOICES];
int         MasterVolume;
int         playing[NUMVOICES];
int         vchan[NUMVOICES];
int         ventry[NUMVOICES];
int         vbover_err, vbunder_err;
int         *vpan[NUMVOICES];

int         SampleRate;
int         audio_sample_rate;
int         sound_emu_count;

static int reserved_channel = 0;

int sound_stream_mode = SOUND_STREAM_WAIT;

static int stream_buffer_max;

static int pause_sound;

void saCheckPlayStream( void );

/*******************************************************************************************/
/**** osd_??? functions                                                                 ****/
/*******************************************************************************************/
int get_play_channels( int request )
{
  return saGetPlayChannels( request );
}

void reset_play_channels(void)
{
  saResetPlayChannels();
}

#ifndef MAME_SOUND
void osd_play_streamed_sample(int channel,signed char *data,int len,int freq,int volume, int pan){
  if( !sound_stream_mode )  saPlayStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 8, pan );
  else                      saPlayBufferedStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 8, pan );
}

void osd_play_streamed_sample_16(int channel,signed short *data,int len,int freq,int volume, int pan){
  if( !sound_stream_mode )  saPlayStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 16, pan );
  else                      saPlayBufferedStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 16, pan );
}
#endif

void osd_ym2203_update(void)
{
}

/*******************************************************************************************/
/*  streams v35x                                                                           */
/*******************************************************************************************/

#include "streams.c"

/*******************************************************************************************/
/*  sa???Sound                                                                             */
/*******************************************************************************************/
#ifdef MAME_SOUND
#define MIXER_MAX_CHANNELS	NUMVOICES

#define MIXER_PAN_LEFT		PAN_LEFT
#define MIXER_PAN_CENTER	PAN_CENTRE
#define MIXER_PAN_RIGHT		PAN_RIGHT

static FILE *errorlog = NULL;

static int throttle;

void osd_set_mastervolume(int _attenuation);

int osd_get_mastervolume(void);

void osd_sound_enable(int enable_it);

void osd_opl_control(int chip,int reg);

void osd_opl_write(int chip,int data);

#include "sound.c"
#endif
/******************************************/
/*    update sound                        */
/******************************************/
void saUpdateSound( int nowclock )
{
   #ifdef MAME_SOUND

   static uclock_t last,curr;

   if(nowclock){

   streams_sh_update();

   //}
   //else{

	//if (throttle)
	//{
		curr = uclock();
		if ((curr - last) > (2*UCLOCKS_PER_SEC) / CPU_FPS)
			//throttle = 0;
		last = curr;

		msdos_update_audio();

		throttle = 1;
	//}

   //msdos_update_audio();

   }

   #else

   int i;

   if( ! GameSound ) return;
   if( ! RaineSoundCard ) return;
   if( ! audio_sample_rate ) return;
   if( ! SndMachine ) return;

   if( nowclock ){

      streams_sh_update();

#ifdef RAINE_DOS
      if( !sound_stream_mode )
		  AUpdateAudio();
#endif

   }
   else{

      if( sound_stream_mode ){
#ifdef RAINE_DOS
		  AUpdateAudio();
#endif
		  saCheckPlayStream();
      }

   }

   #endif

}

typedef struct SOUND_CHIP
{
   UBYTE *name;			// name
   void (*shutdown)(void);	// stop
} SOUND_CHIP;

static struct SOUND_CHIP sound_chip_list[] =
{
   { "ym2203",     YM2203_sh_stop,        },
   { "ym2151",     YM2151_sh_stop,        },
   { "ym2151",     YM2151_sh_stop,        },
   { "ym2610",     YM2610_sh_stop,        },
   { "ym2610b",    YM2610_sh_stop,        },
   { "msm5205",    MSM5205buffer_sh_stop, },
   { "m6295",      M6295buffer_sh_stop,   },
   { "ay9810",     NULL,                  },
   { "ym3812",     YM3812_sh_stop,        },
   { "sn76496",    NULL,                  },
   { "ym2413",     NULL,                  },
   { "smp16bit",   SMP16buffer_sh_stop,   },
   { "m6585",      M6585buffer_sh_stop,   },
   { "ymz280b",    ymz280b_sh_stop,       },
   { NULL,         NULL,                  },
};

char *get_sound_chip_name(ULONG id)
{
   return sound_chip_list[id].name;
}

int init_sound_emulators(void)
{
   int i,j;

   if(change_sample_rate)
      saStopSoundEmulators();

   change_sample_rate = 0;

   if( SndMachine ){
    if( !SndMachine->first ){
      saInitVolPan();		/* moved. (hiro-shi) */
      SndMachine->first = 1;	/* first flag clear */
      streams_sh_start();	/* streaming system initialize & start */
      pause_sound = 0;		/* pause flag off */
      vbover_err = vbunder_err = 0; /* error initial */
      No_FM = 1;		/* FM DAC mode */
      for( j = 0; j < SndMachine->control_max; j++ ){
	switch( SndMachine->init[j] ){
	case SOUND_YM2203:
	  i = YM2203_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_YM2151S:
	  i = YM2151_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_YM2151J:
	  i = YM2151_ALT_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_YM2610:
	  i = YM2610_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_YM2610B:
	  i = YM2610B_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_MSM5205:
	  i = MSM5205buffer_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_M6295:
	  i = M6295buffer_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_PSG:
	  i = AY8910_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_YM3812:
	  i = YM3812_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_SMP16:
	  i = SMP16buffer_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_M6585:
	  i = M6585buffer_sh_start( SndMachine->intf[j] );
	break;
	case SOUND_YMZ280B:
	  i = ymz280b_sh_start( SndMachine->intf[j] );
	break;
	default:
	  i = 1;
	break;
	}
	if( i ){
	  audio_sample_rate = 0;
	  SndMachine = NULL;
	  return 1;
	}
      }
    }
  }
  return 0;
}

#ifdef MAME_SOUND

int new_init_sound(int card)
{
   soundcard = card;

   if(msdos_init_seal()){		// 0 = OK
      print_debug("seal_init_error\n");
      return 1;
   }

   if(msdos_init_sound()){		// 0 = OK
      print_debug("sound_init_error\n");
      return 1;
   }

   if(init_sound_emulators()){		// 0 = OK
      print_debug("sound_emu_init_error\n");
      return 1;
   }

   return 0;
}

BOOL saInitSoundCard( int soundcard, int buffer_mode, int sample_rate )
{
   if(!new_init_sound(soundcard)){
      print_debug("mame_sound_init = ok\n");
      return TRUE;
   }
   else{
      print_debug("mame_sound_init = error\n");
      return FALSE;
   }
}


#else
/******************************************/
/*    setup sound                         */
/******************************************/
BOOL saInitSoundCard( int soundcard, int buffer_mode, int sample_rate )
{
   AUDIOINFO audio_info;
   AUDIOCAPS audio_caps;

   int i;
   char s[32];


   if( AInitialize() != AUDIO_ERROR_NONE ){
      #ifdef HACKS
      print_debug("saInitSoundCard(): Seal failed to initialize\n");
      #endif
      audio_sample_rate = 0;
      return FALSE;
   }

   if( soundcard <= 0 ){		// no soundcard (not going to autodetect)
      #ifdef HACKS
      print_debug("saInitSoundCard(): OK [No Card]\n");
      #endif
      audio_sample_rate = 0;
      return TRUE;
   }

   // Set card id

   audio_info.nDeviceId = soundcard;

   // 16 bit only

   audio_info.wFormat = AUDIO_FORMAT_16BITS | AUDIO_FORMAT_STEREO;

   // Seal is crap, it clicks, it's slow, it's bugged (why are we ever using it?)

   if(audio_sample_rate>44098)
   audio_sample_rate = 44098;

   // Sample Rate

   audio_info.nSampleRate = audio_sample_rate;

   // Open audio

   if( AOpenAudio(&audio_info) != AUDIO_ERROR_NONE ){
      #ifdef HACKS
      print_debug("saInitSoundCard(): Audio Initialization Failed!\n");
      #endif
      audio_sample_rate = 0;
      return FALSE;
   }

   // Find out what seal chose for us

   AGetAudioDevCaps( audio_info.nDeviceId, &audio_caps );
   //#ifdef HACKS
   print_debug(
      "Sound - '%s' %d-bit %s %u Hz\n",
      audio_caps.szProductName,
      audio_info.wFormat & AUDIO_FORMAT_16BITS ? 16 : 8,
      audio_info.wFormat & AUDIO_FORMAT_STEREO ? "stereo" : "mono",
      audio_info.nSampleRate
   );
   //#endif

   // Update sample rate (incase seal chose a different one)
/*
   if(audio_info.nSampleRate != audio_sample_rate)
      audio_sample_rate = audio_info.nSampleRate;
*/
   // Open and allocate voices, allocate waveforms

   if( AOpenVoices(NUMVOICES) != AUDIO_ERROR_NONE ){
      #ifdef HACKS
      print_debug("saInitSoundCard(): Voice Initialization Failed\n");
      #endif
      audio_sample_rate = 0;
      return FALSE;
   }

   for( i = 0; i < NUMVOICES; i++ ){
      if( ACreateAudioVoice(&hVoice[i]) != AUDIO_ERROR_NONE ){
          #ifdef HACKS
	  print_debug("saInitSoundCard(): Voice %d Creation Failed\n",i);
          #endif
	  audio_sample_rate = 0;
	  return FALSE;
      }
      ASetVoicePanning( hVoice[i], PAN_CENTRE );

      lpWave[i]  = 0;
      playing[i] = 0;

      #ifdef DUMP_CHANNELS
      sprintf(s,"stream%02d.raw",i);
      stream_out[i] = fopen(s,"wb");
      #endif
   }

   #ifdef RAINE_DOS
   AUpdateAudio();
   #endif

   #ifdef HACKS
   print_debug("saInitSoundCard(): SEAL initialize OK\n");
   #endif

   /**** stream buffer mode ****/
   sound_stream_mode = buffer_mode;
   if( !sound_stream_mode )  stream_buffer_max = STREAM_BUFFER_MAXA;
   else                      stream_buffer_max = STREAM_BUFFER_MAXB;
   samp_modeb_timer = 0;

   MasterVolume = 100;
   //reserved_channel = 0;

   if(!init_sound_emulators())
      return FALSE;

   return TRUE;
}
#endif

/*********************************************************************/
/* stop sound emulators: this is needed for when sample rate changes */
/*********************************************************************/
void saStopSoundEmulators(void)
{
   int i;

   #ifdef HACKS
   print_debug("saStopSoundEmulators(): Removing Sound Emulators\n");
   #endif

   saResetPlayChannels();

   if( SndMachine == NULL ){
      SndMachine = &snd_entry;
   }
   else{
      if(SndMachine->first!=0){		// YM3812 fix crashes
         streams_sh_stop();
            for( i = 0; i < SndMachine->control_max; i++ ){

               if( sound_chip_list[SndMachine->init[i]].shutdown )
                  sound_chip_list[SndMachine->init[i]].shutdown();
            }
         SndMachine->first           = 0;
      }
   }

   #ifdef HACKS
   print_debug("saStopSoundEmulators(): OK\n");
   #endif
}

/******************************************/
/*    setup sound                         */
/******************************************/

void init_sound_list(void)
{
   SOUND_INFO *sound_src;
   int ta;

   sound_src = current_game->sound_list;

   if(sound_src){

   saStopSoundEmulators();

   for( ta = 0; ta < SND_CONTROL_MAX; ta++ ){
      SndMachine->init[ta] = SOUND_NONE;
      SndMachine->intf[ta] = NULL;
   }

   SndMachine->first = 0;
   SndMachine->control_max = 0;

   ta = 0;

   while(sound_src[ta].interface){

   SndMachine->init[ta] = sound_src[ta].type;
   SndMachine->intf[ta] = sound_src[ta].interface;

   ta++;

   }

   SndMachine->control_max = ta;

   GameSound = 1;

   }
}

/******************************************/
/*    destroy sound                       */
/******************************************/

void saDestroyChannel( int chan )
{
   if( lpWave[chan] ){
      AStopVoice( hVoice[chan] );
      ADestroyAudioData( lpWave[chan] );
      free( lpWave[chan] );
      free( vpan[chan] );
      lpWave[chan] = 0;
      playing[chan] = 0;
      vpan[chan] = 0;
   }
}

void saDestroySound( int remove_all_resources )
{
   int i;

   #ifdef HACKS
   print_debug("saDestroySound: Removing SEAL\n");
   #endif

   pause_raine_ym3812();

   if(remove_all_resources) saStopSoundEmulators();

   for( i = 0; i < NUMVOICES; i++ ){
      saDestroyChannel( i );
      ADestroyAudioVoice( hVoice[i] );

      #ifdef DUMP_CHANNELS
      fclose(stream_out[i]);
      #endif

   }
   ACloseVoices();
   ACloseAudio();

   //SndMachine = NULL;
   #ifdef HACKS
   print_debug("saDestroySound: OK\n");
   #endif
}

void sa_pause_sound(void)
{
   int i;

   pause_sound      = 1;
   samp_modeb_timer = 0;
   vbover_err       = 0;
   vbunder_err      = 0;

   pause_raine_ym3812();
   for( i = 0; i < NUMVOICES; i++ ){
      saDestroyChannel( i );
   }
}

void sa_unpause_sound(void)
{
   pause_sound      = 0;
}

/******************************************/
/*    buffer check                        */
/******************************************/
void saCheckPlayStream( void )
{
   int i, len, rlen;
   DWORD pos;
   int vp, ve;

   if( !pause_sound ){

      samp_modeb_timer = (samp_modeb_timer+1) % MODEB_FRAME_SIZE;	// <60> res = [0..59]

      vp = samp_modeb_timer / MODEB_UPDATE_COUNT;			// <3>  res = [0..19]

      for( i = 0; i < NUMVOICES; i++ ){					// ***** SCAN VOICES

         if( playing[i] ){						// ***** PROCESS ENABLED VOICE

	    ve = ventry[i] % MODEB_MASK;				// <60/3=20> res = [0..19]
	
	    if( vp == ve ){						// ***** PROCESS ENABLED STREAM VOICE

	       /**** buffer update check ****/
	       AGetVoicePosition( hVoice[i], &pos );
	       len = (lpWave[i]->dwLength / stream_buffer_max) * MODEB_UPDATE_COUNT;	// length of <3> buffers
	       rlen = len * vp;								// buffer point where sample should go

	       if( (pos < rlen) || (pos >= (rlen+len)) ){		// Make sure it is not playing this buffer right now

	          /**** check play buffer/write buffer position ****/
	          ve = (ventry[i] + 1) * MODEB_UPDATE_COUNT;		// 

	          /*if( (vchan[i] - ve) > 0 ){*/
	          /*if( (vchan[i] - ve) > -MODEB_UPDATE_COUNT ){*/

	          if( ((vchan[i] - ve) > (0-MODEB_UPDATE_COUNT)) && (vbunder_err < (MODEB_ERROR_MAX*2))){

	             if( (vchan[i] - ve) < 0 )  vbunder_err++;
	             else{
		        if( vbunder_err >= 0 )  vbunder_err--;
	             }
	             /**** all buffer update (not overrun) ****/
                     for( i = 0; i < NUMVOICES; i++ ){
		        if( playing[i] ){
		           vbover_err = 0;
		           ASetVoicePanning( hVoice[i], (UINT)*(vpan[i] + samp_modeb_timer) );
		           ventry[i]++;

     			   #ifdef DUMP_CHANNELS
		           //len  = (lpWave[i]->dwLength / stream_buffer_max) * MODEB_UPDATE_COUNT;
		           //rlen = len * vp;
      			   //fwrite( (((UBYTE *) (lpWave[i]->lpData))+rlen), 1, len, stream_out[i]);
      			   if(vp==0) fwrite( lpWave[i]->lpData, 1, lpWave[i]->dwLength, stream_out[i]);
      			   #endif

		        }
	             }

	          }
                  else{

                     #ifdef HACKS
	             print_ingame(120,"Now buf-p[over] %08x %08x", vchan[i], ve );
                     #endif
	             /**** all buffer update (over run) ****/
                     for( i = 0; i < NUMVOICES; i++ ){
		        if( playing[i] ){
		           //AStopVoice( hVoice[i] );
		           vbunder_err = 0;
		           vbover_err = 0;
		           len  = (lpWave[i]->dwLength / stream_buffer_max) * MODEB_UPDATE_COUNT;
		           rlen = len * vp;
		           //AWriteAudioData( lpWave[i], rlen, len );
		           //APlayVoice( hVoice[i], lpWave[i] );
		           ASetVoicePanning( hVoice[i], (UINT)*(vpan[i] + samp_modeb_timer) );
		           vchan[i] = (ventry[i] + 1) * MODEB_UPDATE_COUNT;
		           ventry[i]++;
		        }
	             }

	          }
	          return;		// Completed
	       }
               else{			// ERROR: Required buffer was being played

	          vbover_err++;		/* error count */
	          //print_ingame(120,"ve:%08x, vc:%08x, verr:%08x", ventry[0]*MODEB_UPDATE_COUNT, vchan[0], vbover_err );
	          if( vbover_err >= MODEB_ERROR_MAX ){
	             /**** all buffer restart ****/
	             vbover_err       = 0;
	             vbunder_err      = 0;
	             samp_modeb_timer = 0;

                     for( i = 0; i < NUMVOICES; i++ ){
                        #if 0
		        ventry[i] = 1;
		        vchan[i] = MODEB_UPDATE_COUNT;
                        #else
		        saDestroyChannel( i );
                        #endif
	             }

                     #ifdef HACKS
	             print_ingame(60,"Buffer stop: Restarting streams.");
                     #endif
	          }
	          return;		// Completed

	       }
	       /**** pos check end ****/
	    }			// ***** END PROCESS ENABLED STREAM VOICE
         }			// ***** END PROCESS ENABLED VOICE
      }				// ***** END SCAN VOICES
   }				// ***** END PLAY SOUND
}

/*******************************************************************************************/
/*******************************************************************************************/
/******************************************/
/*    play samples                        */
/******************************************/
void saPlayBufferedStreamedSampleBase( int channel, signed char *data, int len, int freq, int volume, int bits , int pan ){
  int i;
  if( audio_sample_rate == 0 || channel >= NUMVOICES )  return;
  if( SndMachine == NULL )  return;
  if( !playing[channel] ){
    if( lpWave[channel] ){
      AStopVoice( hVoice[channel] );
      ADestroyAudioData( lpWave[channel] );
      free( lpWave[channel] );
      lpWave[channel] = 0;
    }
    if( (lpWave[channel] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE))) == 0 )  return;
    if( (vpan[channel] = (int *)malloc(sizeof(int)*stream_buffer_max)) == NULL )  return;

    lpWave[channel]->wFormat     = (bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) | AUDIO_FORMAT_STEREO | AUDIO_FORMAT_LOOP;
    lpWave[channel]->nSampleRate = audio_sample_rate;
    lpWave[channel]->dwLength    = stream_buffer_max*len;
    lpWave[channel]->dwLoopStart = 0;
    lpWave[channel]->dwLoopEnd   = stream_buffer_max*len;
    if( ACreateAudioData(lpWave[channel]) != AUDIO_ERROR_NONE ){
      free( lpWave[channel] );
      free( vpan[channel] );
      lpWave[channel] = 0;
      vpan[channel] = 0;
      return;
    }
    memset( lpWave[channel]->lpData, 0, stream_buffer_max*len );
    APlayVoice( hVoice[channel], lpWave[channel] );
    ASetVoiceFrequency( hVoice[channel], freq );
    ASetVoiceVolume( hVoice[channel], MasterVolume*volume/400 );
    ASetVoicePanning( hVoice[channel], (UINT)pan );
    playing[channel] = 1;	/* use front surface */
    /**** make sound temp. buffer ****/
    vchan[channel] = MODEB_UPDATE_COUNT;
    memcpy( &lpWave[channel]->lpData[len * MODEB_UPDATE_COUNT], data, len );
    for( i = 0; i <= MODEB_UPDATE_COUNT; i++ ){
      *(vpan[channel] + i) = pan;
    }
    vchan[channel]++;
    ventry[channel] = 1;
  } else{
    int s_pos = vchan[channel]%stream_buffer_max;
    memcpy( &lpWave[channel]->lpData[len * s_pos], data, len );
    *(vpan[channel] + s_pos) = pan;
    vchan[channel]++;
  }
  Volumi[channel] = volume/4;
}

/******************************************/
/*    play samples                        */
/******************************************/
void saPlayStreamedSampleBase( int channel, signed char *data, int len, int freq, int volume, int bits , int pan ){
  if( audio_sample_rate == 0 || channel >= NUMVOICES )  return;
  if( SndMachine == NULL )  return;
  if( !playing[channel] ){
    if( lpWave[channel] ){
      AStopVoice( hVoice[channel] );
      ADestroyAudioData( lpWave[channel] );
      free( lpWave[channel] );
      lpWave[channel] = 0;
    }
    if( (lpWave[channel] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE))) == 0 )  return;

    lpWave[channel]->wFormat = (bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) | AUDIO_FORMAT_STEREO | AUDIO_FORMAT_LOOP;
    lpWave[channel]->nSampleRate = audio_sample_rate;
    lpWave[channel]->dwLength = stream_buffer_max*len;
    lpWave[channel]->dwLoopStart = 0;
    lpWave[channel]->dwLoopEnd = stream_buffer_max*len;
    if( ACreateAudioData(lpWave[channel]) != AUDIO_ERROR_NONE ){
      free( lpWave[channel] );
      lpWave[channel] = 0;
      return;
    }
    memset(lpWave[channel]->lpData,0,stream_buffer_max*len);
    memcpy(lpWave[channel]->lpData,data,len);
    /* upload the data to the audio DRAM local memory */
    AWriteAudioData(lpWave[channel],0,stream_buffer_max*len);
    APlayVoice(hVoice[channel],lpWave[channel]);
    ASetVoiceFrequency(hVoice[channel],freq);
    ASetVoiceVolume(hVoice[channel],MasterVolume*volume/400);
    ASetVoicePanning(hVoice[channel], (UINT)pan );
    playing[channel] = 1;	/* use front surface */
    vchan[channel] = 1;
    ventry[channel] = 1;

    //print_debug("first stream entry. [%d:%d:%d:%d]\n", channel, len, freq, volume );
  } else{
    DWORD pos;
#if 0
    int nownum = vchan[channel]%STREAM_BUFFER_MAXA;
    for(;;){
#ifdef RAINE_DOS
      AUpdateAudio();
#endif
      AGetVoicePosition(hVoice[channel],&pos);
      
      if( !nownum && pos >= len )  break;
      if( nownum == (stream_buffer_max-1) ){
	if( pos < (len*nownum) )  break;
      } else{
	if( (pos < len*(nownum) || pos >= (len*(nownum+1))) )  break;
      }
      /*
      if ((vchan[channel]%STREAM_BUFFER_MAXA) == 0 && pos >= len) break;
      if ((vchan[channel]%STREAM_BUFFER_MAXA) == 1 && (pos < len || pos >= (2*len))) break;
      if ((vchan[channel]%STREAM_BUFFER_MAXA) == 2 && pos < (2*len)) break;
      */
    }
#else
    AGetVoicePosition(hVoice[channel],&pos);
#ifdef RAINE_DOS
    AUpdateAudio();
#endif
#endif

    memcpy( &lpWave[channel]->lpData[len * (vchan[channel]%STREAM_BUFFER_MAXA)], data, len );
    AWriteAudioData( lpWave[channel], len*(vchan[channel]%STREAM_BUFFER_MAXA), len );
    vchan[channel]++;
    //print_debug("next stream entry. [%d:%d:%d:%d::%d]\n", channel, len, freq, volume, pos );
  }
  Volumi[channel] = volume/4;
}

/******************************************************************************/
/*                                                                            */
/*                        SOUND CHANNEL ALLOCATION                            */
/*                                                                            */
/******************************************************************************/

int saGetPlayChannels( int request )
{
   int ret_value = reserved_channel;
   reserved_channel += request;
   return ret_value;
}

void saResetPlayChannels( void )
{
   reserved_channel = 0;
}

/******************************************************************************/
/*                                                                            */
/*                          SOUND CARD INFORMATION                            */
/*                                                                            */
/******************************************************************************/

char *sound_card_name( int num )
{
   static char *sound_name_list[] =
   {
      "Silence",
#ifdef __linux__
      "Linux OSS",
#else
      "Sound Blaster",
      "Sound Blaster AWE32",
      "Pro Audio Spectrum",
      "Ultrasound Max (CS4231)",
      "Ultrasound",
      "Windows Sound System",
      "Ensoniq Soundscape",
#endif
   };

   return sound_name_list[num];
}

/******************************************************************************/
/*                                                                            */
/*                        VOLUME / PANNING CONTROL                            */
/*                                                                            */
/******************************************************************************/

void saInitVolPan( void )
{
   int i;

   for( i = 0; i < MAX_STREAM_CHANNELS; i++ ){
      SampleVol[i] = VOLUME_MAX;
      SamplePan[i] = PAN_CENTRE;
   }
}

void saSetVolume( int num, int data )
{
   SampleVol[num] = data <= VOLUME_MAX ? data : VOLUME_MAX;
}

void saSetPan( int num, int data )
{
   SamplePan[num] = data;
}

void saSetPanMulti( int num, int data )
{
   int  i;

   for( i = 0; i < stream_joined_channels[num]; i++ )
      SamplePan[num + i] = data;
}

/******************************* END OF FILE **********************************/
