/******************************************************************************/
/*                                                                            */
/*     16-BIT SAMPLE PLAYBACK (odd samples - nichibutsu dac, cabal adpcm)     */
/*                                                                            */
/******************************************************************************/

#ifndef __SMP16_H__
#define __SMP16_H__

void decode_sample_adpcm(UBYTE *src, ULONG size, UWORD *dest, int volume);
void decode_sample_8bit(UBYTE *src, ULONG size, UWORD *dest, int volume);

#define SMP16BF_MAX     (2)
#define SMP16BF_CHANNEL (1)
#define SMP16BF_NUMBUF  (1)

typedef struct SMP16_ROM
{
   UBYTE *data;					// pointer to rom
   ULONG size;					// size of rom
   ULONG type;					// 0 - adpcm
} SMP16_ROM;

struct SMP16buffer_interface
{
   int num;					// number of chips
   int sample_rate[SMP16BF_MAX];		// rate for each chip
   SMP16_ROM *rom[SMP16BF_MAX];			// list of roms
};

typedef struct SMP16_SAMPLE
{
   ULONG len;                  			// length (in samples?)
   WORD *data;                        		// sample data (16 bit?)
} SMP16_SAMPLE;

typedef struct SMP16rec
{
  int rate;					// rate
  int command;
  unsigned int offset, req_len;
  signed short *req_buf;
  unsigned int add;
  ULONG samples;				// sample count
  SMP16_SAMPLE *sample_decode;			// decoded info
} SMP16Rec;

int SMP16buffer_sh_start( struct SMP16buffer_interface *interface );
void SMP16buffer_sh_stop( void );
void SMP16buffer_request( int num, int code );
int  SMP16buffer_status( int num );
void SMP16buffer_UpdateOne( int num, void *buffer, int length );

#endif

/******************************************************************************/
