/******************************************************************************/
/*                                                                            */
/*            YAMAHA YMZ280B - PCMD8 - 8 CHANNEL PCM/ADPCM DECODER            */
/*                                                                            */
/******************************************************************************/

#ifndef __YMZ280B_H__
#define __YMZ280B_H__

#define YMZ280B_MAX     (1)
#define YMZ280B_CHANNEL (1)
#define YMZ280B_NUMBUF  (1)

typedef struct ymz280b_ROM
{
   UBYTE *data;					// pointer to rom
   ULONG size;					// size of rom
} ymz280b_ROM;

struct ymz280b_interface
{
   ULONG num;					// number of chips
   ULONG sample_rate[YMZ280B_MAX];		// rate for each chip
   ymz280b_ROM *rom[YMZ280B_MAX];			// list of roms
};

typedef struct ymz280b_SAMPLE
{
   ULONG len;                  			// length (in samples?)
   UBYTE *data;                        		// sample data (16 bit?)
} ymz280b_SAMPLE;

typedef struct ymz280brec
{
   ULONG rate;					// rate
   ULONG offset, req_len;
   UBYTE *req_buf;
   UBYTE command[8];
   ULONG add;
   ULONG banks;					// sample bank count
   ULONG current_bank;				// current sample bank
   ymz280b_SAMPLE *sample_decode;			// decoded info
} ymz280bRec;

int  ymz280b_sh_start(struct ymz280b_interface *interface);
void ymz280b_sh_stop(void);
void ymz280b_bank_write(int num, int bank);
void ymz280b_request(int num, int offset, int data);
int  ymz280b_status(int num);
void ymz280b_UpdateOne(int num, void *buffer, int length);

#endif

/******************************************************************************/
