/******************************************************************************/
/*                                                                            */
/*                            RAINE TILE DRAWING                              */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

#include "spr8x8.h"
#include "spr16x8.h"
#include "spr16x16.h"

#include "spp8x8.h"

#include "str6x8.h"

typedef void text_func(UBYTE *STR, int x, int y, ULONG cmap);
extern text_func *textout_fast;

typedef void draw_mapped_zoom_xy_func(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
typedef void draw_mapped_func(UBYTE *SPR, int x, int y, UBYTE *cmap);
typedef void draw_func(UBYTE *SPR, int x, int y, UBYTE cmap);

/***************************************/

extern draw_func *Draw8x8_Flip_Rot[4];

#define Draw8x8_flip_Rot(a, b, c, d, e) (*Draw8x8_Flip_Rot[e])(a, b, c, d)

#define Draw8x8_Rot(a, b, c, d)        (*Draw8x8_Flip_Rot[0])(a, b, c, d)
#define Draw8x8_FlipY_Rot(a, b, c, d)  (*Draw8x8_Flip_Rot[1])(a, b, c, d)
#define Draw8x8_FlipX_Rot(a, b, c, d)  (*Draw8x8_Flip_Rot[2])(a, b, c, d)
#define Draw8x8_FlipXY_Rot(a, b, c, d) (*Draw8x8_Flip_Rot[3])(a, b, c, d)

extern draw_func *Draw8x8_Trans_Flip_Rot[4];

#define Draw8x8_Trans_flip_Rot(a, b, c, d, e) (*Draw8x8_Trans_Flip_Rot[e])(a, b, c, d)

#define Draw8x8_Trans_Rot(a, b, c, d)        (*Draw8x8_Trans_Flip_Rot[0])(a, b, c, d)
#define Draw8x8_Trans_FlipY_Rot(a, b, c, d)  (*Draw8x8_Trans_Flip_Rot[1])(a, b, c, d)
#define Draw8x8_Trans_FlipX_Rot(a, b, c, d)  (*Draw8x8_Trans_Flip_Rot[2])(a, b, c, d)
#define Draw8x8_Trans_FlipXY_Rot(a, b, c, d) (*Draw8x8_Trans_Flip_Rot[3])(a, b, c, d)


extern draw_mapped_func *Draw8x8_Mapped_Flip_Rot[4];

#define Draw8x8_Mapped_flip_Rot(a, b, c, d, e) (*Draw8x8_Mapped_Flip_Rot[e])(a, b, c, d)

#define Draw8x8_Mapped_Rot(a, b, c, d)        (*Draw8x8_Mapped_Flip_Rot[0])(a, b, c, d)
#define Draw8x8_Mapped_FlipY_Rot(a, b, c, d)  (*Draw8x8_Mapped_Flip_Rot[1])(a, b, c, d)
#define Draw8x8_Mapped_FlipX_Rot(a, b, c, d)  (*Draw8x8_Mapped_Flip_Rot[2])(a, b, c, d)
#define Draw8x8_Mapped_FlipXY_Rot(a, b, c, d) (*Draw8x8_Mapped_Flip_Rot[3])(a, b, c, d)

extern draw_mapped_func *Draw8x8_Trans_Mapped_Flip_Rot[4];

#define Draw8x8_Trans_Mapped_flip_Rot(a, b, c, d, e) (*Draw8x8_Trans_Mapped_Flip_Rot[e])(a, b, c, d)

#define Draw8x8_Trans_Mapped_Rot(a, b, c, d)        (*Draw8x8_Trans_Mapped_Flip_Rot[0])(a, b, c, d)
#define Draw8x8_Trans_Mapped_FlipY_Rot(a, b, c, d)  (*Draw8x8_Trans_Mapped_Flip_Rot[1])(a, b, c, d)
#define Draw8x8_Trans_Mapped_FlipX_Rot(a, b, c, d)  (*Draw8x8_Trans_Mapped_Flip_Rot[2])(a, b, c, d)
#define Draw8x8_Trans_Mapped_FlipXY_Rot(a, b, c, d) (*Draw8x8_Trans_Mapped_Flip_Rot[3])(a, b, c, d)


extern draw_mapped_func *Draw16x16_Mapped_Flip_Rot[4];

#define Draw16x16_Mapped_flip_Rot(a, b, c, d, e) (*Draw16x16_Mapped_Flip_Rot[e])(a, b, c, d)

#define Draw16x16_Mapped_Rot(a, b, c, d)        (*Draw16x16_Mapped_Flip_Rot[0])(a, b, c, d)
#define Draw16x16_Mapped_FlipY_Rot(a, b, c, d)  (*Draw16x16_Mapped_Flip_Rot[1])(a, b, c, d)
#define Draw16x16_Mapped_FlipX_Rot(a, b, c, d)  (*Draw16x16_Mapped_Flip_Rot[2])(a, b, c, d)
#define Draw16x16_Mapped_FlipXY_Rot(a, b, c, d) (*Draw16x16_Mapped_Flip_Rot[3])(a, b, c, d)

extern draw_mapped_func *Draw16x16_Trans_Mapped_Flip_Rot[4];

#define Draw16x16_Trans_Mapped_flip_Rot(a, b, c, d, e) (*Draw16x16_Trans_Mapped_Flip_Rot[e])(a, b, c, d)

#define Draw16x16_Trans_Mapped_Rot(a, b, c, d)        (*Draw16x16_Trans_Mapped_Flip_Rot[0])(a, b, c, d)
#define Draw16x16_Trans_Mapped_FlipY_Rot(a, b, c, d)  (*Draw16x16_Trans_Mapped_Flip_Rot[1])(a, b, c, d)
#define Draw16x16_Trans_Mapped_FlipX_Rot(a, b, c, d)  (*Draw16x16_Trans_Mapped_Flip_Rot[2])(a, b, c, d)
#define Draw16x16_Trans_Mapped_FlipXY_Rot(a, b, c, d) (*Draw16x16_Trans_Mapped_Flip_Rot[3])(a, b, c, d)


extern draw_mapped_zoom_xy_func *Draw16x16_Mapped_ZoomXY_Flip_Rot[4];

#define Draw16x16_Mapped_ZoomXY_flip_Rot(a, b, c, d, e, f, g) (*Draw16x16_Mapped_ZoomXY_Flip_Rot[g])(a, b, c, d, e, f)

#define Draw16x16_Mapped_ZoomXY_Rot(a, b, c, d, e, f)        (*Draw16x16_Mapped_ZoomXY_Flip_Rot[0])(a, b, c, d, e, f)
#define Draw16x16_Mapped_ZoomXY_FlipY_Rot(a, b, c, d, e, f)  (*Draw16x16_Mapped_ZoomXY_Flip_Rot[1])(a, b, c, d, e, f)
#define Draw16x16_Mapped_ZoomXY_FlipX_Rot(a, b, c, d, e, f)  (*Draw16x16_Mapped_ZoomXY_Flip_Rot[2])(a, b, c, d, e, f)
#define Draw16x16_Mapped_ZoomXY_FlipXY_Rot(a, b, c, d, e, f) (*Draw16x16_Mapped_ZoomXY_Flip_Rot[3])(a, b, c, d, e, f)

extern draw_mapped_zoom_xy_func *Draw16x16_Trans_Mapped_ZoomXY_Flip_Rot[4];

#define Draw16x16_Trans_Mapped_ZoomXY_flip_Rot(a, b, c, d, e, f, g) (*Draw16x16_Trans_Mapped_ZoomXY_Flip_Rot[g])(a, b, c, d, e, f)

#define Draw16x16_Trans_Mapped_ZoomXY_Rot(a, b, c, d, e, f)        (*Draw16x16_Trans_Mapped_ZoomXY_Flip_Rot[0])(a, b, c, d, e, f)
#define Draw16x16_Trans_Mapped_ZoomXY_FlipY_Rot(a, b, c, d, e, f)  (*Draw16x16_Trans_Mapped_ZoomXY_Flip_Rot[1])(a, b, c, d, e, f)
#define Draw16x16_Trans_Mapped_ZoomXY_FlipX_Rot(a, b, c, d, e, f)  (*Draw16x16_Trans_Mapped_ZoomXY_Flip_Rot[2])(a, b, c, d, e, f)
#define Draw16x16_Trans_Mapped_ZoomXY_FlipXY_Rot(a, b, c, d, e, f) (*Draw16x16_Trans_Mapped_ZoomXY_Flip_Rot[3])(a, b, c, d, e, f)

// 64x64 Mapped Sprites

void Draw64x64_Mapped(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw64x64_Mapped_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw64x64_Mapped_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw64x64_Mapped_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

// 64x64 Transparent Mapped Sprites

void Draw64x64_Trans_Mapped(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw64x64_Trans_Mapped_FlipY(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw64x64_Trans_Mapped_FlipX(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw64x64_Trans_Mapped_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap);

void Draw16x16_Part8x8_Trans_Mapped(UBYTE *SPR, int x, int y, UBYTE *cmap);

// Specially for F3 System (pixel layer)

void Draw8xH_Trans_Packed_Mapped_Column(UBYTE *SPR, int x, int y, int height, UBYTE *cmap);
void Draw8xH_Trans_Packed_Mapped_FlipY_Column(UBYTE *SPR, int x, int y, int height, UBYTE *cmap);

// Draw Flipping Jumptables

extern draw_mapped_func *Draw16x16_Mapped_JumpList[];
extern draw_mapped_func *Draw16x16_Mapped_JumpListR[];

extern draw_mapped_func *Draw16x16_Mapped_JumpList_test[];
extern draw_mapped_func *Draw16x16_Trans_Mapped_JumpList_test[];

extern draw_mapped_func *Draw16x16_Trans_Mapped_JumpList[];
extern draw_mapped_func *Draw16x16_Trans_Mapped_JumpListR[];

extern draw_mapped_func *Zoom64x64_Trans_Mapped_JumpList[];

void Draw16x16_Trans_Mapped_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_FlipY_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_FlipX_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Trans_Mapped_FlipXY_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);

void Draw16x16_Mapped_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_FlipY_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_FlipX_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);
void Draw16x16_Mapped_FlipXY_4bpp(UBYTE *SPR, int x, int y, UBYTE *cmap);

void init_video_core(void);
