/******************************************************************************/
/*                                                                            */
/*                          RAINE 16x16 TILE ZOOMING                          */
/*                                                                            */
/******************************************************************************/

#include "deftypes.h"

// These ones can zoom from x/y = [0..16] (ie. max size is normal: 16x16)

void init_16x16_zoom(void);
UBYTE *make_16x16_zoom_ofs_type1(void);
UBYTE *make_16x16_zoom_ofs_type1z(void);
UBYTE *make_16x16_zoom_ofs_type1zz(void);

void Draw16x16_Trans_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_Trans_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_Trans_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_Trans_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);

void Draw16x16_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);

void Draw16x16_Trans_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);
void Draw16x16_Trans_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);
void Draw16x16_Trans_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);
void Draw16x16_Trans_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);

void Draw16x16_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);
void Draw16x16_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);
void Draw16x16_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);
void Draw16x16_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE cmap, int zoom_x, int zoom_y);

// These ones can zoom from x/y = [0..32] (ie. max size is double: 32x32)

void init_16x16_zoom_32(void);
UBYTE *make_16x16_zoom_ofs_type2(void);

void Draw16x16_32_Trans_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_32_Trans_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_32_Trans_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_32_Trans_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);

void Draw16x16_32_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_32_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_32_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_32_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);

// These ones can zoom from x/y = [0..32] (ie. max size is quaruple: 32x32)

void init_16x16_zoom_64(void);
UBYTE *make_16x16_zoom_ofs_type3(void);

void Draw16x16_64_Trans_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_64_Trans_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_64_Trans_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_64_Trans_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);

void Draw16x16_64_Mapped_ZoomXY       (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_64_Mapped_ZoomXY_FlipY (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_64_Mapped_ZoomXY_FlipX (UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
void Draw16x16_64_Mapped_ZoomXY_FlipXY(UBYTE *SPR, int x, int y, UBYTE *cmap, int zoom_x, int zoom_y);
