/******************************************************************************/
/*                                                                            */
/*                          RAINE INTERFACE FOR MZ80                          */
/*                                                                            */
/******************************************************************************/

//#define MZ80_V3

#include "deftypes.h"
#ifdef MZ80_V3
#include "mz8030.h"
#else
#include "mz80.h"
#endif

#define MAX_Z80		(4)
#define MAX_Z80_DATA	(32)
#define MAX_Z80_PORT	(16)

struct mz80context	Z80_context[MAX_Z80];

struct MemoryReadByte	Z80_memory_rb[MAX_Z80][MAX_Z80_DATA];
struct MemoryWriteByte	Z80_memory_wb[MAX_Z80][MAX_Z80_DATA];
struct z80PortRead	Z80_port_rb[MAX_Z80][MAX_Z80_PORT];
struct z80PortWrite	Z80_port_wb[MAX_Z80][MAX_Z80_PORT];

void AddZ80AROMBase(UBYTE *d0, UWORD d1, UWORD d2);

void AddZ80AReadByte( ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80AWriteByte(ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80AReadPort( UWORD d0, UWORD d1, void *d2, UBYTE *d3);
void AddZ80AWritePort(UWORD d0, UWORD d1, void *d2, UBYTE *d3);

void AddZ80AInit(void);

void AddZ80BROMBase(UBYTE *d0, UWORD d1, UWORD d2);

void AddZ80BReadByte( ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80BWriteByte(ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80BReadPort( UWORD d0, UWORD d1, void *d2, UBYTE *d3);
void AddZ80BWritePort(UWORD d0, UWORD d1, void *d2, UBYTE *d3);

void AddZ80BInit(void);

void AddZ80CROMBase(UBYTE *d0, UWORD d1, UWORD d2);

void AddZ80CReadByte( ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80CWriteByte(ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80CReadPort( UWORD d0, UWORD d1, void *d2, UBYTE *d3);
void AddZ80CWritePort(UWORD d0, UWORD d1, void *d2, UBYTE *d3);

void AddZ80CInit(void);

void AddZ80DROMBase(UBYTE *d0, UWORD d1, UWORD d2);

void AddZ80DReadByte( ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80DWriteByte(ULONG d0, ULONG d1, void *d2, UBYTE *d3);
void AddZ80DReadPort( UWORD d0, UWORD d1, void *d2, UBYTE *d3);
void AddZ80DWritePort(UWORD d0, UWORD d1, void *d2, UBYTE *d3);

void AddZ80DInit(void);

void Z80A_load_update(void);
void Z80B_load_update(void);
void Z80C_load_update(void);
void Z80D_load_update(void);

/*----------------------------------------------*/

void ClearZ80List(void);

void StopZ80(UWORD address, UBYTE data);

void SetStopZ80Mode2(UWORD address);
void StopZ80Mode2(UWORD address, UBYTE data);

void SetStopZ80BMode2(UWORD address);
void StopZ80BMode2(UWORD address, UBYTE data);

void SetStopZ80CMode2(UWORD address);
void StopZ80CMode2(UWORD address, UBYTE data);

void SetStopZ80DMode2(UWORD address);
void StopZ80DMode2(UWORD address, UBYTE data);

UWORD DefBadReadZ80(UWORD offset);
void DefBadWriteZ80(UWORD offset, UBYTE data);

void Z80ASetBank(UBYTE *src);
void Z80BSetBank(UBYTE *src);
void Z80CSetBank(UBYTE *src);
void Z80DSetBank(UBYTE *src);

void WriteMZ80Byte(ULONG address, UBYTE data);
UBYTE ReadMZ80Byte(ULONG address);
