/********************************************************/
/*    Sound control linrary version 0.16                */
/*        programed by Hiro-shi (Hiromitsu Shioya)      */
/********************************************************/
/*
  history:
  09/05/99  Added support old update system. (use raine.)

  26/04/99  fixed update sound.
  24/04/99  port raine 0.20
  09/03/99  restart raine support.
            Added sound timer control
            Replaced stream write timing
  12/02/99  rename sample.c -> sasound.c
  support start Meka
*/

#ifdef __RAINE__
#define  ALL_UPDATE_CHANNEL
#endif

//#define  UCLOCK_TEST

#ifdef __RAINE__
/* raine mode */
#include <audio.h>
#ifdef UCLOCK_TEST
#include <time.h>
#endif
#include "raine.h"

#elif __MEKA_SOUND__
/* Meka mode */
#include "shared.h"
#include "allegro.h"
#include <audio.h>
#endif

unsigned char No_FM;		/* dummy key */

#include <math.h>
#include "sasound.h"

unsigned char No_OPL;
static int samp_modeb_timer;

#ifdef __RAINE__
signed short *SampleDest;
int SampleSpace;

int ad_sample;
int ad_index;

int ad_index_table[8] = {
   -1, -1, -1, -1, 2, 4, 6, 8
};

int ad_offset_table[49]= {
   16,  17,  19,  21,  23,  25,  28,  31,  34,  37,  41,  45,  50,  55,  60,  66,
   73,  80,  88,  97,  107, 118, 130, 143, 157, 173, 190, 209, 230,
   253, 279, 307, 337, 371, 408, 449, 494, 544, 598, 658, 724,
   796, 876, 963, 1060,1166,1282,1411,1552
};

void ad_decode(int ad_code)
{
   int ad_base;
   int ad_offset;

   ad_base=ad_offset_table[ad_index];
   ad_offset=ad_base/8;

   if(ad_code&0x01)ad_offset+=ad_base>>2;
   if(ad_code&0x02)ad_offset+=ad_base>>1;
   if(ad_code&0x04)ad_offset+=ad_base;
   if(ad_code&0x08)ad_offset=0-ad_offset;

   ad_sample+=ad_offset;

   if(ad_sample<-2048)ad_sample=-2048;
   if(ad_sample>2047)ad_sample=2047;

   ad_index+=ad_index_table[ad_code&7];

   if(ad_index<0)ad_index=0;
   if(ad_index>48)ad_index=48;
}


void AddSampleADPCM(int start, int end, UBYTE *SOURCE)
{
   int ta,tb;

   ad_sample = 0;
   ad_index = 0;

   tb=0;

   for(ta=start;ta<=end;ta++){
      ad_decode(SOURCE[ta]>>4);
      SampleDest[tb++] = ad_sample<<4;
      ad_decode(SOURCE[ta]&15);
      SampleDest[tb++] = ad_sample<<4;
   }

   SampleList[SampleCount].bits=16;
   SampleList[SampleCount].freq=8000;
   SampleList[SampleCount].priority=128;
   SampleList[SampleCount].len=tb;
   SampleList[SampleCount].loop_start=0;
   SampleList[SampleCount].loop_end=tb;
   SampleList[SampleCount].param=-1;
   SampleList[SampleCount].data=(UBYTE *)&SampleDest[0];

   #ifdef HACKS
      PrintDebug("Sample Added...... $%02x      \nSample Size....... $%06x\n",SampleCount,tb);
      PrintDebug("ADPCM Area........ $%06x-$%06x\nTotal Sample Sizes $%06x\n",start,end,SampleSpace+tb);
   #endif

   SampleSpace+=tb;
   SampleDest=&SampleDest[tb];
   SampleCount++;
}

void AddSample8Bit(int start, int end, UBYTE *SOURCE)
{
   int ta,tb;

   ad_sample = 0;
   ad_index = 0;

   tb=0;

   for(ta=start;ta<=end;ta++){
      SampleDest[tb++] = (SOURCE[ta]-0x80)<<8;
   }

   SampleList[SampleCount].bits=16;
   SampleList[SampleCount].freq=8000;
   SampleList[SampleCount].priority=128;
   SampleList[SampleCount].len=tb;
   SampleList[SampleCount].loop_start=0;
   SampleList[SampleCount].loop_end=tb;
   SampleList[SampleCount].param=-1;
   SampleList[SampleCount].data=(UBYTE *)&SampleDest[0];

   #ifdef HACKS
      PrintDebug("Sample Added...... $%02x      \nSample Size....... $%06x\n",SampleCount,tb);
      PrintDebug("8-Bit Area........ $%06x-$%06x\nTotal Sample Sizes $%06x\n",start,end,SampleSpace+tb);
   #endif

   SampleSpace+=tb;
   SampleDest=&SampleDest[tb];
   SampleCount++;
}

void AddSampleListADPCM(int start, int end, UBYTE *SOURCE)
{
   int ta,tstart,tend;

   for(ta=start;ta<=end;ta+=8){
      tstart=((SOURCE[ta+0]<<16)|(SOURCE[ta+1]<<8)|(SOURCE[ta+2]));
      tend=((SOURCE[ta+3]<<16)|(SOURCE[ta+4]<<8)|(SOURCE[ta+5]));
      AddSampleADPCM(tstart,tend,&SOURCE[0]);
   }

}

void SetSampleDest(int start, UBYTE *DEST)
{
  SampleDest = (signed short *)&DEST[0];
  SampleCount=start;
  SampleSpace=0;
}
#endif
/****************************************************************/
/****************************************************************/
int  SealInitFlag = 0;
AUDIOINFO    audio_info;
AUDIOCAPS    audio_caps;
int    SampleRate;
int    audio_sample_rate;
int    nominal_sample_rate;
int    sound_emu_count;
int    soundcardnum;
static int pause_sound = 0;

SoundRec      *SndMachine = NULL, snd_entry, *nowSndRec;

/* audio related stuff */

int    MasterVolume;
int    vbover_err, vbunder_err;

HAC    hVoice[NUMVOICES];
LPAUDIOWAVE    lpWave[NUMVOICES];
LPBYTE vstreambuf[NUMVOICES];	/* use bufferedstream mode: stock buffer */

int    playing[NUMVOICES];	/* 0:not play 1:playing */
int    vmode[NUMVOICES];	/* playing mode */
int    vchan[NUMVOICES];	/* use bufferedstream mode : write stream butter counter */
int    ventry[NUMVOICES];	/* use bufferedstream mode : entry SEAL buffer counter */
int    vlen[NUMVOICES];		/* buffer length */
int    vbits[NUMVOICES];	/* buffer type (8/16bits) */

int    *vpan[NUMVOICES];	/* Pan buffer */
int    vrestart[NUMVOICES];	/* error restart flag */

enum vmode_num{
  VOICE_NONE = 0,
  VOICE_STREAM,
  VOICE_PLAY
};

static int reserved_channel = 0;
int sound_stream_mode = 1;
int stream_buffer_max;
int buffered_stream_max;

/*******************************************************************************************/
/**** osd_??? functions                                                                 ****/
/*******************************************************************************************/
int get_play_channels( int request ){
  return saGetPlayChannels( request );
}

void reset_play_channels(void){
  saResetPlayChannels();
}

void osd_play_streamed_sample(int channel,signed char *data,int len,int freq,int volume){
  saPlayBufferedStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 8, 128 );
}

void osd_play_streamed_sample_16(int channel,signed short *data,int len,int freq,int volume){
  saPlayBufferedStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 16, 128 );
}

void osd_play_streamed_sample2(int channel,signed char *data,int len,int freq,int volume, int pan){
  saPlayBufferedStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 8, pan );
}

void osd_play_streamed_sample2_16(int channel,signed short *data,int len,int freq,int volume, int pan){
  saPlayBufferedStreamedSampleBase( channel, (signed char *)data, len, freq, volume, 16, pan );
}

void osd_ym2203_update(void){
}

/*******************************************************************************************/
/*  streams v35x                                                                           */
/*******************************************************************************************/

#include "streams.c"

/*******************************************************************************************/
/*  sa???Sound                                                                             */
/*******************************************************************************************/
/************************************/
/*    setup OPL hardware            */
/************************************/
void saInitOpl( void ){
  int  i;
  char *blaster_env;
  /* Get Soundblaster base address from environment variabler BLASTER   */
  /* Soundblaster OPL base port, at some compatibles this must be 0x388 */
  if( !getenv("BLASTER") ){
    printf("\nBLASTER variable not found, disabling fm sound!\n");
    No_OPL = 1;
  } else{
    blaster_env = getenv("BLASTER");
    BaseSb = i = 0;
    while ((blaster_env[i] & 0x5f) != 0x41) i++;        /* Look for 'A' char */
    while (blaster_env[++i] != 0x20) {
      BaseSb = (BaseSb << 4) + (blaster_env[i]-0x30);
    }
    
    DelayReg = 4;   /* Delay after an OPL register write increase it to avoid problems ,but you'll lose speed */
    DelayData = 7;  /* same as above but after an OPL data write this usually is greater than above */
  }
}

/******************************************/
/*    SEAL init                           */
/******************************************/
BOOL saSoundInitSeal( void ){
  int  i;
  if( !SealInitFlag ){
    if( AInitialize() != AUDIO_ERROR_NONE ){
#ifdef HACKS
      PrintDebug("SEAL initialize failed.\n");
#endif
#ifdef __MEKA_SOUND__
      printf("SEAL initialize failed(not create voices)\n");
#endif
      audio_sample_rate = 0;
      return FALSE;
    }
  }
  SealInitFlag = 1;
  saSetSoundCPUClock( NULL ); /* set default base_time */

  /**** init work ****/
  for( i = 0; i < NUMVOICES; i++ ){
    vpan[i] = NULL;
    vstreambuf[i] = NULL;
  }

  return TRUE;
}

/******************************************/
/*    setup sound                         */
/******************************************/
int saGetSoundCard( int soundcard ){
  int  i, k;

  if( saSoundInitSeal() == FALSE )  return -1;
  if( soundcard != -1 )  return soundcard;

  printf( "\nSelect the audio device:\n(if you have an AWE 32, choose Sound Blaster for a more faithful emulation)\n" );
  for( k = 0; k < AGetAudioNumDevs(); k++ ){
    if( AGetAudioDevCaps( k, &audio_caps ) == AUDIO_ERROR_NONE )
      printf("  %2d. %s\n",k,audio_caps.szProductName );
  }
  printf("\n");
#ifdef __MEKA_SOUND__
  soundcard = 0;
  while (!key[KEY_ESC])
    {
    if (key[KEY_0]) break;
    for (i = 1; i < k; i ++)
        if (key[KEY_1 + i - 1]) { soundcard = i; break; }
    if (soundcard > 0) break;
    }
#else
  if( k < 10 ){
    i = getch();
    soundcard = i - '0';
  } else    scanf("%d",&soundcard);
#endif
  return soundcard;
}

/******************************************/
/*    setup sound                         */
/******************************************/
BOOL saInitSoundCard( int soundcard, int buffer_mode, int sample_rate ){
  int  i = 0, j = 0;
  int  err_retry;
  int get_sample_rate;

  if( saSoundInitSeal() == FALSE )  return FALSE;
  if( soundcard == -1 )  soundcard = 0;	/* allways error */

  soundcardnum = soundcard;
  if( soundcard == 0 ){
#ifdef __MEKA_SOUND__
    printf("audio initialization failed\n");
#endif
    audio_sample_rate = 0;
    return TRUE;
  } else{
    audio_info.nDeviceId = soundcard;
    audio_info.wFormat = AUDIO_FORMAT_16BITS | AUDIO_FORMAT_STEREO;
#if 0
    audio_sample_rate = sample_rate; /* set input sample rate */
    if( audio_sample_rate >= 44100 )    audio_sample_rate = 44099;
    audio_info.nSampleRate = audio_sample_rate;
#endif
    audio_sample_rate = 2756;
    audio_info.nSampleRate = audio_sample_rate;
    for( err_retry = 0; err_retry < 5; err_retry++ ){
      int  tmpsamp;
      if( AOpenAudio(&audio_info) != AUDIO_ERROR_NONE )  break;
      tmpsamp = audio_info.nSampleRate;
      if( (tmpsamp < 0) || (tmpsamp >= 44100) ){
	if( get_sample_rate >= 20000 ){
	  audio_info.nSampleRate = 44050;
	  ACloseAudio();
	  continue;
	}
	break;
      }
      /**** try next samplerate ****/
      get_sample_rate = audio_info.nSampleRate;/* store now sample rate */
      audio_sample_rate <<= 1;	/* shift old sample rate */
      audio_info.nSampleRate = audio_sample_rate;
      if( audio_sample_rate > sample_rate )  break;
      ACloseAudio();
    }
    audio_info.nSampleRate = get_sample_rate; /* set last sample rate */
    audio_sample_rate = get_sample_rate; /* set last sample rate */
    ACloseAudio();
    AOpenAudio(&audio_info);
    AGetAudioDevCaps( audio_info.nDeviceId, &audio_caps );
#ifdef HACKS
    PrintDebug(" - Rate: %dHz (input:%dHz)\n", audio_info.nSampleRate, sample_rate );
#endif
#ifdef __MEKA_SOUND__
    printf(" - Rate: %dHz (input:%dHz)\n", audio_info.nSampleRate, sample_rate );
#endif
    
    /* open and allocate voices, allocate waveforms */
    if( AOpenVoices(NUMVOICES) != AUDIO_ERROR_NONE ){
#ifdef HACKS
      PrintDebug("voices initialization failed\n");
#endif
#ifdef __MEKA_SOUND__
      printf(" - Voices initialization failed.\n");
#endif
      audio_sample_rate = 0;
      return FALSE;
    }
    
    for( i = 0; i < NUMVOICES; i++ ){
      if( ACreateAudioVoice(&hVoice[i]) != AUDIO_ERROR_NONE ){
#ifdef HACKS
	PrintDebug("voice #%d creation failed\n",i);
#endif
#ifdef __MEKA_SOUND__
    printf(" - Voice #%d creation failed.\n",i);
#endif
	audio_sample_rate = 0;
	return FALSE;
      }
      ASetVoicePanning( hVoice[i], 128 );
      lpWave[i] = 0;
      playing[i] = 0;
      vmode[i] = VOICE_NONE;
    }
  }
  AUpdateAudio();

  /**** check frame sample rate ****/
  audio_sample_rate = audio_info.nSampleRate;
  nominal_sample_rate = audio_sample_rate;
#ifdef UCLOCK_TEST
  {
    int stockGameSound;
    uclock_t a,b;
    LONG start,end;
    if( (lpWave[0] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE))) == NULL ){
#ifdef HACKS
      PrintDebug("SEAL initialize failed.\n");
#endif
#ifdef __MEKA_SOUND__
      printf(" - SEAL: Failed (test create(malloc))\n");
#endif
      audio_sample_rate = 0;
      return FALSE;
    }
    lpWave[0]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO;
    lpWave[0]->nSampleRate = audio_sample_rate;
    lpWave[0]->dwLength = 6 * audio_sample_rate;
    lpWave[0]->dwLoopStart = 0;
    lpWave[0]->dwLoopEnd = 6 * audio_sample_rate;
    if( ACreateAudioData(lpWave[0]) != AUDIO_ERROR_NONE ){
      free( lpWave[0] );
      lpWave[0] = NULL;
#ifdef HACKS
      PrintDebug("SEAL initialize failed.\n");
#endif
#ifdef __MEKA_SOUND__
      printf(" - SEAL: Failed (test create(ACreateAudioData))\n");
#endif
      audio_sample_rate = 0;
      return FALSE;
    }      
    memset( lpWave[0]->lpData, 0, 6 * audio_sample_rate );
    /* upload the data to the audio DRAM local memory */
    AWriteAudioData( lpWave[0], 0 , 6 * audio_sample_rate );
    APrimeVoice( hVoice[0], lpWave[0] );
    ASetVoiceFrequency( hVoice[0], audio_sample_rate );
    ASetVoiceVolume( hVoice[0], 0 );

    stockGameSound = GameSound;
    GameSound = 0;
    AStartVoice( hVoice[0] );
    a = uclock();
    /* wait some time to let everything stabilize */
    do{
      AUpdateAudioEx( audio_sample_rate / DEF_SOUND_BASE );
      b = uclock();
    } while( (b - a) < UCLOCKS_PER_SEC/10 );
    a = uclock();
    AGetVoicePosition( hVoice[0], &start );
    do{
      AUpdateAudioEx( audio_sample_rate / DEF_SOUND_BASE );
      b = uclock();
    } while( (b - a) < UCLOCKS_PER_SEC );
    AGetVoicePosition( hVoice[0], &end );
    AStopVoice( hVoice[0] );
    ADestroyAudioData( lpWave[0] );
    free( lpWave[0] );
    lpWave[0] = NULL;
    nominal_sample_rate = audio_sample_rate;
    audio_sample_rate = end - start;
#ifdef HACKS
    PrintDebug("uclock:%d %d\n", nominal_sample_rate, audio_sample_rate );
#endif
#ifdef __MEKA_SOUND__
    printf( "uclock:%d %d\n", nominal_sample_rate, audio_sample_rate );
#endif
    GameSound = stockGameSound;
  }
#endif

  /**** stream buffer mode ****/
#ifdef __MEKA_SOUND__
  STREAM_BUFFER_MAXA = DEF_STREAM_BUFFER_MAXA;
  MODEB_FRAME_SIZE   = DEF_MODEB_FRAME_SIZE;
  MODEB_UPDATE_COUNT = DEF_MODEB_UPDATE_COUNT;
  MODEB_ERROR_MAX    = DEF_STREAM_UPDATE_ERROR_MAX;
  STREAM_BUFFER_MAXB = MODEB_FRAME_SIZE;			/* don't change this!! */
  MODEB_MASK         = MODEB_FRAME_SIZE/MODEB_UPDATE_COUNT;	/* don't change this!! */
#endif
  sound_stream_mode = buffer_mode;
  stream_buffer_max = STREAM_BUFFER_MAXB;

  if( sound_stream_mode == SOUND_STREAM_TIMER ){
    buffered_stream_max = stream_buffer_max = 3;	/* audio_buffer_max_size */
    MODEB_UPDATE_COUNT = 1;
  }
  else if( sound_stream_mode == SOUND_STREAM_WAIT ){
    buffered_stream_max = MODEB_UPDATE_COUNT * 3;/* audio_buffer_max_size (triple buffer) */
    if( stream_buffer_max < buffered_stream_max )  stream_buffer_max = buffered_stream_max;
  }

  samp_modeb_timer = 0;
  /**** timer work init ****/
  sound_freerun_count = 0;
  sound_slice = 0;

  MasterVolume = 100;

  if(change_sample_rate!=0){		// Sample rate has changed, so all emulators must
    change_sample_rate=0;		// be restarted!
    saStopSoundEmulators();
  }

  /**** setup SoundBlaster ****/
  saInitOpl();

#ifdef HACKS
  PrintDebug("SEAL initialize OK\n");
#endif
#ifdef __MEKA_SOUND__
  printf(" - SEAL: Ok\n");
#endif

  if( sound_stream_mode == SOUND_STREAM_TIMER )
    saInitSoundTimer();

  if( SndMachine != NULL ){
    if( !SndMachine->first ){
#ifdef HACKS
      PrintDebug("Sound sub-system initialize start\n");
#endif
      saInitVolPan();		/* moved. (hiro-shi) */
      SndMachine->first = 1;	/* first flag clear */
      streams_sh_start();	/* streaming system initialize & start */
      pause_sound = 0;		/* pause flag off */
      vbover_err = vbunder_err = 0; /* error initial */
      No_FM = 1;			/* FM DAC mode */
      for( j = 0; j < SndMachine->control_max; j++ ){
	switch( SndMachine->init[j] ){
#ifdef __RAINE__
	case SOUND_YM2203:
	  i = YM2203_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = YM2203_sh_stop;
	  break;
	case SOUND_YM2151S:
	  i = YM2151_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = YM2151_sh_stop;
	  break;
	case SOUND_YM2151J:
	  i = YM2151_ALT_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = YM2151_sh_stop;
	  break;
	case SOUND_YM2610:
	  i = YM2610_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = YM2610_sh_stop;
	  break;
	case SOUND_YM2610B:
	  i = YM2610B_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = YM2610_sh_stop;
	  break;
	case SOUND_MSM5205:
	  i = MSM5205buffer_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = MSM5205buffer_sh_stop;
	  break;
	case SOUND_M6295:
	  i = M6295buffer_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = M6295buffer_sh_stop;
	  break;
	case SOUND_PSG:
	  i = AY8910_sh_start( SndMachine->intf[j] );
	  //if( !i )  SndMachine->stopfunc[j] = AY8910_sh_stop;
	  break;
	case SOUND_YM3812:
	  i = YM3812_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = YM3812_sh_stop;
	  break;
#endif
#ifdef __MEKA_SOUND__
	case SOUND_SN76496:
	  i = SN76496_sh_start( SndMachine->intf[j] );
	  if( !i )  SndMachine->stopfunc[j] = SN76496_sh_stop;
	  break;
	case SOUND_YM2413Hard:
	  if( InitSBReg() ){
	    i = 0;
	    SndMachine->stopfunc[j] = DestroySBReg;
	  } else{
	    i = 1;
	  }
	  break;
#endif
	}
	if( i ){
	  audio_sample_rate = 0;
	  saStopSoundEmulators(); /* remove sound systems */
	  SndMachine = NULL;
#ifdef HACKS
	  PrintDebug("Sound sub-system initialize failed\n");
#endif
	  return FALSE;
	}
      }
#ifdef HACKS
      PrintDebug("Sound sub-system initialize OK\n");
#endif
    }
  }
  return TRUE;
}

/*********************************************************************/
/* stop sound emulators: this is needed for when sample rate changes */
/*********************************************************************/
void saStopSoundEmulators(void){
  int i;
  saResetPlayChannels();
  if( SndMachine == NULL ){
    SndMachine = &snd_entry;
  }
  else{
    streams_sh_stop();
    for( i = 0; i < SndMachine->control_max; i++ ){
      if( SndMachine->stopfunc[i] != NULL )  SndMachine->stopfunc[i]();
    }
    SndMachine->first           = 0;
    SndMachine->sound_timing    = 0;
    SndMachine->sound_count     = 0;
  }
}

/******************************************/
/*    setup sound                         */
/******************************************/
void saSetupSound( SoundRecEntry *rec ){
  int  i;

  if( rec == NULL )  return;
  saStopSoundEmulators();

  /**** init sound control work ****/
  for( i = 0; i < SND_CONTROL_MAX; i++ ){
    SndMachine->init[i]      = -1;
    SndMachine->update[i]    = NULL;
    SndMachine->stopfunc[i]  = NULL;
    SndMachine->intf[i]      = NULL;
  }
  SndMachine->sound_timing    = 0;
  SndMachine->sound_count     = 0;
  SndMachine->sound_countmax  = rec->count;
  SndMachine->sound_timingmax = rec->sync / SndMachine->sound_countmax;
  SndMachine->init[0]      = rec->init;
  SndMachine->update[0]    = rec->update;
  SndMachine->intf[0]      = rec->intf;
  SndMachine->first = 0;
  SndMachine->control_max = 1;
}

/******************************************/
/*    add sound                           */
/******************************************/
void saAddSound( SoundRecEntry *rec ){
  int i;
  if( SndMachine->control_max >= SND_CONTROL_MAX )  return;
  i = SndMachine->control_max;
  SndMachine->init[i]      = rec->init;
  SndMachine->update[i]    = rec->update;
  SndMachine->intf[i]      = rec->intf;
  SndMachine->control_max++;
}
/******************************************/
/*    destroy 1ch                         */
/******************************************/
void saDestroyChannel( int chan ){
  if( lpWave[chan] ){
    AStopVoice( hVoice[chan] );
    ADestroyAudioData( lpWave[chan] );
    free( lpWave[chan] );

    if( vstreambuf[chan] != NULL )  free( vstreambuf[chan] );
    if( vpan[chan] != NULL )        free( vpan[chan] );

    lpWave[chan] = 0;
    playing[chan] = 0;
    vmode[chan] = VOICE_NONE;
    vpan[chan] = NULL;
    vstreambuf[chan] = NULL;
  }
}
/******************************************/
/*    destroy sound                       */
/******************************************/
void saDestroySound( int mode ){
  int  i;

  if( sound_stream_mode == SOUND_STREAM_TIMER )
    saRemoveSoundTimer();
  if( mode != 0 ){
    saStopSoundEmulators();
  }
  for( i = 0; i < NUMVOICES; i++ ){
    saDestroyChannel( i );
    ADestroyAudioVoice( hVoice[i] );
  }
  ACloseVoices();
  ACloseAudio();
  
#ifdef HACKS
  PrintDebug("SEAL removed OK(%d)\n", mode );
#endif

}

/******************************************/
/*    setup sound                         */
/******************************************/
void saRemoveSound( void ){
  saDestroySound(1);
}

/******************************************/
/*    pause control                       */
/******************************************/
void sa_pause_sound(void){
  int i;
  pause_sound      = 1;
  samp_modeb_timer = 0;
  vbover_err       = 0;
  vbunder_err      = 0;
#ifdef __RAINE__
  pause_raine_ym3812();
#endif
  for( i = 0; i < NUMVOICES; i++ ){
    saDestroyChannel( i );
  }
}

void sa_unpause_sound(void){
  pause_sound      = 0;
}

/******************************************/
/*    update sound                        */
/******************************************/
void saUpdateSound( int nowclock ){
  int  i;

  if( GameSound == 0 ) return;			// [J3d!]: Extra Check
#ifdef __RAINE__
  if( RaineSoundCard == 0 ) return;		// [J3d!]: Extra Check
#endif

  if( audio_sample_rate == 0 )  return;
  if( SndMachine == NULL )    return;
  if( !SndMachine->first )  return; /* not sound initialize end */
  if( sound_stream_mode == SOUND_STREAM_TIMER )  return;

  if( nowclock ){
    streams_sh_update();
    for( i = 0; i < SndMachine->control_max; i++ )
      if( SndMachine->update[i] != NULL )  SndMachine->update[i]();
  } else{
    if( sound_stream_mode == SOUND_STREAM_WAIT )
      saCheckPlayStream();
    else if( sound_stream_mode == SOUND_STREAM_OLDTYPE )
      saCheckPlayStreamOld();
  }
}
/******************************************/
/******************************************/
void saUpdateSoundTimer( void ){
  int  i;
  if( GameSound == 0 ) return;			// [J3d!]: Extra Check
#ifdef __RAINE__
  if( RaineSoundCard == 0 ) return;		// [J3d!]: Extra Check
#endif
  if( audio_sample_rate == 0 )  return;
  if( SndMachine == NULL )    return;
  if( !SndMachine->first )  return; /* not sound initialize end */

  if( !pause_sound ){
    streams_sh_update();
    for( i = 0; i < SndMachine->control_max; i++ )
      if( SndMachine->update[i] != NULL )  SndMachine->update[i]();
  }
}

/******************************************/
/*    buffer check                        */
/******************************************/
static int ckl = 0;
void saCheckPlayStream( void ){
  int ret = 0;
  int i, len, slens = 0, rlens = 0, rlene = 0;
  int update_size;
  int ve, lenc;
  DWORD pos[NUMVOICES];

  if( !pause_sound ){
    /**** get now position ****/
    for( i = 0; i < NUMVOICES; i++ ){
      if( !playing[i] )  continue;
      if( vmode[i] != VOICE_STREAM )  continue;
#ifdef __RAINE__
      AUpdateAudio();
      //AUpdateAudioEx( audio_sample_rate / DEF_SOUND_BASE );
#elif __MEKA_SOUND__
      AUpdateAudio();
#endif
      AGetVoicePosition( hVoice[i], &pos[i] );
#ifdef HACKS
      if( !ret ){
	if( ckl == (i+1) ){
	  PrintIngame(120," *(%2d):%8d", i, pos[i] );
	  ret++;
	}
      }
#endif
    }
    /**** check update position ****/
    for( i = 0; i < NUMVOICES; i++ ){
      if( !playing[i] )  continue;
      if( vmode[i] != VOICE_STREAM )  continue;
      if( (vchan[i] - ventry[i]) > 0 ){
	/**** buffer update check ****/
	update_size = vchan[i] - ventry[i];
	if( update_size > MODEB_UPDATE_COUNT * 2 )  update_size = MODEB_UPDATE_COUNT * 2;
	len = vlen[i];
	rlens = (ventry[i]%buffered_stream_max);
	rlene = rlens + update_size;
	if( rlene > buffered_stream_max ){
	  rlene = rlene%buffered_stream_max;
	}
	rlens = rlens * len;
	rlene = rlene * len;

#if 0
#ifdef HACKS
	if( !i ){
	  PrintIngame(120,"   dump:%8d %8d %8d", pos[i], rlens, rlene );
	}
#endif
#endif
	lenc = 0;
	if( pos[i] < rlens || pos[i] > rlene )   lenc = 1;
	else{
	  lenc = (pos[i] - rlens);
	  if( lenc >= 0 && lenc < (len / 6) )  lenc = 1;
	  else                                 lenc = 0;
	}

	if( lenc ){
	  /**** copy stream buffer -> PCM buffer ****/
#ifndef ALL_UPDATE_CHANNEL
#ifdef HACKS
	  if( ckl == (i+1) )  ckl = 0;
#endif
	  len *= vbits[i];	/* create buffer length (8/16bit) */
	  rlens *= vbits[i];    //rlens = (ventry[i]%buffered_stream_max) * len;
	  ve = ventry[i]%stream_buffer_max;
	  slens = ve * len;    //slens = (ve * len) * vbits[i];
	  
	  memcpy( &lpWave[i]->lpData[rlens], vstreambuf[i] + slens, len * update_size );
	  //AWriteAudioData( lpWave[i], slens, len );

	  /**** pan write ****/
	  if( *(vpan[i] + ve)&WRITE_PAN )  ASetVoicePanning( hVoice[i], (UINT)*(vpan[i] + ve)&0xff );
	  /*** update strem buffer & play buffer position ****/
	  ventry[i] += update_size;
	  vbover_err = 0;	/* reset error count */
	  vbunder_err = 0;

#if 0
	  if( playing[i] == 2 ){
	    playing[i] = 1;
	    AStartVoice( hVoice[i] );
	  }
#endif
#else
#ifdef HACKS
	  ckl = 0;
#endif
	  for( i = 0; i < NUMVOICES; i++ ){
	    if( !playing[i] )  continue;
	    if( vmode[i] != VOICE_STREAM )  continue;
	    update_size = vchan[i] - ventry[i];
	    if( update_size < 0 )  continue;
	    if( update_size > MODEB_UPDATE_COUNT * 2 )  update_size = MODEB_UPDATE_COUNT * 2;
	    len = vlen[i] * vbits[i];
	    rlens = (ventry[i]%buffered_stream_max) * len;
	    ve = ventry[i]%stream_buffer_max;
	    slens = ve * len;    //slens = (ve * len) * vbits[i];
	    memcpy( &lpWave[i]->lpData[rlens], vstreambuf[i] + slens, len * update_size );
	    /**** pan write ****/
	    if( *(vpan[i] + ve)&WRITE_PAN )  ASetVoicePanning( hVoice[i], (UINT)*(vpan[i] + ve)&0xff );
	    /*** update strem buffer & play buffer position ****/
	    ventry[i] += update_size;
	    vbover_err = 0;	/* reset error count */
	    vbunder_err = 0;
#if 0
	    if( playing[i] == 2 ){
	      playing[i] = 1;
	      AStartVoice( hVoice[i] );
	    }
#endif
	  }
	  return;
#endif
	  /**** end of copy stream buffer -> PCM buffer ****/
	} else{
	  vbover_err++;		/* error count */
#ifdef HACKS
	  if( !ret ){
	    if( !ckl ){
	      PrintIngame(120,"  (%2d):%8d %8d %8d", i, pos[i], rlens, rlene );
	      ckl = i + 1;
	    }
	    ret++;
	  }
#endif
	  /**** check error max ****/
	  if( vbover_err >= MODEB_ERROR_MAX ){
#ifdef HACKS
	    PrintIngame(120,"Buffer stop. restart stream" );
#endif
#ifdef __MEKA_SOUND__
	    Message (MESSAGE_DEBUG, "buffer stop. restart stream" );
#endif
	    /**** all buffer restart ****/
	    vbover_err = 0;
	    vbunder_err = 0;
	    for( i = NUMVOICES - 1; i >= 0; i-- ){
	      saDestroyChannel( i );
	    }
	  }
	  /**** error max check ****/
	}
	/**** pos check end ****/
      }
      /**** buffer pos check end ****/
    }
    /**** loop end ****/
  } else{
    /**** update sound ****/
#ifdef __RAINE__
      AUpdateAudioEx( audio_sample_rate / DEF_SOUND_BASE );
#elif __MEKA_SOUND__
      AUpdateAudio();
#endif
  }
  /**** pause ****/
  return;
}


/******************************************/
/*    buffer check                        */
/*    old type                            */
/******************************************/
void saCheckPlayStreamOld( void )
{
  int i, len, rlen;
  DWORD pos;
  int vp, ve;
  
  if( !pause_sound ){
    AUpdateAudio();

    samp_modeb_timer = (samp_modeb_timer+1) % MODEB_FRAME_SIZE;	// <60> res = [0..59]
    
    vp = samp_modeb_timer / MODEB_UPDATE_COUNT;			// <3>  res = [0..19]
    
    for( i = 0; i < NUMVOICES; i++ ){					// ***** SCAN VOICES
      
      if( playing[i] ){						// ***** PROCESS ENABLED VOICE
	
	ve = ventry[i] % MODEB_MASK;				// <60/3=20> res = [0..19]
	
	if( (vmode[i] == VOICE_STREAM) && (vp == ve )){		// ***** PROCESS ENABLED STREAM VOICE
	  
	  /**** buffer update check ****/
	  AGetVoicePosition( hVoice[i], &pos );
	  len = (lpWave[i]->dwLength / stream_buffer_max) * MODEB_UPDATE_COUNT;	// length of <3> buffers
	  rlen = len * vp;								// buffer point where sample should go
	  
	  if( (pos < rlen) || (pos >= (rlen+len)) ){		// Make sure it is not playing this buffer right now
	    
	    /**** check play buffer/write buffer position ****/
	    ve = (ventry[i] + 1) * MODEB_UPDATE_COUNT;		// 
	    
	    /*if( (vchan[i] - ve) > 0 ){*/
	    /*if( (vchan[i] - ve) > -MODEB_UPDATE_COUNT ){*/
	    
	    if( ((vchan[i] - ve) > (0-MODEB_UPDATE_COUNT)) && (vbunder_err < (MODEB_ERROR_MAX*2))){
	      
	      if( (vchan[i] - ve) < 0 )  vbunder_err++;
	      else{
		if( vbunder_err >= 0 )  vbunder_err--;
	      }
	      /**** all buffer update (not overrun) ****/
	      for( i = 0; i < NUMVOICES; i++ ){
		if( playing[i] && vmode[i] == VOICE_STREAM ){
		  vbover_err = 0;
		  len  = (lpWave[i]->dwLength / stream_buffer_max) * MODEB_UPDATE_COUNT;
		  rlen = len * vp;
		  ASetVoicePanning( hVoice[i], (UINT)*(vpan[i] + samp_modeb_timer) );
		  ventry[i]++;
		}
	      }
	      
	    }
	    else{
	      
#ifdef HACKS
	      PrintIngame(120,"Now buf-p[over] %08x %08x", vchan[i], ve );
#endif
	      /**** all buffer update (over run) ****/
	      for( i = 0; i < NUMVOICES; i++ ){
		if( playing[i] && vmode[i] == VOICE_STREAM ){
		  //AStopVoice( hVoice[i] );
		  vbunder_err = 0;
		  vbover_err = 0;
		  len  = (lpWave[i]->dwLength / stream_buffer_max) * MODEB_UPDATE_COUNT;
		  rlen = len * vp;
		  //AWriteAudioData( lpWave[i], rlen, len );
		  //APlayVoice( hVoice[i], lpWave[i] );
		  ASetVoicePanning( hVoice[i], (UINT)*(vpan[i] + samp_modeb_timer) );
		  vchan[i] = (ventry[i] + 1) * MODEB_UPDATE_COUNT;
		  ventry[i]++;
		}
	      }
	      
	    }
	    return;		// Completed
	  }
	  else{			// ERROR: Required buffer was being played
	    
	    vbover_err++;		/* error count */
	    //PrintIngame(120,"ve:%08x, vc:%08x, verr:%08x", ventry[0]*MODEB_UPDATE_COUNT, vchan[0], vbover_err );
	    if( vbover_err >= MODEB_ERROR_MAX ){
	      /**** all buffer restart ****/
	      vbover_err       = 0;
	      vbunder_err      = 0;
	      samp_modeb_timer = 0;
	      
	      for( i = 0; i < NUMVOICES; i++ ){
#if 0
		ventry[i] = 1;
		vchan[i] = MODEB_UPDATE_COUNT;
#else
		saDestroyChannel( i );
#endif
	      }
	      
#ifdef HACKS
	      PrintIngame(60,"Buffer stop: Restarting streams.");
#endif
	    }
	    return;		// Completed
	    
	  }
	  /**** pos check end ****/
	}			// ***** END PROCESS ENABLED STREAM VOICE
      }			// ***** END PROCESS ENABLED VOICE
    }				// ***** END SCAN VOICES
  } else{		// ***** END PLAY SOUND
#ifdef __RAINE__
    AUpdateAudioEx( audio_sample_rate / DEF_SOUND_BASE );
#elif __MEKA_SOUND__
    AUpdateAudio();
#endif
  }
}

/*******************************************************************************************/
/*******************************************************************************************/
/******************************************/
/*    play samples                        */
/******************************************/
void saPlayBufferedStreamedSampleBase( int channel, signed char *data, int len, int freq, int volume, int bits , int pan ){
  int i;
  if( audio_sample_rate == 0 || channel >= NUMVOICES )  return;
  if( SndMachine == NULL )  return;
  if( sound_stream_mode == SOUND_STREAM_OLDTYPE ){
    saPlayBufferedStreamedSampleBaseOld( channel,data, len, freq, volume, bits , pan );
    return;
  }
  /**** entry of new update type ****/
  if( !playing[channel] ){
    if( lpWave[channel] ){
      AStopVoice( hVoice[channel] );
      ADestroyAudioData( lpWave[channel] );
      free( lpWave[channel] );
      lpWave[channel] = 0;
    }
    if( (lpWave[channel] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE))) == 0 )  return;
    if( (vstreambuf[channel] = (LPBYTE)malloc( stream_buffer_max * len )) == NULL ){
      free( lpWave[channel] );
      lpWave[channel] = NULL;
      return;
    }
    if( (vpan[channel] = (int *)malloc(sizeof(int)*stream_buffer_max)) == NULL ){
      free( lpWave[channel] );
      lpWave[channel] = NULL;
      free( vstreambuf[channel] );
      return;
    }

    lpWave[channel]->wFormat     = (bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS)
      | AUDIO_FORMAT_STEREO | AUDIO_FORMAT_LOOP;
#ifndef __RAINE__
    lpWave[channel]->nSampleRate = nominal_sample_rate;
#else
    lpWave[channel]->nSampleRate = audio_sample_rate;
#endif
    lpWave[channel]->dwLength    = buffered_stream_max*len;
    lpWave[channel]->dwLoopStart = 0;
    lpWave[channel]->dwLoopEnd   = lpWave[channel]->dwLength;
    if( ACreateAudioData(lpWave[channel]) != AUDIO_ERROR_NONE ){
      free( lpWave[channel] );
      free( vpan[channel] );
      free( vstreambuf[channel] );
      lpWave[channel] = 0;
      vpan[channel] = 0;
      return;
    }
    memset( lpWave[channel]->lpData, 0, lpWave[channel]->dwLength );
    memset( vstreambuf[channel], 0, stream_buffer_max*len );
    APrimeVoice( hVoice[channel], lpWave[channel] );
#ifndef __RAINE__
    ASetVoiceFrequency( hVoice[channel], ((double)freq * nominal_sample_rate) / audio_sample_rate );
#else
    ASetVoiceFrequency( hVoice[channel], freq );
#endif
    ASetVoiceVolume( hVoice[channel], MasterVolume*volume/400 );
    ASetVoicePanning( hVoice[channel], (UINT)pan );
    playing[channel] = 2;	/* start wait */
    vmode[channel] = VOICE_STREAM;
    /**** make sound temp. buffer ****/
    vchan[channel] = MODEB_UPDATE_COUNT * 2;
    memcpy( vstreambuf[channel] + len * vchan[channel], data, len );
    for( i = 0; i <= vchan[channel]; i++ )
      *(vpan[channel] + i) = pan | WRITE_PAN;
    ventry[channel] = vchan[channel];
    vchan[channel]++;
    vrestart[channel] = 0;
    vbits[channel] = bits / 8;
    vlen[channel] = len / vbits[channel];
    /**** write data ****/
    AWriteAudioData( lpWave[channel], 0, lpWave[channel]->dwLength );
    //AStartVoice( hVoice[channel] );

  } else{
    int s_pos = vchan[channel]%stream_buffer_max;
    memcpy( vstreambuf[channel] + len * s_pos, data, len );
    *(vpan[channel] + s_pos) = pan | WRITE_PAN;
    vchan[channel]++;
  }
}

/******************************************/
/*    play samples                        */
/******************************************/
void saPlayBufferedStreamedSampleBaseOld( int channel, signed char *data, int len, int freq, int volume, int bits , int pan ){
  int i;
  if( !playing[channel] ){
    if( lpWave[channel] ){
      AStopVoice( hVoice[channel] );
      ADestroyAudioData( lpWave[channel] );
      free( lpWave[channel] );
      lpWave[channel] = 0;
    }
    if( (lpWave[channel] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE))) == 0 )  return;
    if( (vpan[channel] = (int *)malloc(sizeof(int)*stream_buffer_max)) == NULL )  return;
    
    lpWave[channel]->wFormat     = (bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) | AUDIO_FORMAT_STEREO | AUDIO_FORMAT_LOOP;
#ifndef __RAINE__
    lpWave[channel]->nSampleRate = nominal_sample_rate;
#else
    lpWave[channel]->nSampleRate = audio_sample_rate;
#endif
    lpWave[channel]->dwLength    = stream_buffer_max*len;
    lpWave[channel]->dwLoopStart = 0;
    lpWave[channel]->dwLoopEnd   = stream_buffer_max*len;
    if( ACreateAudioData(lpWave[channel]) != AUDIO_ERROR_NONE ){
      free( lpWave[channel] );
      free( vpan[channel] );
      lpWave[channel] = 0;
      vpan[channel] = 0;
      return;
    }
    memset( lpWave[channel]->lpData, 0, stream_buffer_max*len );
    APlayVoice( hVoice[channel], lpWave[channel] );
#ifndef __RAINE__
    ASetVoiceFrequency( hVoice[channel], ((double)freq * nominal_sample_rate) / audio_sample_rate );
#else
    ASetVoiceFrequency( hVoice[channel], freq );
#endif
    ASetVoiceVolume( hVoice[channel], MasterVolume*volume/400 );
    ASetVoicePanning( hVoice[channel], (UINT)pan );
    playing[channel] = 1;	/* use front surface */
    vmode[channel] = VOICE_STREAM;
    /**** make sound temp. buffer ****/
    vchan[channel] = MODEB_UPDATE_COUNT;
    memcpy( &lpWave[channel]->lpData[len * MODEB_UPDATE_COUNT], data, len );
    for( i = 0; i <= MODEB_UPDATE_COUNT; i++ ){
      *(vpan[channel] + i) = pan;
    }
    vchan[channel]++;
    ventry[channel] = 1;
  } else{
    int s_pos = vchan[channel]%stream_buffer_max;
    memcpy( &lpWave[channel]->lpData[len * s_pos], data, len );
    *(vpan[channel] + s_pos) = pan;
    vchan[channel]++;
  }
}

/******************************************/
/*    play samples                        */
/******************************************/
void saPlayStreamedSampleBase( int channel, signed char *data, int len, int freq, int volume, int bits , int pan ){
  if( audio_sample_rate == 0 || channel >= NUMVOICES )  return;
  if( SndMachine == NULL )  return;
  if( !playing[channel] ){
    if( lpWave[channel] ){
      AStopVoice( hVoice[channel] );
      ADestroyAudioData( lpWave[channel] );
      free( lpWave[channel] );
      lpWave[channel] = 0;
    }
    if( (lpWave[channel] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE))) == 0 )  return;

    lpWave[channel]->wFormat = 
      (bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) | AUDIO_FORMAT_STEREO | AUDIO_FORMAT_LOOP;
    lpWave[channel]->nSampleRate = nominal_sample_rate;
    lpWave[channel]->dwLength = stream_buffer_max*len;
    lpWave[channel]->dwLoopStart = 0;
    lpWave[channel]->dwLoopEnd = stream_buffer_max*len;
    if( ACreateAudioData(lpWave[channel]) != AUDIO_ERROR_NONE ){
      free( lpWave[channel] );
      lpWave[channel] = 0;
      return;
    }
    memset(lpWave[channel]->lpData,0,stream_buffer_max*len);
    memcpy(lpWave[channel]->lpData,data,len);
    /* upload the data to the audio DRAM local memory */
    APrimeVoice(hVoice[channel],lpWave[channel]);
    ASetVoiceFrequency(hVoice[channel],(double)freq*nominal_sample_rate/audio_sample_rate );
    ASetVoiceVolume(hVoice[channel],MasterVolume*volume/400);
    ASetVoicePanning(hVoice[channel], (UINT)pan );
    playing[channel] = 1;	/* use front surface */
    vchan[channel] = 1;
    ventry[channel] = 1;
    vmode[channel] = VOICE_STREAM;
    AStartVoice( hVoice[channel] );
  } else{
    DWORD pos;
#if 0
    int nownum = vchan[channel]%stream_buffer_max;
    for(;;){
      AUpdateAudio();
      AGetVoicePosition(hVoice[channel],&pos);
      
      if( !nownum && pos >= len )  break;
      if( nownum == (stream_buffer_max-1) ){
	if( pos < (len*nownum) )  break;
      } else{
	if( (pos < len*(nownum) || pos >= (len*(nownum+1))) )  break;
      }
      /*
      if ((vchan[channel]%STREAM_BUFFER_MAXA) == 0 && pos >= len) break;
      if ((vchan[channel]%STREAM_BUFFER_MAXA) == 1 && (pos < len || pos >= (2*len))) break;
      if ((vchan[channel]%STREAM_BUFFER_MAXA) == 2 && pos < (2*len)) break;
      */
    }
#else
    AGetVoicePosition(hVoice[channel],&pos);
    //AUpdateAudio();
#endif

    memcpy( &lpWave[channel]->lpData[len * (vchan[channel]%stream_buffer_max)], data, len );
    //AWriteAudioData( lpWave[channel], len*(vchan[channel]%stream_buffer_max), len );
    vchan[channel]++;
  }
}

/******************************************/
/*    play samples                        */
/******************************************/
void saPlayStreamedSample16( int channel, signed short *data, int len, int freq, int volume ){
  saPlayBufferedStreamedSampleBase( channel, (signed char *)data, 2*len, freq, volume, 16, 128 );
}
/******************************************/
/*    play samples                        */
/******************************************/
void saPlayStreamedSample16Pan( int channel, signed short *data, int len, int freq, int volume, int pan ){
  saPlayBufferedStreamedSampleBase( channel, (signed char *)data, 2*len, freq, volume, 16, pan );
}

/******************************************/
/*    play samples                        */
/******************************************/
void saPlaySampleBase( int channel, signed char *data, int len, int freq, int volume, int loop, int bits ){
  if( audio_sample_rate == 0 || channel >= NUMVOICES ) return;
  if( SndMachine == NULL )  return;

  if ( lpWave[channel] && lpWave[channel]->dwLength != len ){
    AStopVoice(hVoice[channel]);
    ADestroyAudioData(lpWave[channel]);
    free(lpWave[channel]);
    lpWave[channel] = 0;
  }
  if( lpWave[channel] == 0 ){
    if( (lpWave[channel] = (LPAUDIOWAVE)malloc(sizeof(AUDIOWAVE))) == 0 )  return;

    if( loop )  lpWave[channel]->wFormat = ( bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) |
		  AUDIO_FORMAT_MONO | AUDIO_FORMAT_LOOP;
    else        lpWave[channel]->wFormat = (bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) |
		  AUDIO_FORMAT_MONO;
    lpWave[channel]->nSampleRate = nominal_sample_rate;
    lpWave[channel]->dwLength = len;
    lpWave[channel]->dwLoopStart = 0;
    lpWave[channel]->dwLoopEnd = len;
    if( ACreateAudioData(lpWave[channel]) != AUDIO_ERROR_NONE ){
      free(lpWave[channel]);
      lpWave[channel] = 0;
      return;
    }
  } else{
    /*
    if( loop )  lpWave[channel]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO | AUDIO_FORMAT_LOOP;
    else        lpWave[channel]->wFormat = AUDIO_FORMAT_8BITS | AUDIO_FORMAT_MONO;
    */
    if( loop )  lpWave[channel]->wFormat = ( bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) |
		  AUDIO_FORMAT_MONO | AUDIO_FORMAT_LOOP;
    else        lpWave[channel]->wFormat = (bits == 8 ? AUDIO_FORMAT_8BITS : AUDIO_FORMAT_16BITS) |
		  AUDIO_FORMAT_MONO;
  }
  memcpy(lpWave[channel]->lpData,data,len);
  /* upload the data to the audio DRAM local memory */
  AWriteAudioData(lpWave[channel],0,len);
  APrimeVoice(hVoice[channel],lpWave[channel]);
  /* need to cast to double because freq*nominal_sample_rate can exceed the size of an int */
  ASetVoiceFrequency(hVoice[channel],freq*nominal_sample_rate/audio_sample_rate );
  ASetVoiceVolume(hVoice[channel],MasterVolume*volume/400);
  AStartVoice(hVoice[channel]);
}

/******************************************/
/*    play samples                        */
/******************************************/
void saPlaySample8(int channel,signed char *data,int len,int freq,int volume,int loop){
  saPlaySampleBase(channel,data,len,freq,volume,loop,8);
}

/******************************************/
/*    play samples                        */
/******************************************/
void saPlaySample16(int channel,signed short *data,int len,int freq,int volume,int loop){
  saPlaySampleBase(channel,(signed char *)data,2*len,freq,volume,loop,16);
}

/******************************************/
/*    stop samples                        */
/******************************************/
void saStopSample(int channel){
    AStopVoice(hVoice[channel]);
    ADestroyAudioData(lpWave[channel]);
    free(lpWave[channel]);
    lpWave[channel] = 0;
}
/*******************************************************************************************/
/*******************************************************************************************/
/******************************************/
/*    get play channel                    */
/******************************************/
int saGetPlayChannels( int request ){
  int ret_value = reserved_channel;
  reserved_channel += request;
  return ret_value;
}
void saResetPlayChannels( void ){
  reserved_channel = 0;
}
// ChannelActive():
// Return Status of an audio channel (playing/stopped).

int ChannelActive(int ch)
{
   int ta;
   AGetVoiceStatus(hVoice[ch],&ta);
   return(ta);
}
/*******************************************************************************************/
/*******************************************************************************************/
char *sound_card_name( int num )
{
   static char *sound_name_list[] =
   {
      "Silence",
      "Sound Blaster",
      "Sound Blaster AWE32",
      "Pro Audio Spectrum",
      "Ultrasound Max (CS4231 Codec)",
      "Ultrasound",
      "Windows Sound System",
      "Ensoniq Soundscape",
   };

   return sound_name_list[num];
}

/*******************************************************************************************/
/*******************************************************************************************/
/************************************/
/*    volume/pan control init       */
/************************************/
void saInitVolPan( void ){
  int  i;
  for( i = 0; i < VOL_PAN_MAX; i++ ){
    SampleVol[i] = VOLUME_MAX;	/* max volume */
    SamplePan[i] = 0x80;	/* 00:left 80:center ff:right */
  }
}

void saSetVolume( int num, int data ){
  SampleVol[num] = data < 0x100 ? data : VOLUME_MAX;
}
void saSetPan( int num, int data ){
  SamplePan[num] = data;
}

void saSetVolumeNolimit( int num, int data ){
  SampleVol[num] = data;
}

void saSetVolumeMuli( int num, int data ){
  int  i;
  for( i = 0; i < stream_joined_channels[num]; i++ )
    SampleVol[num + i] = data < 0x100 ? data : VOLUME_MAX;
}
void saSetPanMulti( int num, int data ){
  int  i;
  for( i = 0; i < stream_joined_channels[num]; i++ )
    SamplePan[num + i] = data;
}
void saSetVolumeMuliNolimit( int num, int data ){
  int  i;
  for( i = 0; i < stream_joined_channels[num]; i++ )
    SampleVol[num + i] = data;
}

/*******************************************************************************************/
/****    sound timer system                                                             ****/
/*******************************************************************************************/
/************************************/
/*    sound timer callback          */
/************************************/
void saSoundTimerCallback( void ){
  sound_slice++;
  if( sound_slice >= DEF_SOUND_SLICE_BASE ){
    sound_slice = 0;
    sound_icount = 0;		/* sound interval counter clear */
    saCheckPlayStream();
    sound_freerun_count++;
#ifdef __RAINE__
#ifdef RDTSC_PROFILE
    if(raine_cfg.show_fps_mode>2) ProfileStart(ProfileSound);
#endif
#endif
    saUpdateSoundTimer(); /* check update stream buffer */
#ifdef __RAINE__
#ifdef RDTSC_PROFILE
    if(raine_cfg.show_fps_mode>2) ProfileStop(ProfileSound);
#endif
#endif
  }
}
END_OF_FUNCTION( saSoundTimerCallback );

/************************************/
/*    install timer                 */
/************************************/
static int  first_int_install = 0;
void saInitSoundTimer( void ){
  LOCK_VARIABLE( sound_icount );
  LOCK_VARIABLE( sound_freerun_count );
  LOCK_VARIABLE( sound_slice );
  LOCK_FUNCTION ( saSoundTimerCallback );
  if( !first_int_install ){
    install_int_ex( saSoundTimerCallback, BPS_TO_TIMER(DEF_SOUND_SLICE_COUNT) );
    first_int_install = 1;
  }
  sound_freerun_count = 0;
  sound_slice = 0;
  sound_icount = 0;
}  

/************************************/
/*    remove timer                  */
/************************************/
void saRemoveSoundTimer( void ){
  if( first_int_install ){
    remove_int( saSoundTimerCallback );
    first_int_install = 0;
  }
}

/*******************************************************************************************/
/****    stream update system                                                           ****/
/*******************************************************************************************/
/*******************************************/
/*    set Sound CPU base time (1/60sec)    */
/*******************************************/
static double (*calc_time)( void );
void saSetSoundCPUClock( double (*func)( void ) ){
  calc_time = func;
}
/*******************************************/
/*    get Sound CPU time                   */
/*******************************************/
double saGetSoundCPUTime( void ){
  if( calc_time != NULL ){
    return (double)calc_time();
  }
  return (double)0;
}

/**************** end of file ****************/
