/********************************************************/
/*    Sound control linrary version 0.16                */
/*        programed by Hiro-shi (Hiromitsu Shioya)      */
/*    note: see top of sasound.c                        */
/********************************************************/

#ifndef __SASOUND_H__
#define __SASOUND_H__

//#include <stdio.h>
//#include <stdlib.h>
#include "deftypes.h"


#define OSD_PAN_CENTER 0x80
#define OSD_PAN_LEFT   0x00
#define OSD_PAN_RIGHT  0xff


#ifndef INLINE
#define INLINE inline
#endif

#ifdef __MEKA_SOUND__
#define INSTALL_CALC_SOUNDCPU_CLOCK
#endif

//#define USE_MAME_RCFILTER

/* audio related stuff */
#define MAX_STREAM_CHANNELS 16

#define    NUMVOICES    (MAX_STREAM_CHANNELS)

#define DEF_STREAM_BUFFER_MAXA   (3)
#define DEF_MODEB_FRAME_SIZE   (60)
#define DEF_MODEB_UPDATE_COUNT   (4)
#define DEF_STREAM_BUFFER_MAXB   ((DEF_FRAME_SIZE/DEF_MODEB_UPDATE_COUNT))
#define DEF_STREAM_UPDATE_ERROR_MAX   (16) /* error wait is 16 counts. */

#define  VOLUME_MAX     (255)


int STREAM_BUFFER_MAXA;
int STREAM_BUFFER_MAXB;
int MODEB_UPDATE_COUNT;
int MODEB_FRAME_SIZE;
int MODEB_MASK;
int MODEB_ERROR_MAX;
int SampleModebTimer;

typedef struct ADSAMPLE                  /* a sample */
{
   int bits;                           /* 8 or 16 */
   int stereo;                         /* sample type flag */
   int freq;                           /* sample frequency */
   int priority;                       /* 0-255 */
   unsigned long len;                  /* length (in samples) */
   unsigned long loop_start;           /* loop start position */
   unsigned long loop_end;             /* loop finish position */
   unsigned long param;                /* for internal use by the driver */
   void *data;                         /* sample data */
} ADSAMPLE;
ADSAMPLE SampleList[256];
int SampleCount;

void AddSampleADPCM(int start, int end, UBYTE *SOURCE);
void AddSampleListADPCM(int start, int end, UBYTE *SOURCE);
void SetSampleDest(int start, UBYTE *DEST);

void AddSample8Bit(int start, int end, UBYTE *SOURCE);

int RaineSoundCardTotal;
int RaineSoundCard;

/**** add hiro-shi 10/30/98 ****/
int DariusStereo;

int change_sample_rate;
extern int    SealInitFlag;
extern int    SampleRate, audio_sample_rate;
extern int soundcardnum;
extern int sound_stream_mode;

extern int    vchan[NUMVOICES];
extern int    ventry[NUMVOICES];
extern int    vbover_err, vbunder_err;

enum {
  SOUND_STREAM_WAIT = 0,
  SOUND_STREAM_OLDTYPE,
  SOUND_STREAM_TIMER,

  SOUND_STREAM_MODE_ERROR
};

#define   SND_CONTROL_MAX   (3)

typedef struct soundrec{
  int  first;
  int  sound_timing;		/* 60 / sound_timing Hz */
  int  sound_timingmax;
  int  sound_count, sound_countmax;
  int  init[SND_CONTROL_MAX];
  void (*update[SND_CONTROL_MAX])( void );
  void (*stopfunc[SND_CONTROL_MAX])( void );
  void *intf[SND_CONTROL_MAX];
  int  control_max;
}SoundRec;

typedef struct soundrecentry{
  int sync;
  int count;
  int  init;
  void (*update)( void );
  void (*stop)( void );
  void *intf;
}SoundRecEntry;

enum inittype{
  SOUND_YM2203 = 0,
  SOUND_YM2151S,
  SOUND_YM2151J,
  SOUND_YM2610,
  SOUND_YM2610B,
  SOUND_MSM5205,
  SOUND_M6295,
  SOUND_PSG,
  SOUND_YM3812,
  SOUND_SN76496,
  SOUND_YM2413Hard
};

extern SoundRec      *SndMachine, snd_entry, *nowSndRec;

/**** osd ???? ****/
int get_play_channels( int request );
void reset_play_channels(void);
void osd_play_streamed_sample(int channel,signed char *data,int len,int freq,int volume);
void osd_play_streamed_sample_16(int channel,signed short *data,int len,int freq,int volume);
void osd_play_streamed_sample2(int channel,signed char *data,int len,int freq,int volume, int pan);
void osd_play_streamed_sample2_16(int channel,signed short *data,int len,int freq,int volume, int pan);
void osd_ym2203_update(void);

/**** prottype ****/
void saCheckPlayStream( void );
void saCheckPlayStreamOld( void ); /* old type : raine/sample.c */

inline void saUpdateSound( int nowclock );
int saGetSoundCard( int soundcard );
BOOL saInitSoundCard( int soundcard, int buffer_mode, int sample_rate );
void saSetupSound( SoundRecEntry *rec );
void saAddSound( SoundRecEntry *rec );
void saDestroySound( int mode );
void saRemoveSound( void );
void saStopSoundEmulators(void);

void saPlayBufferedStreamedSampleBase( int channel, signed char *data, int len, int freq, int volume, int bits , int pan );
void saPlayBufferedStreamedSampleBaseOld( int channel, signed char *data, int len, int freq, int volume, int bits , int pan );

void saPlayStreamedSampleBase( int channel, signed char *data, int len, int freq, int volume, int bits , int pan );
void saPlayStreamedSample16( int channel, signed short *data, int len, int freq, int volume );
void saPlayStreamedSample16Pan( int channel, signed short *data, int len, int freq, int volume, int pan );
void saPlaySampleBase( int channel, signed char *data, int len, int freq, int volume, int loop, int bits );
void saPlaySample8(int channel,signed char *data,int len,int freq,int volume,int loop);
void saPlaySample16(int channel,signed short *data,int len,int freq,int volume,int loop);

void saStopSample(int channel);

int saGetPlayChannels( int request );
void saResetPlayChannels( void );

char *sound_card_name( int num );

void sa_pause_sound(void);
void sa_unpause_sound(void);

/**** streams control (base:mame 0.34b6) ****/
int streams_sh_start(void);
void streams_sh_stop(void);
void streams_sh_update(void);

int stream_init(const char *name,int sample_rate,int sample_bits,int param,void (*callback)(int param,void *buffer,int length));
int stream_init_multi(int channels,const char **name,int sample_rate,int sample_bits,int param,void (*callback)(int param,void **buffer,int length));
void stream_update(int channel,int min_interval);	/* min_interval is in usec */
void stream_set_volume(int channel,int volume);
int stream_get_volume(int channel);
void stream_set_pan(int channel,int pan);
const char *stream_get_name(int channel);

/**** volume/pan control (TAITO) ****/
#define  WRITE_PAN    (0x8000)

#define  VOL_PAN_MAX    (MAX_STREAM_CHANNELS)
int SampleVol[VOL_PAN_MAX];
int SamplePan[VOL_PAN_MAX];

void saInitVolPan( void );
void saSetVolume( int num, int data );
void saSetPan( int num, int data );
void saSetVolumeNolimit( int num, int data );
void saSetVolumeMuli( int num, int data );
void saSetPanMulti( int num, int data );
void saSetVolumeMuliNolimit( int num, int data );

int ChannelActive(int ch);

void saStopSample(int channel);		// Stop channel

/**** new!! sound timer system ****/
#define DEF_SOUND_BASE     (60)	/* 1/60 sec */
//#define DEF_SOUND_SLICE_BASE  (300)
#define DEF_SOUND_SLICE_BASE  (1)
#define DEF_SOUND_SLICE_COUNT    (DEF_SOUND_BASE * DEF_SOUND_SLICE_BASE)

/**** work ****/
int sound_freerun_count;
int sound_slice;
int sound_icount;

/**** prototype ****/
void saInitSoundTimer( void );
void saRemoveSoundTimer( void );
void saSetSoundCPUClock( double (*func)( void ) );
double saGetSoundCPUTime( void );

/**** meka add work/defines ****/
#ifdef __MEKA_SOUND__
int GameSound;			/* Raine:sound card number */
int PauseGame;			/* Raine:0=pause off 1~=pause on */
#endif

unsigned int  BaseSb;
unsigned int  DelayReg;
unsigned int  DelayData;


/**** pcm support ****/
#ifdef __RAINE__
int ProfileSound;
UBYTE *YM2610_Rompointers[2];
ULONG YM2610_Romsizes[2];
UBYTE *PCMROM;			/* hiro-shi */
#endif

/************************************************/
/*    include some headers                      */
/************************************************/
#define HAS_YM2203  1
#define HAS_YM2151  1
#define HAS_YM2610  1

#ifdef __RAINE__
#include "ay8910.h"
#include "2203intf.h"		// Renamed!
#include "2151intf.h"
#include "2610intf.h"
#include "msm5205.h"
#include "m6295.h"
#endif

#include "3812intf.h"

#ifdef __MEKA_SOUND__
#include "sn76496.h"
#include "ym2413hd.h"
#endif

#endif
/**************** end of file ****************/
