; For assembly by NASM only
bits 32

; Theory of operation

; EDI=General purpose
; ESI=Program counter + base address
; EBP=mz80Base
; AX=AF
; BX=HL
; CX=BC
; DX=General purpose

; Using stack calling conventions
; Extended input/output instructions treat (C) as I/O address


		section	.data

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

		global	_mz80contextBegin
_mz80contextBegin:
		global	_z80pc
		global	z80pc_
		global	z80pc
		global	z80Base
		global	_z80nmiAddr
		global	_z80intAddr

; DO NOT CHANGE THE ORDER OF AF, BC, DE, HL and THE PRIME REGISTERS!

z80Base	dd	0	; Base address for Z80 stuff
_z80MemRead	dd	0	; Offset of memory read structure array
_z80MemWrite	dd	0	; Offset of memory write structure array
_z80IoRead	dd	0	; Base address for I/O reads list
_z80IoWrite	dd	0	; Base address for I/O write list
_z80clockticks	dd	0	; # Of clock tips that have elapsed
_z80inInterrupt	dd	0	; Non-zero if we're in an interrupt
_z80interruptMode dd	0	; Interrupt mode
_z80interruptState	dd	0	; What state is our interrupt in?
_z80halted	dd	0	; 0=Not halted, 1=Halted
_z80af		dw	0	; A Flag & Flags
_z80bc		dw	0	; BC
_z80de		dw	0	; DE
_z80hl		dw	0	; HL
_z80afprime	dw	0	; A Flag & Flags prime
_z80bcprime	dw	0	; BC prime
_z80deprime	dw	0	; DE prime
_z80hlprime	dw	0	; HL prime

; The order of the following registers can be changed without adverse
; effect. Keep the WORD and DWORDs on boundaries of two for faster access

_z80ix		dw	0	; IX
_z80iy		dw	0	; IY
_z80sp		dw	0	; Stack pointer
z80pc:
z80pc_:
_z80pc		dw	0	; PC
_z80nmiAddr	dw	0	; Address to jump to for NMI
_z80intAddr	dw	0	; Address to jump to for INT
_z80i		db	0	; I register
_z80r		db	0	; R register

_mz80contextEnd:

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

dwElapsedTicks	dd	0	; # Of ticks elapsed
cyclesRemaining	dd	0	; # Of cycles remaining
dwOriginalExec	dd	0	; # Of cycles originally executing
_orgval	dw	0	; Scratch area
_orgval2	dw	0	; Scratch area
_wordval	dw	0	; Scratch area
_baseFixup	dd	0	; Our base fixup for when we're out of time
_z80stoponintend	dd	0	; int patch


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

z80regular:
		dd	RegInst00
		dd	RegInst01
		dd	RegInst02
		dd	RegInst03
		dd	RegInst04
		dd	RegInst05
		dd	RegInst06
		dd	RegInst07
		dd	RegInst08
		dd	RegInst09
		dd	RegInst0a
		dd	RegInst0b
		dd	RegInst0c
		dd	RegInst0d
		dd	RegInst0e
		dd	RegInst0f
		dd	RegInst10
		dd	RegInst11
		dd	RegInst12
		dd	RegInst13
		dd	RegInst14
		dd	RegInst15
		dd	RegInst16
		dd	RegInst17
		dd	RegInst18
		dd	RegInst19
		dd	RegInst1a
		dd	RegInst1b
		dd	RegInst1c
		dd	RegInst1d
		dd	RegInst1e
		dd	RegInst1f
		dd	RegInst20
		dd	RegInst21
		dd	RegInst22
		dd	RegInst23
		dd	RegInst24
		dd	RegInst25
		dd	RegInst26
		dd	RegInst27
		dd	RegInst28
		dd	RegInst29
		dd	RegInst2a
		dd	RegInst2b
		dd	RegInst2c
		dd	RegInst2d
		dd	RegInst2e
		dd	RegInst2f
		dd	RegInst30
		dd	RegInst31
		dd	RegInst32
		dd	RegInst33
		dd	RegInst34
		dd	RegInst35
		dd	RegInst36
		dd	RegInst37
		dd	RegInst38
		dd	RegInst39
		dd	RegInst3a
		dd	RegInst3b
		dd	RegInst3c
		dd	RegInst3d
		dd	RegInst3e
		dd	RegInst3f
		dd	RegInst40
		dd	RegInst41
		dd	RegInst42
		dd	RegInst43
		dd	RegInst44
		dd	RegInst45
		dd	RegInst46
		dd	RegInst47
		dd	RegInst48
		dd	RegInst49
		dd	RegInst4a
		dd	RegInst4b
		dd	RegInst4c
		dd	RegInst4d
		dd	RegInst4e
		dd	RegInst4f
		dd	RegInst50
		dd	RegInst51
		dd	RegInst52
		dd	RegInst53
		dd	RegInst54
		dd	RegInst55
		dd	RegInst56
		dd	RegInst57
		dd	RegInst58
		dd	RegInst59
		dd	RegInst5a
		dd	RegInst5b
		dd	RegInst5c
		dd	RegInst5d
		dd	RegInst5e
		dd	RegInst5f
		dd	RegInst60
		dd	RegInst61
		dd	RegInst62
		dd	RegInst63
		dd	RegInst64
		dd	RegInst65
		dd	RegInst66
		dd	RegInst67
		dd	RegInst68
		dd	RegInst69
		dd	RegInst6a
		dd	RegInst6b
		dd	RegInst6c
		dd	RegInst6d
		dd	RegInst6e
		dd	RegInst6f
		dd	RegInst70
		dd	RegInst71
		dd	RegInst72
		dd	RegInst73
		dd	RegInst74
		dd	RegInst75
		dd	RegInst76
		dd	RegInst77
		dd	RegInst78
		dd	RegInst79
		dd	RegInst7a
		dd	RegInst7b
		dd	RegInst7c
		dd	RegInst7d
		dd	RegInst7e
		dd	RegInst7f
		dd	RegInst80
		dd	RegInst81
		dd	RegInst82
		dd	RegInst83
		dd	RegInst84
		dd	RegInst85
		dd	RegInst86
		dd	RegInst87
		dd	RegInst88
		dd	RegInst89
		dd	RegInst8a
		dd	RegInst8b
		dd	RegInst8c
		dd	RegInst8d
		dd	RegInst8e
		dd	RegInst8f
		dd	RegInst90
		dd	RegInst91
		dd	RegInst92
		dd	RegInst93
		dd	RegInst94
		dd	RegInst95
		dd	RegInst96
		dd	RegInst97
		dd	RegInst98
		dd	RegInst99
		dd	RegInst9a
		dd	RegInst9b
		dd	RegInst9c
		dd	RegInst9d
		dd	RegInst9e
		dd	RegInst9f
		dd	RegInsta0
		dd	RegInsta1
		dd	RegInsta2
		dd	RegInsta3
		dd	RegInsta4
		dd	RegInsta5
		dd	RegInsta6
		dd	RegInsta7
		dd	RegInsta8
		dd	RegInsta9
		dd	RegInstaa
		dd	RegInstab
		dd	RegInstac
		dd	RegInstad
		dd	RegInstae
		dd	RegInstaf
		dd	RegInstb0
		dd	RegInstb1
		dd	RegInstb2
		dd	RegInstb3
		dd	RegInstb4
		dd	RegInstb5
		dd	RegInstb6
		dd	RegInstb7
		dd	RegInstb8
		dd	RegInstb9
		dd	RegInstba
		dd	RegInstbb
		dd	RegInstbc
		dd	RegInstbd
		dd	RegInstbe
		dd	RegInstbf
		dd	RegInstc0
		dd	RegInstc1
		dd	RegInstc2
		dd	RegInstc3
		dd	RegInstc4
		dd	RegInstc5
		dd	RegInstc6
		dd	RegInstc7
		dd	RegInstc8
		dd	RegInstc9
		dd	RegInstca
		dd	RegInstcb
		dd	RegInstcc
		dd	RegInstcd
		dd	RegInstce
		dd	RegInstcf
		dd	RegInstd0
		dd	RegInstd1
		dd	RegInstd2
		dd	RegInstd3
		dd	RegInstd4
		dd	RegInstd5
		dd	RegInstd6
		dd	RegInstd7
		dd	RegInstd8
		dd	RegInstd9
		dd	RegInstda
		dd	RegInstdb
		dd	RegInstdc
		dd	RegInstdd
		dd	RegInstde
		dd	RegInstdf
		dd	RegInste0
		dd	RegInste1
		dd	RegInste2
		dd	RegInste3
		dd	RegInste4
		dd	RegInste5
		dd	RegInste6
		dd	RegInste7
		dd	RegInste8
		dd	RegInste9
		dd	RegInstea
		dd	RegInsteb
		dd	RegInstec
		dd	RegInsted
		dd	RegInstee
		dd	RegInstef
		dd	RegInstf0
		dd	RegInstf1
		dd	RegInstf2
		dd	RegInstf3
		dd	RegInstf4
		dd	RegInstf5
		dd	RegInstf6
		dd	RegInstf7
		dd	RegInstf8
		dd	RegInstf9
		dd	RegInstfa
		dd	RegInstfb
		dd	RegInstfc
		dd	RegInstfd
		dd	RegInstfe
		dd	RegInstff

z80PrefixCB:
		dd	CBInst00
		dd	CBInst01
		dd	CBInst02
		dd	CBInst03
		dd	CBInst04
		dd	CBInst05
		dd	CBInst06
		dd	CBInst07
		dd	CBInst08
		dd	CBInst09
		dd	CBInst0a
		dd	CBInst0b
		dd	CBInst0c
		dd	CBInst0d
		dd	CBInst0e
		dd	CBInst0f
		dd	CBInst10
		dd	CBInst11
		dd	CBInst12
		dd	CBInst13
		dd	CBInst14
		dd	CBInst15
		dd	CBInst16
		dd	CBInst17
		dd	CBInst18
		dd	CBInst19
		dd	CBInst1a
		dd	CBInst1b
		dd	CBInst1c
		dd	CBInst1d
		dd	CBInst1e
		dd	CBInst1f
		dd	CBInst20
		dd	CBInst21
		dd	CBInst22
		dd	CBInst23
		dd	CBInst24
		dd	CBInst25
		dd	CBInst26
		dd	CBInst27
		dd	CBInst28
		dd	CBInst29
		dd	CBInst2a
		dd	CBInst2b
		dd	CBInst2c
		dd	CBInst2d
		dd	CBInst2e
		dd	CBInst2f
		dd	CBInst30
		dd	CBInst31
		dd	CBInst32
		dd	CBInst33
		dd	CBInst34
		dd	CBInst35
		dd	CBInst36
		dd	CBInst37
		dd	CBInst38
		dd	CBInst39
		dd	CBInst3a
		dd	CBInst3b
		dd	CBInst3c
		dd	CBInst3d
		dd	CBInst3e
		dd	CBInst3f
		dd	CBInst40
		dd	CBInst41
		dd	CBInst42
		dd	CBInst43
		dd	CBInst44
		dd	CBInst45
		dd	CBInst46
		dd	CBInst47
		dd	CBInst48
		dd	CBInst49
		dd	CBInst4a
		dd	CBInst4b
		dd	CBInst4c
		dd	CBInst4d
		dd	CBInst4e
		dd	CBInst4f
		dd	CBInst50
		dd	CBInst51
		dd	CBInst52
		dd	CBInst53
		dd	CBInst54
		dd	CBInst55
		dd	CBInst56
		dd	CBInst57
		dd	CBInst58
		dd	CBInst59
		dd	CBInst5a
		dd	CBInst5b
		dd	CBInst5c
		dd	CBInst5d
		dd	CBInst5e
		dd	CBInst5f
		dd	CBInst60
		dd	CBInst61
		dd	CBInst62
		dd	CBInst63
		dd	CBInst64
		dd	CBInst65
		dd	CBInst66
		dd	CBInst67
		dd	CBInst68
		dd	CBInst69
		dd	CBInst6a
		dd	CBInst6b
		dd	CBInst6c
		dd	CBInst6d
		dd	CBInst6e
		dd	CBInst6f
		dd	CBInst70
		dd	CBInst71
		dd	CBInst72
		dd	CBInst73
		dd	CBInst74
		dd	CBInst75
		dd	CBInst76
		dd	CBInst77
		dd	CBInst78
		dd	CBInst79
		dd	CBInst7a
		dd	CBInst7b
		dd	CBInst7c
		dd	CBInst7d
		dd	CBInst7e
		dd	CBInst7f
		dd	CBInst80
		dd	CBInst81
		dd	CBInst82
		dd	CBInst83
		dd	CBInst84
		dd	CBInst85
		dd	CBInst86
		dd	CBInst87
		dd	CBInst88
		dd	CBInst89
		dd	CBInst8a
		dd	CBInst8b
		dd	CBInst8c
		dd	CBInst8d
		dd	CBInst8e
		dd	CBInst8f
		dd	CBInst90
		dd	CBInst91
		dd	CBInst92
		dd	CBInst93
		dd	CBInst94
		dd	CBInst95
		dd	CBInst96
		dd	CBInst97
		dd	CBInst98
		dd	CBInst99
		dd	CBInst9a
		dd	CBInst9b
		dd	CBInst9c
		dd	CBInst9d
		dd	CBInst9e
		dd	CBInst9f
		dd	CBInsta0
		dd	CBInsta1
		dd	CBInsta2
		dd	CBInsta3
		dd	CBInsta4
		dd	CBInsta5
		dd	CBInsta6
		dd	CBInsta7
		dd	CBInsta8
		dd	CBInsta9
		dd	CBInstaa
		dd	CBInstab
		dd	CBInstac
		dd	CBInstad
		dd	CBInstae
		dd	CBInstaf
		dd	CBInstb0
		dd	CBInstb1
		dd	CBInstb2
		dd	CBInstb3
		dd	CBInstb4
		dd	CBInstb5
		dd	CBInstb6
		dd	CBInstb7
		dd	CBInstb8
		dd	CBInstb9
		dd	CBInstba
		dd	CBInstbb
		dd	CBInstbc
		dd	CBInstbd
		dd	CBInstbe
		dd	CBInstbf
		dd	CBInstc0
		dd	CBInstc1
		dd	CBInstc2
		dd	CBInstc3
		dd	CBInstc4
		dd	CBInstc5
		dd	CBInstc6
		dd	CBInstc7
		dd	CBInstc8
		dd	CBInstc9
		dd	CBInstca
		dd	CBInstcb
		dd	CBInstcc
		dd	CBInstcd
		dd	CBInstce
		dd	CBInstcf
		dd	CBInstd0
		dd	CBInstd1
		dd	CBInstd2
		dd	CBInstd3
		dd	CBInstd4
		dd	CBInstd5
		dd	CBInstd6
		dd	CBInstd7
		dd	CBInstd8
		dd	CBInstd9
		dd	CBInstda
		dd	CBInstdb
		dd	CBInstdc
		dd	CBInstdd
		dd	CBInstde
		dd	CBInstdf
		dd	CBInste0
		dd	CBInste1
		dd	CBInste2
		dd	CBInste3
		dd	CBInste4
		dd	CBInste5
		dd	CBInste6
		dd	CBInste7
		dd	CBInste8
		dd	CBInste9
		dd	CBInstea
		dd	CBInsteb
		dd	CBInstec
		dd	CBInsted
		dd	CBInstee
		dd	CBInstef
		dd	CBInstf0
		dd	CBInstf1
		dd	CBInstf2
		dd	CBInstf3
		dd	CBInstf4
		dd	CBInstf5
		dd	CBInstf6
		dd	CBInstf7
		dd	CBInstf8
		dd	CBInstf9
		dd	CBInstfa
		dd	CBInstfb
		dd	CBInstfc
		dd	CBInstfd
		dd	CBInstfe
		dd	CBInstff

z80PrefixED:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst40
		dd	EDInst41
		dd	EDInst42
		dd	EDInst43
		dd	EDInst44
		dd	EDInst45
		dd	EDInst46
		dd	EDInst47
		dd	EDInst48
		dd	EDInst49
		dd	EDInst4a
		dd	EDInst4b
		dd	invalidInsWord
		dd	EDInst4d
		dd	invalidInsWord
		dd	EDInst4f
		dd	EDInst50
		dd	EDInst51
		dd	EDInst52
		dd	EDInst53
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst56
		dd	EDInst57
		dd	EDInst58
		dd	EDInst59
		dd	EDInst5a
		dd	EDInst5b
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst5e
		dd	EDInst5f
		dd	EDInst60
		dd	EDInst61
		dd	EDInst62
		dd	EDInst63
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst67
		dd	EDInst68
		dd	EDInst69
		dd	EDInst6a
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst6f
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst72
		dd	EDInst73
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInst78
		dd	EDInst79
		dd	EDInst7a
		dd	EDInst7b
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInsta0
		dd	EDInsta1
		dd	EDInsta2
		dd	EDInsta3
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInsta8
		dd	EDInsta9
		dd	EDInstaa
		dd	EDInstab
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInstb0
		dd	EDInstb1
		dd	EDInstb2
		dd	EDInstb3
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	EDInstb8
		dd	EDInstb9
		dd	EDInstba
		dd	EDInstbb
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord

z80PrefixDD:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst09
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst19
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst21
		dd	DDInst22
		dd	DDInst23
		dd	DDInst24
		dd	DDInst25
		dd	DDInst26
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst29
		dd	DDInst2a
		dd	DDInst2b
		dd	DDInst2c
		dd	DDInst2d
		dd	DDInst2e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst34
		dd	DDInst35
		dd	DDInst36
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst39
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst44
		dd	DDInst45
		dd	DDInst46
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst4c
		dd	DDInst4d
		dd	DDInst4e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst54
		dd	DDInst55
		dd	DDInst56
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst5c
		dd	DDInst5d
		dd	DDInst5e
		dd	invalidInsWord
		dd	DDInst60
		dd	DDInst61
		dd	DDInst62
		dd	DDInst63
		dd	DDInst64
		dd	DDInst65
		dd	DDInst66
		dd	DDInst67
		dd	DDInst68
		dd	DDInst69
		dd	DDInst6a
		dd	DDInst6b
		dd	DDInst6c
		dd	DDInst6d
		dd	DDInst6e
		dd	DDInst6f
		dd	DDInst70
		dd	DDInst71
		dd	DDInst72
		dd	DDInst73
		dd	DDInst74
		dd	DDInst75
		dd	invalidInsWord
		dd	DDInst77
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst7c
		dd	DDInst7d
		dd	DDInst7e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst84
		dd	DDInst85
		dd	DDInst86
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst8c
		dd	DDInst8d
		dd	DDInst8e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst94
		dd	DDInst95
		dd	DDInst96
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInst9c
		dd	DDInst9d
		dd	DDInst9e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInsta4
		dd	DDInsta5
		dd	DDInsta6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstac
		dd	DDInstad
		dd	DDInstae
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstb4
		dd	DDInstb5
		dd	DDInstb6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstbc
		dd	DDInstbd
		dd	DDInstbe
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstcb
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInste1
		dd	invalidInsWord
		dd	DDInste3
		dd	invalidInsWord
		dd	DDInste5
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInste9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDInstf9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord

z80PrefixFD:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst09
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst19
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst21
		dd	FDInst22
		dd	FDInst23
		dd	FDInst24
		dd	FDInst25
		dd	FDInst26
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst29
		dd	FDInst2a
		dd	FDInst2b
		dd	FDInst2c
		dd	FDInst2d
		dd	FDInst2e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst34
		dd	FDInst35
		dd	FDInst36
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst39
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst44
		dd	FDInst45
		dd	FDInst46
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst4c
		dd	FDInst4d
		dd	FDInst4e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst54
		dd	FDInst55
		dd	FDInst56
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst5c
		dd	FDInst5d
		dd	FDInst5e
		dd	invalidInsWord
		dd	FDInst60
		dd	FDInst61
		dd	FDInst62
		dd	FDInst63
		dd	FDInst64
		dd	FDInst65
		dd	FDInst66
		dd	FDInst67
		dd	FDInst68
		dd	FDInst69
		dd	FDInst6a
		dd	FDInst6b
		dd	FDInst6c
		dd	FDInst6d
		dd	FDInst6e
		dd	FDInst6f
		dd	FDInst70
		dd	FDInst71
		dd	FDInst72
		dd	FDInst73
		dd	FDInst74
		dd	FDInst75
		dd	invalidInsWord
		dd	FDInst77
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst7c
		dd	FDInst7d
		dd	FDInst7e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst84
		dd	FDInst85
		dd	FDInst86
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst8c
		dd	FDInst8d
		dd	FDInst8e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst94
		dd	FDInst95
		dd	FDInst96
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInst9c
		dd	FDInst9d
		dd	FDInst9e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInsta4
		dd	FDInsta5
		dd	FDInsta6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstac
		dd	FDInstad
		dd	FDInstae
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstb4
		dd	FDInstb5
		dd	FDInstb6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstbc
		dd	FDInstbd
		dd	FDInstbe
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstcb
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInste1
		dd	invalidInsWord
		dd	FDInste3
		dd	invalidInsWord
		dd	FDInste5
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInste9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	FDInstf9
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
z80ddfdcbInstructions:
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst06
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst0e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst16
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst1e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst26
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst2e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst3e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst46
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst4e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst56
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst5e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst66
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst6e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst76
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst7e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst86
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst8e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst96
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInst9e
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInsta6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstae
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstb6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstbe
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstc6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstce
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstd6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstde
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInste6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstee
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstf6
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	invalidInsWord
		dd	DDFDCBInstfe
		dd	invalidInsWord

		section	.text

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst00:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst01:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	cx, [esi]	; Get our immediate value of BC
		add	esi, 2
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst02:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop0:
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr0	; Yes... go to the next addr
		cmp	cx, [edi+4]	; Are we smaller?
		jbe	callRoutine0	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite0	; Yes - go write it!
nextAddr0:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop0

callRoutine0:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite0
memoryWrite0:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ecx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit0
callWrite0:
		mov	dx, cx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit0:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst03:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	cx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst04:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst05:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst06:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	ch, [esi]	; Get our immediate value
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst07:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		rol	al, 1
		lahf
		and	ah, 0edh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst08:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		xchg	ah, al
		xchg	ax, [_z80afprime]
		xchg	ah, al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst09:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, cx
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, cx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0a:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop1:
		cmp	cx, [edi]		; Are we smaller?
		jb	nextAddr1		; Yes, go to the next address
		cmp	cx, [edi+4]		; Are we bigger?
		jbe	callRoutine1

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead1
nextAddr1:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop1

callRoutine1:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead1
memoryRead1:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	al, [edi + ecx]	; Get our data

		jmp	short readExit1

callRead1:
		mov	dx, cx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
readExit1:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	cx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	cl, [esi]	; Get our immediate value
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst0f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		ror	al, 1
		lahf
		and	ah, 0edh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst10:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 8
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		dec	ch	; Decrement B
		jz	noJump	; Don't take the jump if it's done!
; Otherwise, take the jump
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
noJump:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst11:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	di, [esi]	; Get our immediate value of DE
		mov	word [_z80de], di ; Store DE
		add	esi, 2
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst12:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop2:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr2	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine2	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite2	; Yes - go write it!
nextAddr2:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop2

callRoutine2:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite2
memoryWrite2:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit2
callWrite2:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit2:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst13:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	word [_z80de]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst14:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst15:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst16:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi]	; Get our immediate value
		mov	byte [_z80de + 1], dl	; Store our new value
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst17:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		rcl	al, 1
		lahf
		and	ah, 0edh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst18:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		cmp	dl, 0feh	; Jump to self?
		je		yesJrMan	; Yup! Bail out!
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan3:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

yesJrMan:
		mov	edx, [cyclesRemaining]	; Get # of cycles remaining
		inc	edx		; Make it a little longer
		add	[dwElapsedTicks], edx	; Elapse it!
		xor	edx, edx		; Zero me for later
		mov	[cyclesRemaining], edx
		dec	esi		; Back up one
		jmp	noMoreExec


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst19:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, word [_z80de]
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, word [_z80de]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1a:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dx, [_z80de]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop4:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr4		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine4

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead4
nextAddr4:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop4

callRoutine4:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead4
memoryRead4:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	al, [edi + edx]	; Get our data

		jmp	short readExit4

callRead4:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
readExit4:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	word [_z80de]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi]	; Get our immediate value
		mov	byte [_z80de], dl	; Store our new value
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst1f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		rcr	al, 1
		lahf
		and	ah, 0edh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst20:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jnz	takeJump5
		jmp	short noJumpMan5
takeJump5:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan5:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst21:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	bx, [esi]	; Get our immediate value of HL
		add	esi, 2
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst22:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 16
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop6:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr6	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine6	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite6	; Yes - go write it!
nextAddr6:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop6

callRoutine6:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite6
memoryWrite6:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit6
callWrite6:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit6:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop7:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr7	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine7	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite7	; Yes - go write it!
nextAddr7:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop7

callRoutine7:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite7
memoryWrite7:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit7
callWrite7:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit7:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst23:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	bx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst24:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst25:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst26:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	bh, [esi]	; Get our immediate value
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst27:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dh, ah
		and	dh, 02ah
		test	ah, 02h	; Were we doing a subtraction?
		jnz	handleNeg ; Nope!
		sahf
		daa
		lahf
		jmp	short endDaa
handleNeg:
		sahf
		das
		lahf
endDaa:
		and	ah, 0d5h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst28:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jz	takeJump8
		jmp	short noJumpMan8
takeJump8:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan8:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst29:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, bx
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, bx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2a:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 16
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop9:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr9		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine9

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead9
nextAddr9:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop9

callRoutine9:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead9
memoryRead9:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bl, [edi + edx]	; Get our data

		jmp	short readExit9

callRead9:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit9:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop10:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr10		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine10

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead10
nextAddr10:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop10

callRoutine10:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead10
memoryRead10:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bh, [edi + edx]	; Get our data

		jmp	short readExit10

callRead10:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit10:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	bx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	bl, [esi]	; Get our immediate value
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst2f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		not	al
		or	ah, 012h	; N And H are now on!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst30:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jnc	takeJump11
		jmp	short noJumpMan11
takeJump11:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan11:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst31:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	di, [esi]	; Get our immediate value of SP
		mov	word [_z80sp], di	; Store it!
		add	esi, 2
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst32:
		sub	dword [cyclesRemaining], byte 13
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 13
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop12:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr12	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine12	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite12	; Yes - go write it!
nextAddr12:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop12

callRoutine12:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite12
memoryWrite12:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit12
callWrite12:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit12:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst33:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		inc	word [_z80sp]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst34:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop13:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr13		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine13

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead13
nextAddr13:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop13

callRoutine13:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead13
memoryRead13:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit13

callRead13:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit13:
		sahf
		inc	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		shr	edx, 16
		and	ah, 0fdh	; Knock out N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop14:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr14	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine14	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite14	; Yes - go write it!
nextAddr14:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop14

callRoutine14:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite14
memoryWrite14:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit14
callWrite14:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit14:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst35:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop15:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr15		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine15

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead15
nextAddr15:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop15

callRoutine15:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead15
memoryRead15:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit15

callRead15:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit15:
		sahf
		dec	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		shr	edx, 16
		or		ah, 02h	; Make it N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop16:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr16	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine16	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite16	; Yes - go write it!
nextAddr16:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop16

callRoutine16:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite16
memoryWrite16:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit16
callWrite16:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit16:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst36:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	[_z80af], ax	; Store AF
		mov	al, [esi]	; And our data to write
		inc	esi	; Increment our program counter
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop17:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr17	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine17	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite17	; Yes - go write it!
nextAddr17:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop17

callRoutine17:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite17
memoryWrite17:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], al		; Store our direct value
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit17
callWrite17:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit17:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst37:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		or	ah, 1
		and	ah,0edh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst38:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	dl, [esi] ; Get our relative offset
		inc	esi	; Next instruction, please!
		sahf
		jc	takeJump18
		jmp	short noJumpMan18
takeJump18:
		add	dword [dwElapsedTicks], 5
		sub	dword [cyclesRemaining], 5
		xchg	ax, dx
		cbw
		xchg	ax, dx
		sub	esi, ebp
		add	si, dx
		add	esi, ebp
		xor	dh, dh
noJumpMan18:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst39:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	[_orgval], bx	; Store our original value
		add	bx, word [_z80sp]
		lahf
		mov	di, [_orgval]	; Get original
		xor	di, bx ; XOR It with our computed value
		xor	di, word [_z80sp]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3a:
		sub	dword [cyclesRemaining], byte 13
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 13
		mov	dx, [esi]	; Get our address
		add	esi, 2		; Skip past the address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop19:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr19		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine19

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead19
nextAddr19:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop19

callRoutine19:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead19
memoryRead19:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	al, [edi + edx]	; Get our data

		jmp	short readExit19

callRead19:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
readExit19:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3b:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		dec	word [_z80sp]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		inc	al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		dec	al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	al, [esi]	; Get our immediate value
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst3f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, ah
		and	dl, 01h
		shl	dl, 4
		xor	ah, 01h
		and	ah, 0edh
		or	ah, dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst40:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst41:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, cl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst42:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, byte [_z80de + 1]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst43:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, byte [_z80de]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst44:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, bh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst45:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, bl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst46:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop20:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr20		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine20

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead20
nextAddr20:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop20

callRoutine20:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead20
memoryRead20:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	ch, [edi + ebx]	; Get our data

		jmp	short readExit20

callRead20:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit20:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst47:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	ch, al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst48:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, ch
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst49:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, byte [_z80de + 1]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, byte [_z80de]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, bh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, bl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop21:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr21		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine21

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead21
nextAddr21:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop21

callRoutine21:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead21
memoryRead21:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	cl, [edi + ebx]	; Get our data

		jmp	short readExit21

callRead21:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit21:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst4f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	cl, al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst50:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], ch
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst51:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], cl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst52:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst53:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [_z80de]
		mov	[_z80de + 1], dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst54:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], bh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst55:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], bl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst56:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop22:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr22		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine22

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead22
nextAddr22:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop22

callRoutine22:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead22
memoryRead22:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dh, [edi + ebx]	; Get our data

		jmp	short readExit22

callRead22:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit22:
		mov	byte [_z80de + 1], dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst57:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de + 1], al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst58:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], ch
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst59:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], cl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [_z80de + 1]
		mov	[_z80de], dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], bh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], bl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop23:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr23		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine23

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead23
nextAddr23:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop23

callRoutine23:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead23
memoryRead23:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit23

callRead23:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit23:
		mov	byte [_z80de], dl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst5f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	byte [_z80de], al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst60:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, ch
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst61:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, cl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst62:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, byte [_z80de + 1]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst63:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, byte [_z80de]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst64:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst65:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, bl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst66:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop24:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr24		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine24

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead24
nextAddr24:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop24

callRoutine24:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead24
memoryRead24:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bh, [edi + ebx]	; Get our data

		jmp	short readExit24

callRead24:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit24:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst67:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bh, al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst68:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, ch
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst69:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, cl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, byte [_z80de + 1]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, byte [_z80de]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, bh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop25:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr25		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine25

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead25
nextAddr25:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop25

callRoutine25:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead25
memoryRead25:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bl, [edi + ebx]	; Get our data

		jmp	short readExit25

callRead25:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit25:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst6f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	bl, al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst70:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop26:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr26	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine26	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite26	; Yes - go write it!
nextAddr26:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop26

callRoutine26:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite26
memoryWrite26:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit26
callWrite26:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit26:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst71:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop27:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr27	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine27	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite27	; Yes - go write it!
nextAddr27:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop27

callRoutine27:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite27
memoryWrite27:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit27
callWrite27:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit27:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst72:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop28:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr28	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine28	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite28	; Yes - go write it!
nextAddr28:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop28

callRoutine28:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite28
memoryWrite28:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, byte [_z80de + 1]
		mov	[edi + ebx], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit28
callWrite28:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit28:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst73:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop29:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr29	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine29	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite29	; Yes - go write it!
nextAddr29:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop29

callRoutine29:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite29
memoryWrite29:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, byte [_z80de]
		mov	[edi + ebx], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit29
callWrite29:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit29:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst74:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop30:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr30	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine30	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite30	; Yes - go write it!
nextAddr30:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop30

callRoutine30:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite30
memoryWrite30:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit30
callWrite30:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit30:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst75:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop31:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr31	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine31	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite31	; Yes - go write it!
nextAddr31:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop31

callRoutine31:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite31
memoryWrite31:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit31
callWrite31:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit31:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst76:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dword [_z80halted], 1	; We've halted the chip!
		mov	edx, dword [cyclesRemaining] ; Get the time remaining
		add	[dwElapsedTicks], edx ; Fake like we did it
		inc	esi
		jmp	noMoreExec
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst77:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop32:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr32	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine32	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite32	; Yes - go write it!
nextAddr32:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop32

callRoutine32:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite32
memoryWrite32:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit32
callWrite32:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit32:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst78:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, ch
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst79:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, cl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, byte [_z80de + 1]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, byte [_z80de]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, bh
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	al, bl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop33:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr33		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine33

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead33
nextAddr33:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop33

callRoutine33:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead33
memoryRead33:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	al, [edi + ebx]	; Get our data

		jmp	short readExit33

callRead33:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
readExit33:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst7f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst80:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst81:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst82:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst83:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst84:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst85:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst86:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop34:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr34		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine34

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead34
nextAddr34:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop34

callRoutine34:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead34
memoryRead34:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit34

callRead34:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit34:
		sahf
		add	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst87:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		add	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst88:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst89:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop35:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr35		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine35

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead35
nextAddr35:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop35

callRoutine35:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead35
memoryRead35:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit35

callRead35:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit35:
		sahf
		adc	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst8f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		adc	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst90:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst91:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst92:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst93:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst94:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst95:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst96:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop36:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr36		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine36

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead36
nextAddr36:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop36

callRoutine36:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead36
memoryRead36:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit36

callRead36:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit36:
		sahf
		sub	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst97:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sub	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst98:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst99:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9a:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9b:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9c:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9d:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9e:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop37:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr37		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine37

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead37
nextAddr37:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop37

callRoutine37:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead37
memoryRead37:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit37

callRead37:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit37:
		sahf
		sbb	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInst9f:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		sbb	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta0:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, ch
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta1:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, cl
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta2:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, byte [_z80de + 1]
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta3:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, byte [_z80de]
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta4:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, bh
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta5:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, bl
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop38:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr38		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine38

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead38
nextAddr38:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop38

callRoutine38:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead38
memoryRead38:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit38

callRead38:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit38:
		sahf
		and	al, dl
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta7:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		and	al, al
		lahf
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta8:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, ch
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsta9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, cl
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstaa:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, byte [_z80de + 1]
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstab:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, byte [_z80de]
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstac:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, bh
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstad:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, bl
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstae:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop39:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr39		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine39

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead39
nextAddr39:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop39

callRoutine39:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead39
memoryRead39:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit39

callRead39:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit39:
		sahf
		xor	al, dl
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstaf:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		xor	al, al
		lahf
		and	ah, 0ech	; Only these flags matter!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb0:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, ch
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb1:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, cl
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb2:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, byte [_z80de + 1]
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb3:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, byte [_z80de]
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb4:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, bh
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb5:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, bl
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop40:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr40		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine40

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead40
nextAddr40:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop40

callRoutine40:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead40
memoryRead40:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit40

callRead40:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit40:
		sahf
		or	al, dl
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb7:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		or	al, al
		lahf
		and	ah, 0ech ; No H, N, or C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb8:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, ch
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstb9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, cl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstba:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, byte [_z80de + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbb:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, byte [_z80de]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbc:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, bh
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbd:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, bl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbe:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop41:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr41		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine41

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead41
nextAddr41:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop41

callRoutine41:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead41
memoryRead41:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit41

callRead41:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit41:
		sahf
		cmp	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstbf:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		sahf
		cmp	al, al
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set N for compare!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jnz	takeReturn42
		jmp	short retNotTaken42
takeReturn42:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken42:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop43:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr43		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine43

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead43
nextAddr43:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop43

callRoutine43:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead43
memoryRead43:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	cl, [edi + edx]	; Get our data

		jmp	short readExit43

callRead43:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit43:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop44:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr44		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine44

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead44
nextAddr44:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop44

callRoutine44:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead44
memoryRead44:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	ch, [edi + edx]	; Get our data

		jmp	short readExit44

callRead44:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit44:
		add	word [_z80sp], 2
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnz	takeJump45	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst45	 ; Go execute the next instruction
takeJump45:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst45:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc3:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	si, [esi]	; Get our new address
		and	esi, 0ffffh	; Only the lower 16 bits
		add	esi, ebp		; Our new address!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnz	takeJump46	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken46	 ; Go execute the next instruction
takeJump46:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken46:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop47:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr47	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine47	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite47	; Yes - go write it!
nextAddr47:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop47

callRoutine47:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite47
memoryWrite47:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit47
callWrite47:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit47:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop48:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr48	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine48	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite48	; Yes - go write it!
nextAddr48:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop48

callRoutine48:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite48
memoryWrite48:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit48
callWrite48:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit48:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		add	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; Knock out N!
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0000h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jz	takeReturn49
		jmp	short retNotTaken49
takeReturn49:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken49:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstc9:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstca:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jz	takeJump50	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst50	 ; Go execute the next instruction
takeJump50:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst50:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all CBxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcb:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixCB+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcc:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jz	takeJump51	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken51	 ; Go execute the next instruction
takeJump51:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken51:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcd:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstce:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		adc	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; Knock out N!
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstcf:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0008h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jnc	takeReturn52
		jmp	short retNotTaken52
takeReturn52:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken52:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop53:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr53		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine53

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead53
nextAddr53:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop53

callRoutine53:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead53
memoryRead53:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de], dl
		pop	edx
		jmp	short readExit53

callRead53:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit53:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop54:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr54		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine54

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead54
nextAddr54:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop54

callRoutine54:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead54
memoryRead54:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de + 1], dl
		pop	edx
		jmp	short readExit54

callRead54:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit54:
		add	word [_z80sp], 2
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnc	takeJump55	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst55	 ; Go execute the next instruction
takeJump55:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst55:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd3:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dl, [esi]	; Get our address to 'out' to
		inc	esi	; Next address
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop56:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit56	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr56	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine56	; If not, go call it!

nextAddr56:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop56

callRoutine56:
		call	WriteIOByte	; Go write the data!
WriteMacroExit56:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jnc	takeJump57	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken57	 ; Go execute the next instruction
takeJump57:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken57:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop58:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr58	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine58	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite58	; Yes - go write it!
nextAddr58:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop58

callRoutine58:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite58
memoryWrite58:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit58
callWrite58:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit58:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop59:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr59	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine59	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite59	; Yes - go write it!
nextAddr59:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop59

callRoutine59:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite59
memoryWrite59:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit59
callWrite59:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit59:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		sub	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0010h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jc	takeReturn60
		jmp	short retNotTaken60
takeReturn60:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken60:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstd9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	di, [_z80de]
		xchg	cx, [_z80bcprime]
		xchg	di, [_z80deprime]
		xchg	bx, [_z80hlprime]
		mov	[_z80de], di
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstda:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jc	takeJump61	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst61	 ; Go execute the next instruction
takeJump61:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst61:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdb:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		mov	dl, [esi]	; Get our address to 'out' to
		inc	esi	; Next address
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop62:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead62
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr62		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine62

nextAddr62:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop62

callRoutine62:
		call	ReadIOByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit62

ioRead62:
		mov	al, 0ffh	; An unreferenced read
readExit62:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdc:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jc	takeJump63	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken63	 ; Go execute the next instruction
takeJump63:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken63:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all DDxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdd:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixDD+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstde:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		sbb	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstdf:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0018h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jpo	takeReturn64
		jmp	short retNotTaken64
takeReturn64:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken64:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop65:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr65		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine65

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead65
nextAddr65:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop65

callRoutine65:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead65
memoryRead65:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bl, [edi + edx]	; Get our data

		jmp	short readExit65

callRead65:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit65:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop66:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr66		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine66

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead66
nextAddr66:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop66

callRoutine66:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead66
memoryRead66:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bh, [edi + edx]	; Get our data

		jmp	short readExit66

callRead66:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit66:
		add	word [_z80sp], 2
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpo	takeJump67	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst67	 ; Go execute the next instruction
takeJump67:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst67:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste3:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 19
		call	PopWord
		xchg	bx, [_wordval]
		call	PushWord
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpo	takeJump68	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken68	 ; Go execute the next instruction
takeJump68:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken68:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop69:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr69	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine69	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite69	; Yes - go write it!
nextAddr69:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop69

callRoutine69:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite69
memoryWrite69:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit69
callWrite69:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit69:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop70:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr70	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine70	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite70	; Yes - go write it!
nextAddr70:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop70

callRoutine70:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite70
memoryWrite70:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit70
callWrite70:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit70:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		and	al, [esi]
		lahf
		and	ah, 0ech ; Only parity, half carry, sign, zero
		or	ah, 10h	; Half carry
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0020h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jpe	takeReturn71
		jmp	short retNotTaken71
takeReturn71:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken71:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInste9:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	si, bx
		and	esi, 0ffffh
		add	esi, ebp
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstea:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpe	takeJump72	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst72	 ; Go execute the next instruction
takeJump72:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst72:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsteb:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		xchg	[_z80de], bx	; Exchange DE & HL
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstec:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jpe	takeJump73	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken73	 ; Go execute the next instruction
takeJump73:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken73:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all EDxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInsted:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixED+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstee:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		xor	al, [esi]
		lahf
		and	ah, 0ech	; No H, N, or C
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstef:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0028h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf0:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		jns	takeReturn74
		jmp	short retNotTaken74
takeReturn74:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken74:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf1:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop75:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr75		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine75

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead75
nextAddr75:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop75

callRoutine75:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead75
memoryRead75:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	ah, [edi + edx]	; Get our data

		jmp	short readExit75

callRead75:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af + 1], al	; Save our new flags
		mov	ax, [_z80af]	; Get our AF back
readExit75:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop76:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr76		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine76

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead76
nextAddr76:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop76

callRoutine76:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead76
memoryRead76:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	al, [edi + edx]	; Get our data

		jmp	short readExit76

callRead76:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
readExit76:
		add	word [_z80sp], 2
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf2:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jns	takeJump77	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst77	 ; Go execute the next instruction
takeJump77:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst77:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf3:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dword [_z80interruptState], 0	; Interrupts disabled now
		mov	dword [_z80inInterrupt], 0	; Not in an interrupt
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf4:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		jns	takeJump78	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken78	 ; Go execute the next instruction
takeJump78:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken78:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf5:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, ah	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop79:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr79	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine79	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite79	; Yes - go write it!
nextAddr79:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop79

callRoutine79:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite79
memoryWrite79:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], ah
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit79
callWrite79:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit79:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop80:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr80	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine80	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite80	; Yes - go write it!
nextAddr80:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop80

callRoutine80:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite80
memoryWrite80:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit80
callWrite80:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit80:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf6:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		or	al, [esi]
		lahf
		and	ah, 0ech	; No H, N, or C
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf7:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0030h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf8:
		sub	dword [cyclesRemaining], byte 5
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 5
		sahf
		js	takeReturn81
		jmp	short retNotTaken81
takeReturn81:
		add	dword [dwElapsedTicks], 6
		sub	dword [cyclesRemaining], 6
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		xor	edx, edx
retNotTaken81:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstf9:
		sub	dword [cyclesRemaining], byte 6
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 6
		mov	word [_z80sp], bx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfa:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		js	takeJump82	; We're going to take a jump
		add	esi, 2		; Skip past the address
		jmp	short nextInst82	 ; Go execute the next instruction
takeJump82:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	si, [esi]	; Get our new offset
		and	esi, 0ffffh	; Only the lower WORD is valid
		add	esi, ebp		; Our new address!
nextInst82:
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfb:
		sub	dword [cyclesRemaining], byte 4
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 4
		mov	dword [_z80interruptState], 1	; Interrupts enabled now
		mov	dword [_z80inInterrupt], 0	; Not in an interrupt
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfc:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 10
		sahf		; Restore our flags
		js	takeJump83	; We're going call in this case
		add	esi, 2		; Skip past the address
		jmp	short noCallTaken83	 ; Go execute the next instruction
takeJump83:
		add	dword [dwElapsedTicks], 7
		sub	dword [cyclesRemaining], 7
		mov	dx, [esi]	; Get our call to address
		mov	[_z80pc], dx ; Store our new program counter
		add	esi, 2		; Skip to our new address to be pushed
		sub	esi, ebp		; Value to push onto the "stack"
		mov	[_wordval], si	; Store our return address on the stack
		mov	si, dx		; Our new address
		add	esi, ebp	; And our base address
		call	PushWord	; Go push our orgval to the stack
noCallTaken83:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

;
; Handler for all FDxx instructions
;

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfd:
		mov	[_baseFixup], dword 1
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80PrefixFD+edx*4]




times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstfe:
		sub	dword [cyclesRemaining], byte 7
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 7
		sahf
		cmp	al, [esi]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative!
		inc	esi
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

RegInstff:
		sub	dword [cyclesRemaining], byte 11
		js	near noMoreExec
		add	dword [dwElapsedTicks], byte 11
		sub	esi, ebp
		mov	[_wordval], si	; Store our return address
		call	PushWord
		xor	esi, esi
		mov	si, 0038h
		add	esi, ebp
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst00:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst01:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst02:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rol	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst03:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rol	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst04:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst05:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst06:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop84:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr84		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine84

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead84
nextAddr84:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop84

callRoutine84:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead84
memoryRead84:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit84

callRead84:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit84:
		sahf
		rol	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop85:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr85	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine85	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite85	; Yes - go write it!
nextAddr85:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop85

callRoutine85:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite85
memoryWrite85:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit85
callWrite85:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit85:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst07:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rol	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst08:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst09:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		ror	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		ror	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop86:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr86		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine86

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead86
nextAddr86:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop86

callRoutine86:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead86
memoryRead86:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit86

callRead86:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit86:
		sahf
		ror	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop87:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr87	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine87	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite87	; Yes - go write it!
nextAddr87:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop87

callRoutine87:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite87
memoryWrite87:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit87
callWrite87:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit87:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst0f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		ror	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst10:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst11:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst12:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcl	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst13:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcl	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst14:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst15:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst16:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop88:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr88		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine88

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead88
nextAddr88:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop88

callRoutine88:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead88
memoryRead88:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit88

callRead88:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit88:
		sahf
		rcl	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop89:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr89	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine89	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite89	; Yes - go write it!
nextAddr89:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop89

callRoutine89:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite89
memoryWrite89:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit89
callWrite89:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit89:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst17:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcl	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst18:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	ch, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	ch, ch
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst19:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	cl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	cl, cl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcr	dh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dh, dh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		rcr	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	bh, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bh, bh
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	bl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	bl, bl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop90:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr90		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine90

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead90
nextAddr90:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop90

callRoutine90:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead90
memoryRead90:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit90

callRead90:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit90:
		sahf
		rcr	dl, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	dl, dl
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop91:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr91	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine91	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite91	; Yes - go write it!
nextAddr91:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop91

callRoutine91:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite91
memoryWrite91:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit91
callWrite91:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit91:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst1f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		rcr	al, 1
		lahf
		and	ah, 029h	; Clear H and N
		mov	byte [_z80af], ah
		or	al, al
		lahf
		and	ah, 0c4h	; Sign, zero, and parity
		or	ah, byte [_z80af]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst20:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	ch, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst21:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	cl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst22:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst23:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst24:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst25:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst26:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop92:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr92		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine92

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead92
nextAddr92:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop92

callRoutine92:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead92
memoryRead92:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit92

callRead92:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit92:
		sahf
		shl	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop93:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr93	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine93	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite93	; Yes - go write it!
nextAddr93:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop93

callRoutine93:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite93
memoryWrite93:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit93
callWrite93:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit93:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst27:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	al, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst28:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	ch, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst29:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	cl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		sar	dh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		sar	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	bh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	bl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop94:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr94		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine94

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead94
nextAddr94:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop94

callRoutine94:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead94
memoryRead94:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit94

callRead94:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit94:
		sahf
		sar	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop95:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr95	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine95	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite95	; Yes - go write it!
nextAddr95:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop95

callRoutine95:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite95
memoryWrite95:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit95
callWrite95:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit95:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst2f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sar	al, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst30:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	ch, 1
		lahf
		or	ch, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst31:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	cl, 1
		lahf
		or	cl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst32:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dh, 1
		lahf
		or	dh, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst33:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shl	dl, 1
		lahf
		or	dl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst34:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bh, 1
		lahf
		or	bh, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst35:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	bl, 1
		lahf
		or	bl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst36:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop96:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr96		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine96

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead96
nextAddr96:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop96

callRoutine96:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead96
memoryRead96:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit96

callRead96:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit96:
		sahf
		shl	dl, 1
		lahf
		or	dl, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop97:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr97	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine97	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite97	; Yes - go write it!
nextAddr97:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop97

callRoutine97:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite97
memoryWrite97:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit97
callWrite97:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit97:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst37:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shl	al, 1
		lahf
		or	al, 1	; Slide in a 1 bit (SLIA)
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst38:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	ch, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst39:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	cl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shr	dh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		sahf
		shr	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	bh, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	bl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop98:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr98		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine98

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead98
nextAddr98:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop98

callRoutine98:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead98
memoryRead98:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit98

callRead98:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit98:
		sahf
		shr	dl, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop99:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr99	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine99	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite99	; Yes - go write it!
nextAddr99:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop99

callRoutine99:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite99
memoryWrite99:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit99
callWrite99:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit99:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst3f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		shr	al, 1
		lahf
		and	ah, 0edh	; Clear H and N
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst40:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst41:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst42:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst43:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst44:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst45:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst46:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop100:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr100		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine100

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead100
nextAddr100:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop100

callRoutine100:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead100
memoryRead100:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit100

callRead100:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit100:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst47:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 001h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst48:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst49:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop101:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr101		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine101

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead101
nextAddr101:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop101

callRoutine101:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead101
memoryRead101:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit101

callRead101:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit101:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst4f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 002h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst50:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst51:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst52:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst53:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst54:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst55:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst56:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop102:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr102		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine102

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead102
nextAddr102:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop102

callRoutine102:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead102
memoryRead102:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit102

callRead102:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit102:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst57:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 004h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst58:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst59:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop103:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr103		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine103

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead103
nextAddr103:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop103

callRoutine103:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead103
memoryRead103:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit103

callRead103:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit103:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst5f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 008h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst60:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst61:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst62:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst63:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst64:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst65:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst66:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop104:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr104		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine104

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead104
nextAddr104:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop104

callRoutine104:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead104
memoryRead104:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit104

callRead104:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit104:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst67:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 010h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst68:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst69:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop105:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr105		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine105

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead105
nextAddr105:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop105

callRoutine105:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead105
memoryRead105:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit105

callRead105:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit105:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst6f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 020h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst70:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst71:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst72:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst73:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst74:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst75:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst76:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop106:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr106		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine106

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead106
nextAddr106:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop106

callRoutine106:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead106
memoryRead106:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit106

callRead106:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit106:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst77:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 040h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst78:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test ch, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst79:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test cl, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de + 1], 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test byte [_z80de], 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bh, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test bl, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7e:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop107:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr107		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine107

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead107
nextAddr107:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop107

callRoutine107:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead107
memoryRead107:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit107

callRead107:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit107:
		mov	byte [_z80af], ah ; Store F
		sahf
		test	dl, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst7f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	byte [_z80af], ah ; Store F
		sahf
		test al, 080h	; Do a bitwise check
		lahf
		and	ah, 0c0h	; Only care about Z and S
		or	ah, 10h	; Set half carry to 1
		and	byte [_z80af], 029h		; Only zero/non-zero!
		or	ah, byte [_z80af]	; Put it in with the real flags
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst80:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0feh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst81:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0feh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst82:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0feh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst83:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0feh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst84:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0feh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst85:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0feh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst86:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop108:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr108		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine108

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead108
nextAddr108:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop108

callRoutine108:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead108
memoryRead108:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit108

callRead108:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit108:
		and dl, 0feh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop109:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr109	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine109	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite109	; Yes - go write it!
nextAddr109:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop109

callRoutine109:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite109
memoryWrite109:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit109
callWrite109:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit109:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst87:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0feh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst88:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0fdh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst89:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0fdh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0fdh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0fdh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0fdh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0fdh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop110:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr110		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine110

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead110
nextAddr110:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop110

callRoutine110:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead110
memoryRead110:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit110

callRead110:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit110:
		and dl, 0fdh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop111:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr111	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine111	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite111	; Yes - go write it!
nextAddr111:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop111

callRoutine111:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite111
memoryWrite111:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit111
callWrite111:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit111:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst8f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0fdh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst90:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0fbh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst91:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0fbh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst92:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0fbh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst93:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0fbh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst94:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0fbh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst95:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0fbh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst96:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop112:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr112		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine112

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead112
nextAddr112:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop112

callRoutine112:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead112
memoryRead112:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit112

callRead112:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit112:
		and dl, 0fbh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop113:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr113	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine113	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite113	; Yes - go write it!
nextAddr113:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop113

callRoutine113:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite113
memoryWrite113:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit113
callWrite113:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit113:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst97:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0fbh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst98:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0f7h	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst99:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0f7h	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9a:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0f7h	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9b:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0f7h	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9c:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0f7h	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9d:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0f7h	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9e:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop114:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr114		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine114

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead114
nextAddr114:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop114

callRoutine114:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead114
memoryRead114:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit114

callRead114:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit114:
		and dl, 0f7h	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop115:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr115	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine115	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite115	; Yes - go write it!
nextAddr115:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop115

callRoutine115:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite115
memoryWrite115:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit115
callWrite115:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit115:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInst9f:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0f7h	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0efh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0efh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0efh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0efh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0efh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0efh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop116:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr116		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine116

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead116
nextAddr116:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop116

callRoutine116:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead116
memoryRead116:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit116

callRead116:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit116:
		and dl, 0efh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop117:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr117	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine117	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite117	; Yes - go write it!
nextAddr117:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop117

callRoutine117:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite117
memoryWrite117:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit117
callWrite117:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit117:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0efh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0dfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsta9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0dfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstaa:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0dfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstab:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0dfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstac:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0dfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstad:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0dfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstae:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop118:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr118		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine118

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead118
nextAddr118:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop118

callRoutine118:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead118
memoryRead118:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit118

callRead118:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit118:
		and dl, 0dfh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop119:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr119	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine119	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite119	; Yes - go write it!
nextAddr119:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop119

callRoutine119:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite119
memoryWrite119:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit119
callWrite119:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit119:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstaf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0dfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 0bfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 0bfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 0bfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 0bfh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 0bfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 0bfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop120:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr120		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine120

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead120
nextAddr120:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop120

callRoutine120:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead120
memoryRead120:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit120

callRead120:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit120:
		and dl, 0bfh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop121:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr121	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine121	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite121	; Yes - go write it!
nextAddr121:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop121

callRoutine121:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite121
memoryWrite121:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit121
callWrite121:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit121:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 0bfh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and ch, 07fh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstb9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and cl, 07fh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstba:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dh, 07fh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		and dl, 07fh	; Reset a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bh, 07fh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and bl, 07fh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbe:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop122:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr122		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine122

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead122
nextAddr122:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop122

callRoutine122:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead122
memoryRead122:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit122

callRead122:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit122:
		and dl, 07fh	; Reset a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop123:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr123	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine123	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite123	; Yes - go write it!
nextAddr123:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop123

callRoutine123:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite123
memoryWrite123:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit123
callWrite123:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit123:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstbf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		and al, 07fh	; Reset a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 001h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 001h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 001h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 001h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 001h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 001h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop124:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr124		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine124

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead124
nextAddr124:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop124

callRoutine124:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead124
memoryRead124:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit124

callRead124:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit124:
		or	dl, 001h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop125:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr125	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine125	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite125	; Yes - go write it!
nextAddr125:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop125

callRoutine125:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite125
memoryWrite125:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit125
callWrite125:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit125:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 001h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 002h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstc9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 002h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstca:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 002h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 002h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 002h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 002h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstce:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop126:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr126		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine126

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead126
nextAddr126:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop126

callRoutine126:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead126
memoryRead126:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit126

callRead126:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit126:
		or	dl, 002h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop127:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr127	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine127	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite127	; Yes - go write it!
nextAddr127:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop127

callRoutine127:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite127
memoryWrite127:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit127
callWrite127:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit127:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstcf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 002h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 004h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 004h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 004h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 004h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 004h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 004h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop128:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr128		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine128

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead128
nextAddr128:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop128

callRoutine128:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead128
memoryRead128:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit128

callRead128:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit128:
		or	dl, 004h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop129:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr129	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine129	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite129	; Yes - go write it!
nextAddr129:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop129

callRoutine129:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite129
memoryWrite129:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit129
callWrite129:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit129:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 004h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 008h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstd9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 008h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstda:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 008h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 008h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 008h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 008h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstde:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop130:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr130		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine130

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead130
nextAddr130:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop130

callRoutine130:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead130
memoryRead130:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit130

callRead130:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit130:
		or	dl, 008h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop131:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr131	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine131	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite131	; Yes - go write it!
nextAddr131:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop131

callRoutine131:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite131
memoryWrite131:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit131
callWrite131:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit131:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstdf:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 008h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 010h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 010h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 010h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 010h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 010h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 010h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop132:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr132		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine132

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead132
nextAddr132:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop132

callRoutine132:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead132
memoryRead132:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit132

callRead132:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit132:
		or	dl, 010h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop133:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr133	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine133	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite133	; Yes - go write it!
nextAddr133:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop133

callRoutine133:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite133
memoryWrite133:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit133
callWrite133:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit133:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 010h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 020h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInste9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 020h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstea:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 020h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsteb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 020h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstec:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 020h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInsted:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 020h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstee:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop134:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr134		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine134

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead134
nextAddr134:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop134

callRoutine134:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead134
memoryRead134:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit134

callRead134:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit134:
		or	dl, 020h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop135:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr135	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine135	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite135	; Yes - go write it!
nextAddr135:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop135

callRoutine135:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite135
memoryWrite135:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit135
callWrite135:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit135:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstef:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 020h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf0:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 040h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf1:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 040h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf2:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 040h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf3:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 040h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf4:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 040h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf5:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 040h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf6:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop136:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr136		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine136

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead136
nextAddr136:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop136

callRoutine136:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead136
memoryRead136:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit136

callRead136:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit136:
		or	dl, 040h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop137:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr137	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine137	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite137	; Yes - go write it!
nextAddr137:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop137

callRoutine137:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite137
memoryWrite137:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit137
callWrite137:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit137:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf7:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 040h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf8:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	ch, 080h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstf9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	cl, 080h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfa:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dh, 080h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfb:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80de]	; Move DE into something half usable
		or	dl, 080h	; Set a bit
		mov	[_z80de], dx	; Once modified, put it back
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfc:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bh, 080h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfd:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	bl, 080h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstfe:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop138:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr138		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine138

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead138
nextAddr138:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop138

callRoutine138:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead138
memoryRead138:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit138

callRead138:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit138:
		or	dl, 080h	; Set a bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop139:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr139	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine139	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite139	; Yes - go write it!
nextAddr139:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop139

callRoutine139:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite139
memoryWrite139:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit139
callWrite139:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit139:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

CBInstff:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		or	al, 080h	; Set a bit
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst40:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop140:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead140
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr140		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine140

nextAddr140:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop140

callRoutine140:
		call	ReadIOByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit140

ioRead140:
		mov	ch, 0ffh	; An unreferenced read
readExit140:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	ch, ch;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst41:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop141:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit141	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr141	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine141	; If not, go call it!

nextAddr141:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop141

callRoutine141:
		call	WriteIOByte	; Go write the data!
WriteMacroExit141:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst42:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, cx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst43:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop142:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr142	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine142	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite142	; Yes - go write it!
nextAddr142:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop142

callRoutine142:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite142
memoryWrite142:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit142
callWrite142:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit142:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop143:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr143	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine143	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite143	; Yes - go write it!
nextAddr143:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop143

callRoutine143:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite143
memoryWrite143:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit143
callWrite143:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit143:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst44:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		sahf
		sub	dh, al
		lahf
		mov	al, dh
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst45:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		cmp	dword [_z80stoponintend], 0	
		je	cont_int_144	; Continue?	
		mov	dword [_z80stoponintend], 0
		mov	edx, [cyclesRemaining]
		sub	[dwOriginalExec], edx
		mov	[cyclesRemaining], dword 1
cont_int_144:					
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst46:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dword [_z80interruptMode], 0 ; IM 0
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst47:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     [_z80i], al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst48:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop145:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead145
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr145		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine145

nextAddr145:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop145

callRoutine145:
		call	ReadIOByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit145

ioRead145:
		mov	cl, 0ffh	; An unreferenced read
readExit145:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	cl, cl;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst49:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop146:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit146	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr146	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine146	; If not, go call it!

nextAddr146:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop146

callRoutine146:
		call	WriteIOByte	; Go write the data!
WriteMacroExit146:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, cx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4b:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop147:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr147		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine147

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead147
nextAddr147:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop147

callRoutine147:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead147
memoryRead147:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	cl, [edi + edx]	; Get our data

		jmp	short readExit147

callRead147:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit147:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop148:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr148		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine148

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead148
nextAddr148:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop148

callRoutine148:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead148
memoryRead148:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	ch, [edi + edx]	; Get our data

		jmp	short readExit148

callRead148:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit148:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4d:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		call	PopWord
		xor	esi, esi
		mov	si, dx
		add	esi, ebp
		mov	dword [_z80inInterrupt], 0
		cmp	dword [_z80stoponintend], 0	
		je	cont_int_149	; Continue?	
		mov	dword [_z80stoponintend], 0
		mov	edx, [cyclesRemaining]
		sub	[dwOriginalExec], edx
		mov	[cyclesRemaining], dword 1
cont_int_149:					
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst4f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     [_z80r], al
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst50:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop150:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead150
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr150		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine150

nextAddr150:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop150

callRoutine150:
		call	ReadIOByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit150

ioRead150:
		mov	byte [_z80de + 1], 0ffh	; An unreferenced read
readExit150:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		mov	dl, byte [_z80de + 1]
		or	dl, dl
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst51:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop151:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit151	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr151	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine151	; If not, go call it!

nextAddr151:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop151

callRoutine151:
		call	WriteIOByte	; Go write the data!
WriteMacroExit151:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst52:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80de]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst53:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop152:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr152	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine152	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite152	; Yes - go write it!
nextAddr152:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop152

callRoutine152:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite152
memoryWrite152:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit152
callWrite152:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit152:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop153:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr153	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine153	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite153	; Yes - go write it!
nextAddr153:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop153

callRoutine153:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite153
memoryWrite153:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit153
callWrite153:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit153:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst56:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dword [_z80interruptMode], 1 ; Interrupt mode 1
		mov	word [_z80intAddr], 038h	; Interrupt mode 1 cmd!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst57:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     al, [_z80i]
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst58:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop154:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead154
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr154		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine154

nextAddr154:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop154

callRoutine154:
		call	ReadIOByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit154

ioRead154:
		mov	byte [_z80de], 0ffh	; An unreferenced read
readExit154:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		mov	dl, byte [_z80de]
		or	dl, dl
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst59:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop155:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit155	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr155	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine155	; If not, go call it!

nextAddr155:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop155

callRoutine155:
		call	WriteIOByte	; Go write the data!
WriteMacroExit155:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80de]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5b:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop156:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr156		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine156

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead156
nextAddr156:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop156

callRoutine156:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead156
memoryRead156:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de], dl
		pop	edx
		jmp	short readExit156

callRead156:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit156:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop157:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr157		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine157

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead157
nextAddr157:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop157

callRoutine157:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead157
memoryRead157:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de + 1], dl
		pop	edx
		jmp	short readExit157

callRead157:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit157:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5e:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dword [_z80interruptMode], 2 ; IM 2
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst5f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
           mov     al, [_z80r]
		and	ah, 029h	; No N, H, Z, or S!
		or	al,al	; Get appropriate flags
		o16 pushf
		pop	dx
		and	dl, 0c0h
		or	ah, dl	; OR In our S & Z flags
		mov	dl, byte [_z80inInterrupt]
		not	dl
		and	dl, 1
		shl	dl, 2
		or	ah, dl
		xor	edx, edx
		mov	dl, byte [cyclesRemaining]
		not	dl
		shr	dl, 2
		mov	[_z80r], dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst60:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop158:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead158
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr158		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine158

nextAddr158:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop158

callRoutine158:
		call	ReadIOByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit158

ioRead158:
		mov	bh, 0ffh	; An unreferenced read
readExit158:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	bh, bh;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst61:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop159:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit159	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr159	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine159	; If not, go call it!

nextAddr159:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop159

callRoutine159:
		call	WriteIOByte	; Go write the data!
WriteMacroExit159:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst62:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, bx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst63:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop160:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr160	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine160	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite160	; Yes - go write it!
nextAddr160:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop160

callRoutine160:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite160
memoryWrite160:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit160
callWrite160:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit160:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop161:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr161	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine161	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite161	; Yes - go write it!
nextAddr161:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop161

callRoutine161:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite161
memoryWrite161:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit161
callWrite161:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit161:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst67:
		sub	dword [cyclesRemaining], byte 18
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 18
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop162:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr162		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine162

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead162
nextAddr162:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop162

callRoutine162:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead162
memoryRead162:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit162

callRead162:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit162:
		mov	dh, dl	; Put a copy in DH
		shr	dl, 4	; Upper nibble to lower nibble
		shl	ecx, 16	; Save this
		mov	cl, al
		shl	cl, 4
		or	dl, cl	; OR In what was in A
		and	al, 0f0h	; Knock out lower part
		and	dh, 0fh	; Only the lower nibble
		or	al, dh	; OR In our nibble
		shr	ecx, 16	; Restore this
		and	ah, 29h	; Retain carry & two undefined bits
		mov	dh, ah	; Store our flags away for later
		or	al, al	; Get our flags
		lahf
		and	ah,0c4h	; Only partiy, zero, and sign
		or	ah, dh	; OR In our old flags
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop163:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr163	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine163	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite163	; Yes - go write it!
nextAddr163:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop163

callRoutine163:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite163
memoryWrite163:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit163
callWrite163:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit163:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst68:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop164:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead164
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr164		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine164

nextAddr164:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop164

callRoutine164:
		call	ReadIOByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit164

ioRead164:
		mov	bl, 0ffh	; An unreferenced read
readExit164:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	bl, bl;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst69:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop165:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit165	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr165	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine165	; If not, go call it!

nextAddr165:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop165

callRoutine165:
		call	WriteIOByte	; Go write the data!
WriteMacroExit165:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst6a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, bx	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst6f:
		sub	dword [cyclesRemaining], byte 18
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 18
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop166:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr166		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine166

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead166
nextAddr166:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop166

callRoutine166:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead166
memoryRead166:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit166

callRead166:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit166:
		mov	dh, dl	; Put a copy in DH
		shr	dh, 4	; Get our upper nibble in position
		shl	dl, 4	; Get our lower nibble into the higher position
		shl	ecx, 16	; Save this for later
		mov	cl, al
		and	cl, 0fh
	; Only the lower nibble
		or	dl, cl	; OR In A->(HL) transfer
		and	al, 0f0h	; Only the upper 4 bits remain
		or	al, dh	; OR It in to our accumulator
		shr	ecx, 16	; Restore this
		and	ah, 29h	; Retain carry & two undefined bits
		mov	dh, ah	; Store our flags away for later
		or	al, al	; Get our flags
		lahf
		and	ah,0c4h	; Only partiy, zero, and sign
		or	ah, dh	; OR In our old flags
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop167:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr167	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine167	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite167	; Yes - go write it!
nextAddr167:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop167

callRoutine167:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite167
memoryWrite167:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit167
callWrite167:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit167:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst72:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80sp]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		sbb	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		or	ah, 02h	; Negative!
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst73:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get our address to write to
		add	esi, 2		; Next address, please...
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80sp]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop168:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr168	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine168	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite168	; Yes - go write it!
nextAddr168:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop168

callRoutine168:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite168
memoryWrite168:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80sp]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit168
callWrite168:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit168:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80sp + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop169:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr169	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine169	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite169	; Yes - go write it!
nextAddr169:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop169

callRoutine169:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite169
memoryWrite169:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80sp + 1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit169
callWrite169:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit169:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst78:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop170:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead170
		cmp	dx, [edi]	; Are we smaller?
		jb		nextAddr170		; Yes, go to the next address
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine170

nextAddr170:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop170

callRoutine170:
		call	ReadIOByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit170

ioRead170:
		mov	al, 0ffh	; An unreferenced read
readExit170:
;
; Remember, this variant of the IN instruction modifies the flags
;

		sahf	; Restore our flags
		mov	dh, ah	; Save flags for later
		or	al, al;
		lahf
		and	dh, 029h	; Only keep carry and two unused flags
		and	ah, 0d4h
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst79:
		sub	dword [cyclesRemaining], byte 12
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 12
		mov	dl, cl	; Address in DX... (C)
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop171:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit171	; Yes - ignore it!
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr171	; Yes... go to the next addr
		cmp	dx, [edi+2]	; Are we bigger?
		jbe	callRoutine171	; If not, go call it!

nextAddr171:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop171

callRoutine171:
		call	WriteIOByte	; Go write the data!
WriteMacroExit171:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst7a:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dx, word [_z80sp]	; Get our original register
		mov	[_orgval], dx	; Store this for later half carry computation
		mov	[_orgval2], bx	; Store this, too
		sahf		; Restore our flags
		adc	bx, dx	; Do the operation!
		lahf		; Get our new flags
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0edh	; Knock out negative & half carry flags
		mov	[_z80hl], bx
		xor	bx, [_orgval]
		xor	bx, [_orgval2]
		and	bh, 10h	; Half carry?
		or	ah, bh	; OR It in if so
		mov	bx, [_z80hl]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInst7b:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	; Get address to load
		add	esi, 2	; Skip over it so we don't execute it
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop172:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr172		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine172

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead172
nextAddr172:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop172

callRoutine172:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead172
memoryRead172:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80sp], dl
		pop	edx
		jmp	short readExit172

callRead172:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80sp], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit172:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop173:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr173		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine173

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead173
nextAddr173:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop173

callRoutine173:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead173
memoryRead173:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80sp + 1], dl
		pop	edx
		jmp	short readExit173

callRead173:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80sp + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit173:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta0:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop174:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr174		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine174

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead174
nextAddr174:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop174

callRoutine174:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead174
memoryRead174:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit174

callRead174:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit174:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop175:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr175	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine175	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite175	; Yes - go write it!
nextAddr175:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop175

callRoutine175:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite175
memoryWrite175:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit175
callWrite175:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit175:
		inc	bx	; Increment HL
		inc	word [_z80de]	; Increment DE
		and	ah, 0e9h ; Knock out H & N and P/V
		dec	cx	; Decrement BC
		jz	atZero176 ; We're done!
		or	ah, 04h	; Non-zero - we're still going!
atZero176:
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta1:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop177:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr177		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine177

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead177
nextAddr177:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop177

callRoutine177:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead177
memoryRead177:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit177

callRead177:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit177:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero178
		or	ah, 04h	; P/V set when BC not zero
notBcZero178:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		inc	bx	; Increment!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta2:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		push	cx	; Save BC
		xor	ch, ch ; We want 8 bit ports
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop179:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead179
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr179		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine179

nextAddr179:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop179

callRoutine179:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit179

ioRead179:
		mov	dl, 0ffh	; An unreferenced read
readExit179:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop180:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr180	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine180	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite180	; Yes - go write it!
nextAddr180:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop180

callRoutine180:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite180
memoryWrite180:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit180
callWrite180:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit180:
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag178
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue178
clearFlag178:
		and	ah, 0bfh	; Clear the zero flag
continue178:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta3:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop182:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr182		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine182

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead182
nextAddr182:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop182

callRoutine182:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead182
memoryRead182:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit182

callRead182:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit182:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop183:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit183	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr183	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine183	; If not, go call it!

nextAddr183:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop183

callRoutine183:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit183:
		pop	cx	; Restore BC now that it has been "OUT"ed
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag181
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue181
clearFlag181:
		and	ah, 0bfh	; Clear the zero flag
continue181:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta8:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop184:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr184		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine184

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead184
nextAddr184:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop184

callRoutine184:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead184
memoryRead184:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit184

callRead184:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit184:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop185:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr185	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine185	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite185	; Yes - go write it!
nextAddr185:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop185

callRoutine185:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite185
memoryWrite185:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit185
callWrite185:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit185:
		dec	bx	; Decrement HL
		dec	word [_z80de]	; Decrement DE
		and	ah, 0e9h ; Knock out H & N and P/V
		dec	cx	; Decrement BC
		jz	atZero186 ; We're done!
		or	ah, 04h	; Non-zero - we're still going!
atZero186:
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInsta9:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop187:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr187		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine187

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead187
nextAddr187:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop187

callRoutine187:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead187
memoryRead187:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit187

callRead187:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit187:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero188
		or	ah, 04h	; P/V set when BC not zero
notBcZero188:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		dec	bx	; Decrement!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstaa:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		push	cx	; Save BC
		xor	ch, ch ; We want 8 bit ports
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop189:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead189
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr189		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine189

nextAddr189:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop189

callRoutine189:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit189

ioRead189:
		mov	dl, 0ffh	; An unreferenced read
readExit189:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop190:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr190	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine190	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite190	; Yes - go write it!
nextAddr190:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop190

callRoutine190:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite190
memoryWrite190:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit190
callWrite190:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit190:
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag188
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue188
clearFlag188:
		and	ah, 0bfh	; Clear the zero flag
continue188:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstab:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop192:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr192		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine192

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead192
nextAddr192:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop192

callRoutine192:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead192
memoryRead192:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit192

callRead192:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit192:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop193:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit193	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr193	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine193	; If not, go call it!

nextAddr193:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop193

callRoutine193:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit193:
		pop	cx	; Restore BC now that it has been "OUT"ed
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	clearFlag191
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue191
clearFlag191:
		and	ah, 0bfh	; Clear the zero flag
continue191:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb0:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
ldRepeat194:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop194:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr194		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine194

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead194
nextAddr194:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop194

callRoutine194:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead194
memoryRead194:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit194

callRead194:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit194:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop195:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr195	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine195	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite195	; Yes - go write it!
nextAddr195:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop195

callRoutine195:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite195
memoryWrite195:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit195
callWrite195:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit195:
		inc	bx	; Increment HL
		inc	word [_z80de]	; Increment DE
		dec	cx	; Decrement BC
		jz	noMore196
		jmp	ldRepeat194 ; Loop until we're done!
noMore196:
		and	ah, 0e9h	; No N, P/V, or H!
		shl	eax, 16	; Save this for later
		mov	ax, [_orgval] ; Get our original BC count
		mov	dx, 21	; 21 Clock cycles per iteration
		mul	dx		; Multiply it!
		mov	edx, eax	; Put our value in EDX
		and	edx, 0ffffh ; Only the lower part matters..
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		shr	eax, 16	; Restore this!
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb1:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	dword [_orgval], 0	; Zero our timing info
cpRepeat196:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop197:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr197		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine197

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead197
nextAddr197:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop197

callRoutine197:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead197
memoryRead197:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit197

callRead197:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit197:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero198
		or	ah, 04h	; P/V set when BC not zero
notBcZero198:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		inc	bx	; Increment!
		sahf
		jz	BCDone196
		jnp	BCDone196
		add	dword [_orgval], 21	; 21 T-States when not done
		jmp	cpRepeat196
BCDone196:
		mov	edx, dword [_orgval]
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb2:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
loopIt198:
		push	cx	; Save BC
		xor	ch, ch ; We want 8 bit ports
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop199:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead199
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr199		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine199

nextAddr199:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop199

callRoutine199:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit199

ioRead199:
		mov	dl, 0ffh	; An unreferenced read
readExit199:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop200:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr200	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine200	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite200	; Yes - go write it!
nextAddr200:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop200

callRoutine200:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite200
memoryWrite200:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit200
callWrite200:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit200:
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	near loopIt198
		jnz	clearFlag198
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue198
clearFlag198:
		and	ah, 0bfh	; Clear the zero flag
continue198:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb3:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
loopIt201:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop202:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr202		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine202

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead202
nextAddr202:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop202

callRoutine202:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead202
memoryRead202:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit202

callRead202:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit202:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop203:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit203	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr203	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine203	; If not, go call it!

nextAddr203:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop203

callRoutine203:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit203:
		pop	cx	; Restore BC now that it has been "OUT"ed
		inc	bx	; Increment HL
		dec	ch	; Decrement B (of C)
		jnz	near loopIt201
		jnz	clearFlag201
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue201
clearFlag201:
		and	ah, 0bfh	; Clear the zero flag
continue201:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb8:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	[_orgval], cx	; Store BC for later
		push	esi	; Save our PC for later
		push	ebp	; Save our base pointer for later
ldRepeat204:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop204:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr204		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine204

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead204
nextAddr204:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop204

callRoutine204:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead204
memoryRead204:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit204

callRead204:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit204:
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_z80de]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop205:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr205	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine205	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite205	; Yes - go write it!
nextAddr205:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop205

callRoutine205:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite205
memoryWrite205:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit205
callWrite205:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit205:
		dec	bx	; Decrement HL
		dec	word [_z80de]	; Decrement DE
		dec	cx	; Decrement BC
		jz	noMore206
		jmp	ldRepeat204 ; Loop until we're done!
noMore206:
		and	ah, 0e9h	; No N, P/V, or H!
		shl	eax, 16	; Save this for later
		mov	ax, [_orgval] ; Get our original BC count
		mov	dx, 21	; 21 Clock cycles per iteration
		mul	dx		; Multiply it!
		mov	edx, eax	; Put our value in EDX
		and	edx, 0ffffh ; Only the lower part matters..
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		shr	eax, 16	; Restore this!
		pop	ebp	; Restore our base pointer
		pop	esi	; Restore PC
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstb9:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
		mov	dword [_orgval], 0	; Zero our timing info
cpRepeat206:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop207:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr207		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine207

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead207
nextAddr207:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop207

callRoutine207:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead207
memoryRead207:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit207

callRead207:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit207:
		mov	byte [_z80af], ah
		sahf
		cmp	al, dl	; Do our comparison
		lahf
		and	ah, 0fah	; No P/V or carry!
		dec	cx	; Dec BC
		jz	notBcZero208
		or	ah, 04h	; P/V set when BC not zero
notBcZero208:
		or	ah, 02h	; N Gets set when we do compares
		mov	dl, byte [_z80af]
		and	dl, 01h
		or	ah, dl	; Preserve carry!
		dec	bx	; Decrement!
		sahf
		jz	BCDone206
		jnp	BCDone206
		add	dword [_orgval], 21	; 21 T-States when not done
		jmp	cpRepeat206
BCDone206:
		mov	edx, dword [_orgval]
		add	[dwElapsedTicks], edx
		sub	[cyclesRemaining], edx
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstba:
		sub	dword [cyclesRemaining], byte 21
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 21
loopIt208:
		push	cx	; Save BC
		xor	ch, ch ; We want 8 bit ports
		mov	edi, [_z80IoRead]	; Point to the read array

checkLoop209:
		cmp	[edi], word 0ffffh ; End of the list?
		je		ioRead209
		cmp	cx, [edi]	; Are we smaller?
		jb		nextAddr209		; Yes, go to the next address
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine209

nextAddr209:
		add	edi, 0ch		; Next structure!
		jmp	short checkLoop209

callRoutine209:
		mov	dx, cx	; Get our address
		call	ReadIOByte	; Standard read routine
		mov	dl, al	; Put it in DL for later consumption
		mov	ax, [_z80af]	; Get our AF back
		jmp	short readExit209

ioRead209:
		mov	dl, 0ffh	; An unreferenced read
readExit209:
		pop	cx	; Restore BC
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop210:
		cmp	bx, [edi]	; Are we smaller?
		jb	nextAddr210	; Yes... go to the next addr
		cmp	bx, [edi+4]	; Are we smaller?
		jbe	callRoutine210	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite210	; Yes - go write it!
nextAddr210:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop210

callRoutine210:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite210
memoryWrite210:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + ebx], dl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit210
callWrite210:
		mov	dx, bx	; Get our address to target
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit210:
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	near loopIt208
		jnz	clearFlag208
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue208
clearFlag208:
		and	ah, 0bfh	; Clear the zero flag
continue208:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

EDInstbb:
		sub	dword [cyclesRemaining], byte 16
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 16
loopIt211:
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop212:
		cmp	bx, [edi]		; Are we smaller?
		jb	nextAddr212		; Yes, go to the next address
		cmp	bx, [edi+4]		; Are we bigger?
		jbe	callRoutine212

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead212
nextAddr212:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop212

callRoutine212:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead212
memoryRead212:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + ebx]	; Get our data

		jmp	short readExit212

callRead212:
		mov	dx, bx		; Get our address
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit212:
		push	cx	; Save BC
		xor	ch, ch	; No 16 bit for this instruction!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	edi, [_z80IoWrite]	; Point to the I/O write array

checkLoop213:
		cmp	[edi], word 0ffffh ; End of our list?
		je	WriteMacroExit213	; Yes - ignore it!
		cmp	cx, [edi]	; Are we smaller?
		jb	nextAddr213	; Yes... go to the next addr
		cmp	cx, [edi+2]	; Are we bigger?
		jbe	callRoutine213	; If not, go call it!

nextAddr213:
		add	edi, 0ch		; Next structure, please
		jmp	short checkLoop213

callRoutine213:
		mov	dx, cx	; Get our address to target
		call	WriteIOByte	; Go write the data!
WriteMacroExit213:
		pop	cx	; Restore BC now that it has been "OUT"ed
		dec	bx	; Decrement HL
		dec	ch	; Decrement B (of C)
		jnz	near loopIt211
		jnz	clearFlag211
		or	ah, 040h	; Set the Zero flag!
		jmp	short continue211
clearFlag211:
		and	ah, 0bfh	; Clear the zero flag
continue211:
		or	ah, 02h	; Set negative!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst09:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, cx
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, cx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst19:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80de]
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, word [_z80de]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst21:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	di, [esi]	; Get our word to load
		add	esi, 2	; Advance past the word
		mov	[_z80ix], di ; Store our new value
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst22:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	dl, [_z80ix]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop214:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr214	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine214	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite214	; Yes - go write it!
nextAddr214:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop214

callRoutine214:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite214
memoryWrite214:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit214
callWrite214:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit214:
		inc	word [_orgval]
		mov	dl, [_z80ix + 1]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop215:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr215	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine215	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite215	; Yes - go write it!
nextAddr215:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop215

callRoutine215:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite215
memoryWrite215:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit215
callWrite215:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit215:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst23:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		inc	word [_z80ix]	; Increment our mz80Index register
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst24:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80ix + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst25:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80ix + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		or	ah, 02h	; Set negative!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst26:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80ix + 1], dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst29:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, di
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, di
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2a:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop216:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr216		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine216

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead216
nextAddr216:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop216

callRoutine216:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead216
memoryRead216:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit216

callRead216:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit216:
		mov	[_z80ix], dl
		inc	word [_orgval]
		mov	dx, [_orgval]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop217:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr217		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine217

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead217
nextAddr217:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop217

callRoutine217:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead217
memoryRead217:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit217

callRead217:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit217:
		mov	[_z80ix + 1], dl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2b:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		dec	word [_z80ix]	; Increment our mz80Index register
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80ix]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80ix]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		or	ah, 02h	; Set negative!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst2e:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80ix], dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst34:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned218	; Nope!
		dec	dh			; Make it FFable
notSigned218:
		add	dx, [_z80ix]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop219:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr219		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine219

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead219
nextAddr219:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop219

callRoutine219:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead219
memoryRead219:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit219

callRead219:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit219:
		sahf
		inc	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		shr	edx, 16
		and	ah, 0fdh	; Knock out N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop220:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr220	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine220	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite220	; Yes - go write it!
nextAddr220:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop220

callRoutine220:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite220
memoryWrite220:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit220
callWrite220:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit220:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst35:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned221	; Nope!
		dec	dh			; Make it FFable
notSigned221:
		add	dx, [_z80ix]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop222:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr222		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine222

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead222
nextAddr222:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop222

callRoutine222:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead222
memoryRead222:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit222

callRead222:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit222:
		sahf
		dec	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		shr	edx, 16
		or		ah, 02h	; Make it N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop223:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr223	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine223	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite223	; Yes - go write it!
nextAddr223:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop223

callRoutine223:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite223
memoryWrite223:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit223
callWrite223:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit223:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst36:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dx, [esi]	; Get our address
		add	esi, 2	; Skip over our storage bytes
		mov	di, dx	; Store it here for later
		xor	dh, dh
		or	dl, dl
		jns	noNegate224
		dec	dh
noNegate224:
		add	dx, [_z80ix]	; Add in our index
		mov	[_orgval], dx	; Store our address to write to
		mov	dx, di
		xchg	dh, dl
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop224:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr224	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine224	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite224	; Yes - go write it!
nextAddr224:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop224

callRoutine224:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite224
memoryWrite224:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit224
callWrite224:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit224:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst39:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80ix]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80sp]
		lahf
		mov	[_z80ix], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80ix] ; XOR It with our computed value
		xor	di, word [_z80sp]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst44:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80ix + 1]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst45:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80ix + 0]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst46:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned226	; Nope!
		dec	dh			; Make it FFable
notSigned226:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop227:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr227		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine227

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead227
nextAddr227:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop227

callRoutine227:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead227
memoryRead227:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	ch, [edi + edx]	; Get our data

		jmp	short readExit227

callRead227:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit227:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst4c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80ix + 1]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst4d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80ix + 0]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst4e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned229	; Nope!
		dec	dh			; Make it FFable
notSigned229:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop230:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr230		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine230

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead230
nextAddr230:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop230

callRoutine230:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead230
memoryRead230:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	cl, [edi + edx]	; Get our data

		jmp	short readExit230

callRead230:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit230:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst54:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80ix + 1]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst55:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80ix + 0]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst56:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned232	; Nope!
		dec	dh			; Make it FFable
notSigned232:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop233:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr233		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine233

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead233
nextAddr233:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop233

callRoutine233:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead233
memoryRead233:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de + 1], dl
		pop	edx
		jmp	short readExit233

callRead233:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit233:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst5c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80ix + 1]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst5d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80ix + 0]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst5e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned235	; Nope!
		dec	dh			; Make it FFable
notSigned235:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop236:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr236		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine236

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead236
nextAddr236:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop236

callRoutine236:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead236
memoryRead236:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de], dl
		pop	edx
		jmp	short readExit236

callRead236:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit236:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst60:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 1], ch
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst61:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 1], cl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst62:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 1], dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst63:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 1], dl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst64:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80ix + 1]
		mov   byte [_z80ix + 1], bh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst65:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80ix]
		mov   byte [_z80ix + 1], bl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst66:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned238	; Nope!
		dec	dh			; Make it FFable
notSigned238:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop239:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr239		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine239

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead239
nextAddr239:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop239

callRoutine239:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead239
memoryRead239:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bh, [edi + edx]	; Get our data

		jmp	short readExit239

callRead239:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit239:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst67:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 1], al
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst68:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 0], ch
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst69:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 0], cl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6a:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 0], dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6b:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80ix + 0], dl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80ix + 1]
		mov   byte [_z80ix + 0], bh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80ix]
		mov   byte [_z80ix + 0], bl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned241	; Nope!
		dec	dh			; Make it FFable
notSigned241:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop242:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr242		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine242

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead242
nextAddr242:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop242

callRoutine242:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead242
memoryRead242:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bl, [edi + edx]	; Get our data

		jmp	short readExit242

callRead242:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit242:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst6f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80ix + 0], al
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst70:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned244	; Nope!
		dec	dh			; Make it FFable
notSigned244:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop245:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr245	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine245	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite245	; Yes - go write it!
nextAddr245:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop245

callRoutine245:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite245
memoryWrite245:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit245
callWrite245:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit245:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst71:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned246	; Nope!
		dec	dh			; Make it FFable
notSigned246:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop247:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr247	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine247	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite247	; Yes - go write it!
nextAddr247:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop247

callRoutine247:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite247
memoryWrite247:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit247
callWrite247:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit247:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst72:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned248	; Nope!
		dec	dh			; Make it FFable
notSigned248:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop249:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr249	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine249	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite249	; Yes - go write it!
nextAddr249:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop249

callRoutine249:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite249
memoryWrite249:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit249
callWrite249:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit249:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst73:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned250	; Nope!
		dec	dh			; Make it FFable
notSigned250:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop251:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr251	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine251	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite251	; Yes - go write it!
nextAddr251:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop251

callRoutine251:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite251
memoryWrite251:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit251
callWrite251:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit251:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst74:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned252	; Nope!
		dec	dh			; Make it FFable
notSigned252:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop253:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr253	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine253	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite253	; Yes - go write it!
nextAddr253:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop253

callRoutine253:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite253
memoryWrite253:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit253
callWrite253:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit253:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst75:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned254	; Nope!
		dec	dh			; Make it FFable
notSigned254:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop255:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr255	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine255	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite255	; Yes - go write it!
nextAddr255:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop255

callRoutine255:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite255
memoryWrite255:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit255
callWrite255:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit255:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst77:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned256	; Nope!
		dec	dh			; Make it FFable
notSigned256:
		add	dx, [_z80ix]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop257:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr257	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine257	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite257	; Yes - go write it!
nextAddr257:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop257

callRoutine257:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite257
memoryWrite257:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit257
callWrite257:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit257:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst7c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80ix + 1]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst7d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80ix + 0]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst7e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned258	; Nope!
		dec	dh			; Make it FFable
notSigned258:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop259:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr259		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine259

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead259
nextAddr259:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop259

callRoutine259:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead259
memoryRead259:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	al, [edi + edx]	; Get our data

		jmp	short readExit259

callRead259:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
readExit259:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst84:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst85:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst86:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned261	; Nope!
		dec	dh			; Make it FFable
notSigned261:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop262:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr262		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine262

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead262
nextAddr262:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop262

callRoutine262:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead262
memoryRead262:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit262

callRead262:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit262:
		sahf
		add	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst8c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst8d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst8e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned263	; Nope!
		dec	dh			; Make it FFable
notSigned263:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop264:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr264		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine264

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead264
nextAddr264:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop264

callRoutine264:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead264
memoryRead264:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit264

callRead264:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit264:
		sahf
		adc	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst94:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst95:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst96:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned265	; Nope!
		dec	dh			; Make it FFable
notSigned265:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop266:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr266		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine266

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead266
nextAddr266:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop266

callRoutine266:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead266
memoryRead266:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit266

callRead266:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit266:
		sahf
		sub	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst9c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst9d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInst9e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned267	; Nope!
		dec	dh			; Make it FFable
notSigned267:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop268:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr268		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine268

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead268
nextAddr268:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop268

callRoutine268:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead268
memoryRead268:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit268

callRead268:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit268:
		sahf
		sbb	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInsta4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInsta5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInsta6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned269	; Nope!
		dec	dh			; Make it FFable
notSigned269:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop270:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr270		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine270

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead270
nextAddr270:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop270

callRoutine270:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead270
memoryRead270:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit270

callRead270:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit270:
		sahf
		and	al, dl
		lahf
		and	ah,0fch	; Knock out N & C
		or	ah, 10h	; Set half carry
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstac:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstad:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstae:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned271	; Nope!
		dec	dh			; Make it FFable
notSigned271:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop272:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr272		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine272

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead272
nextAddr272:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop272

callRoutine272:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead272
memoryRead272:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit272

callRead272:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit272:
		sahf
		xor	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstb4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstb5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstb6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned273	; Nope!
		dec	dh			; Make it FFable
notSigned273:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop274:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr274		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine274

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead274
nextAddr274:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop274

callRoutine274:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead274
memoryRead274:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit274

callRead274:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit274:
		sahf
		or	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstbc:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix + 1]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstbd:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80ix]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstbe:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned275	; Nope!
		dec	dh			; Make it FFable
notSigned275:
		add	dx, [_z80ix]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop276:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr276		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine276

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead276
nextAddr276:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop276

callRoutine276:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead276
memoryRead276:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit276

callRead276:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit276:
		sahf
		cmp	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

DDInstcb:
		mov	[_baseFixup], dword 3
		mov	dx, [esi]	; Get our instruction (and offset)
		add	esi, 2	; Increment our PC
		mov	byte [_orgval], dl ; Store our value
		or	dl, dl
		js	notNeg277
		mov	byte [_orgval + 1], 00h;
 		jmp	short jumpHandler277
notNeg277:
		mov	byte [_orgval + 1], 0ffh;	It's negative
jumpHandler277:
		shl	ebx, 16	; Save BX away
		mov	bx, [_z80ix]
		add	[_orgval], bx
		shr	ebx, 16	; Restore BX
		mov	dl, dh	; Get our instruction
		xor	dh, dh	; Zero this
		jmp	dword [z80ddfdcbInstructions+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste1:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop278:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr278		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine278

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead278
nextAddr278:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop278

callRoutine278:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead278
memoryRead278:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80ix], dl
		pop	edx
		jmp	short readExit278

callRead278:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80ix], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit278:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop279:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr279		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine279

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead279
nextAddr279:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop279

callRoutine279:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead279
memoryRead279:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80ix + 1], dl
		pop	edx
		jmp	short readExit279

callRead279:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80ix + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit279:
		add	word [_z80sp], 2
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste3:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov dx, word [_z80ix]
		push dx
		call PopWord
		mov	[_z80ix], dx
		pop dx
		mov [_wordval], dx
		call PushWord
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste5:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80ix]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop280:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr280	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine280	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite280	; Yes - go write it!
nextAddr280:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop280

callRoutine280:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite280
memoryWrite280:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80ix]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit280
callWrite280:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit280:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80ix + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop281:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr281	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine281	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite281	; Yes - go write it!
nextAddr281:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop281

callRoutine281:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite281
memoryWrite281:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80ix + 1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit281
callWrite281:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit281:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInste9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80ix]	; Get our value
		mov	esi, edx		; New PC!
		add	esi, ebp		; Add in our base
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDInstf9:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		mov	di, [_z80ix] ; Get our source register
		mov	word [_z80sp], di	; Store our new SP
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst06:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop282:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr282		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine282

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead282
nextAddr282:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop282

callRoutine282:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead282
memoryRead282:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit282

callRead282:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit282:
		sahf		; Restore our flags
		rol	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop283:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr283	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine283	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite283	; Yes - go write it!
nextAddr283:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop283

callRoutine283:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite283
memoryWrite283:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit283
callWrite283:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit283:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst0e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop284:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr284		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine284

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead284
nextAddr284:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop284

callRoutine284:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead284
memoryRead284:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit284

callRead284:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit284:
		sahf		; Restore our flags
		ror	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop285:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr285	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine285	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite285	; Yes - go write it!
nextAddr285:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop285

callRoutine285:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite285
memoryWrite285:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit285
callWrite285:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit285:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst16:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop286:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr286		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine286

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead286
nextAddr286:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop286

callRoutine286:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead286
memoryRead286:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit286

callRead286:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit286:
		sahf		; Restore our flags
		rcl	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop287:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr287	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine287	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite287	; Yes - go write it!
nextAddr287:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop287

callRoutine287:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite287
memoryWrite287:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit287
callWrite287:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit287:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst1e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop288:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr288		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine288

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead288
nextAddr288:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop288

callRoutine288:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead288
memoryRead288:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit288

callRead288:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit288:
		sahf		; Restore our flags
		rcr	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop289:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr289	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine289	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite289	; Yes - go write it!
nextAddr289:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop289

callRoutine289:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite289
memoryWrite289:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit289
callWrite289:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit289:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst26:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop290:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr290		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine290

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead290
nextAddr290:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop290

callRoutine290:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead290
memoryRead290:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit290

callRead290:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit290:
		sahf		; Restore our flags
		shl	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop291:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr291	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine291	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite291	; Yes - go write it!
nextAddr291:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop291

callRoutine291:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite291
memoryWrite291:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit291
callWrite291:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit291:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst2e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop292:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr292		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine292

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead292
nextAddr292:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop292

callRoutine292:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead292
memoryRead292:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit292

callRead292:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit292:
		sahf		; Restore our flags
		sar	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop293:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr293	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine293	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite293	; Yes - go write it!
nextAddr293:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop293

callRoutine293:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite293
memoryWrite293:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit293
callWrite293:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit293:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst3e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop294:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr294		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine294

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead294
nextAddr294:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop294

callRoutine294:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead294
memoryRead294:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit294

callRead294:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit294:
		sahf		; Restore our flags
		shr	dl, 1
		lahf		; Get our flags back
		and	ah, 0edh	; Knock out H & N
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop295:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr295	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine295	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite295	; Yes - go write it!
nextAddr295:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop295

callRoutine295:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite295
memoryWrite295:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit295
callWrite295:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit295:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst46:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop296:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr296		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine296

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead296
nextAddr296:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop296

callRoutine296:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead296
memoryRead296:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit296

callRead296:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit296:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 001h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst4e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop297:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr297		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine297

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead297
nextAddr297:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop297

callRoutine297:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead297
memoryRead297:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit297

callRead297:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit297:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 002h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst56:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop298:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr298		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine298

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead298
nextAddr298:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop298

callRoutine298:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead298
memoryRead298:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit298

callRead298:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit298:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 004h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst5e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop299:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr299		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine299

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead299
nextAddr299:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop299

callRoutine299:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead299
memoryRead299:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit299

callRead299:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit299:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 008h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst66:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop300:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr300		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine300

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead300
nextAddr300:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop300

callRoutine300:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead300
memoryRead300:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit300

callRead300:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit300:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 010h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst6e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop301:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr301		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine301

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead301
nextAddr301:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop301

callRoutine301:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead301
memoryRead301:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit301

callRead301:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit301:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 020h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst76:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop302:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr302		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine302

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead302
nextAddr302:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop302

callRoutine302:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead302
memoryRead302:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit302

callRead302:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit302:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 040h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst7e:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop303:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr303		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine303

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead303
nextAddr303:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop303

callRoutine303:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead303
memoryRead303:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit303

callRead303:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit303:
		mov	dh, ah	; Store our original flags
		and	dh, 29h	; Keep our old flags
		sahf		; Restore our flags
		test	dl, 080h	; Is it set?
		lahf		; Get our flags back
		and	ah, 0edh	; No Half carry or negative!
		or	ah, 10h	; OR In our half carry
		and	ah, 0d0h ; New flags
		or	ah, dh	; OR In our old flags
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst86:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop304:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr304		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine304

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead304
nextAddr304:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop304

callRoutine304:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead304
memoryRead304:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit304

callRead304:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit304:
		and	dl, 0feh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop305:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr305	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine305	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite305	; Yes - go write it!
nextAddr305:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop305

callRoutine305:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite305
memoryWrite305:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit305
callWrite305:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit305:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst8e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop306:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr306		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine306

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead306
nextAddr306:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop306

callRoutine306:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead306
memoryRead306:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit306

callRead306:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit306:
		and	dl, 0fdh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop307:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr307	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine307	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite307	; Yes - go write it!
nextAddr307:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop307

callRoutine307:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite307
memoryWrite307:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit307
callWrite307:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit307:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst96:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop308:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr308		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine308

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead308
nextAddr308:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop308

callRoutine308:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead308
memoryRead308:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit308

callRead308:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit308:
		and	dl, 0fbh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop309:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr309	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine309	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite309	; Yes - go write it!
nextAddr309:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop309

callRoutine309:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite309
memoryWrite309:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit309
callWrite309:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit309:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInst9e:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop310:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr310		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine310

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead310
nextAddr310:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop310

callRoutine310:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead310
memoryRead310:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit310

callRead310:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit310:
		and	dl, 0f7h	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop311:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr311	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine311	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite311	; Yes - go write it!
nextAddr311:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop311

callRoutine311:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite311
memoryWrite311:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit311
callWrite311:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit311:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInsta6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop312:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr312		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine312

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead312
nextAddr312:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop312

callRoutine312:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead312
memoryRead312:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit312

callRead312:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit312:
		and	dl, 0efh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop313:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr313	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine313	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite313	; Yes - go write it!
nextAddr313:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop313

callRoutine313:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite313
memoryWrite313:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit313
callWrite313:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit313:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstae:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop314:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr314		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine314

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead314
nextAddr314:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop314

callRoutine314:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead314
memoryRead314:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit314

callRead314:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit314:
		and	dl, 0dfh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop315:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr315	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine315	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite315	; Yes - go write it!
nextAddr315:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop315

callRoutine315:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite315
memoryWrite315:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit315
callWrite315:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit315:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstb6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop316:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr316		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine316

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead316
nextAddr316:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop316

callRoutine316:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead316
memoryRead316:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit316

callRead316:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit316:
		and	dl, 0bfh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop317:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr317	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine317	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite317	; Yes - go write it!
nextAddr317:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop317

callRoutine317:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite317
memoryWrite317:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit317
callWrite317:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit317:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstbe:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop318:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr318		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine318

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead318
nextAddr318:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop318

callRoutine318:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead318
memoryRead318:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit318

callRead318:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit318:
		and	dl, 07fh	; Reset the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop319:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr319	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine319	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite319	; Yes - go write it!
nextAddr319:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop319

callRoutine319:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite319
memoryWrite319:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit319
callWrite319:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit319:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstc6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop320:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr320		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine320

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead320
nextAddr320:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop320

callRoutine320:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead320
memoryRead320:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit320

callRead320:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit320:
		or	dl, 001h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop321:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr321	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine321	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite321	; Yes - go write it!
nextAddr321:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop321

callRoutine321:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite321
memoryWrite321:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit321
callWrite321:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit321:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstce:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop322:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr322		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine322

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead322
nextAddr322:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop322

callRoutine322:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead322
memoryRead322:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit322

callRead322:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit322:
		or	dl, 002h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop323:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr323	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine323	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite323	; Yes - go write it!
nextAddr323:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop323

callRoutine323:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite323
memoryWrite323:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit323
callWrite323:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit323:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstd6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop324:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr324		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine324

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead324
nextAddr324:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop324

callRoutine324:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead324
memoryRead324:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit324

callRead324:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit324:
		or	dl, 004h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop325:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr325	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine325	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite325	; Yes - go write it!
nextAddr325:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop325

callRoutine325:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite325
memoryWrite325:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit325
callWrite325:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit325:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstde:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop326:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr326		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine326

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead326
nextAddr326:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop326

callRoutine326:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead326
memoryRead326:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit326

callRead326:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit326:
		or	dl, 008h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop327:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr327	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine327	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite327	; Yes - go write it!
nextAddr327:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop327

callRoutine327:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite327
memoryWrite327:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit327
callWrite327:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit327:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInste6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop328:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr328		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine328

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead328
nextAddr328:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop328

callRoutine328:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead328
memoryRead328:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit328

callRead328:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit328:
		or	dl, 010h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop329:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr329	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine329	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite329	; Yes - go write it!
nextAddr329:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop329

callRoutine329:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite329
memoryWrite329:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit329
callWrite329:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit329:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstee:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop330:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr330		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine330

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead330
nextAddr330:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop330

callRoutine330:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead330
memoryRead330:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit330

callRead330:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit330:
		or	dl, 020h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop331:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr331	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine331	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite331	; Yes - go write it!
nextAddr331:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop331

callRoutine331:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite331
memoryWrite331:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit331
callWrite331:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit331:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstf6:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop332:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr332		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine332

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead332
nextAddr332:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop332

callRoutine332:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead332
memoryRead332:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit332

callRead332:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit332:
		or	dl, 040h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop333:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr333	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine333	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite333	; Yes - go write it!
nextAddr333:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop333

callRoutine333:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite333
memoryWrite333:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit333
callWrite333:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit333:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

DDFDCBInstfe:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dx, [_orgval]	; Get our target address
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop334:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr334		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine334

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead334
nextAddr334:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop334

callRoutine334:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead334
memoryRead334:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit334

callRead334:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit334:
		or	dl, 080h	; Set the bit
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop335:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr335	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine335	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite335	; Yes - go write it!
nextAddr335:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop335

callRoutine335:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite335
memoryWrite335:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit335
callWrite335:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit335:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst09:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, cx
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, cx
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst19:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80de]
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, word [_z80de]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst21:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	di, [esi]	; Get our word to load
		add	esi, 2	; Advance past the word
		mov	[_z80iy], di ; Store our new value
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst22:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	dl, [_z80iy]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop336:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr336	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine336	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite336	; Yes - go write it!
nextAddr336:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop336

callRoutine336:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite336
memoryWrite336:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit336
callWrite336:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit336:
		inc	word [_orgval]
		mov	dl, [_z80iy + 1]
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop337:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr337	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine337	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite337	; Yes - go write it!
nextAddr337:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop337

callRoutine337:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite337
memoryWrite337:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit337
callWrite337:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit337:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst23:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		inc	word [_z80iy]	; Increment our mz80Index register
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst24:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80iy + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst25:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80iy + 1]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		or	ah, 02h	; Set negative!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst26:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80iy + 1], dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst29:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, di
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, di
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2a:
		sub	dword [cyclesRemaining], byte 20
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 20
		mov	dx, [esi]	 ; Get our address to store
		add	esi, 2
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop338:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr338		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine338

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead338
nextAddr338:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop338

callRoutine338:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead338
memoryRead338:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit338

callRead338:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit338:
		mov	[_z80iy], dl
		inc	word [_orgval]
		mov	dx, [_orgval]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop339:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr339		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine339

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead339
nextAddr339:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop339

callRoutine339:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead339
memoryRead339:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit339

callRead339:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit339:
		mov	[_z80iy + 1], dl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2b:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		dec	word [_z80iy]	; Increment our mz80Index register
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		inc	byte [_z80iy]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		and	ah, 0fdh	; Knock out N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		sahf
		dec	byte [_z80iy]
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		xor	edx, edx
		or	ah, 02h	; Set negative!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst2e:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, [esi]	; Get immediate byte to load
		inc	esi	; Next byte
		mov	byte [_z80iy], dl
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst34:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned340	; Nope!
		dec	dh			; Make it FFable
notSigned340:
		add	dx, [_z80iy]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop341:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr341		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine341

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead341
nextAddr341:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop341

callRoutine341:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead341
memoryRead341:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit341

callRead341:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit341:
		sahf
		inc	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		shr	edx, 16
		and	ah, 0fdh	; Knock out N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop342:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr342	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine342	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite342	; Yes - go write it!
nextAddr342:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop342

callRoutine342:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite342
memoryWrite342:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit342
callWrite342:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit342:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst35:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned343	; Nope!
		dec	dh			; Make it FFable
notSigned343:
		add	dx, [_z80iy]	; Our offset!
		mov	[_orgval], dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop344:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr344		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine344

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead344
nextAddr344:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop344

callRoutine344:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead344
memoryRead344:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit344

callRead344:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit344:
		sahf
		dec	dl
		lahf
		o16	pushf
		shl	edx, 16
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		shr	edx, 16
		or		ah, 02h	; Make it N!
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop345:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr345	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine345	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite345	; Yes - go write it!
nextAddr345:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop345

callRoutine345:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite345
memoryWrite345:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit345
callWrite345:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit345:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst36:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dx, [esi]	; Get our address
		add	esi, 2	; Skip over our storage bytes
		mov	di, dx	; Store it here for later
		xor	dh, dh
		or	dl, dl
		jns	noNegate346
		dec	dh
noNegate346:
		add	dx, [_z80iy]	; Add in our index
		mov	[_orgval], dx	; Store our address to write to
		mov	dx, di
		xchg	dh, dl
		mov	[_z80af], ax	; Store AF
		mov	al, dl	; And our data to write
		mov	dx, [_orgval]
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop346:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr346	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine346	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite346	; Yes - go write it!
nextAddr346:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop346

callRoutine346:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite346
memoryWrite346:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit346
callWrite346:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit346:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst39:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		mov	dh, ah	; Get our flags
		and	dh, 0ech	; Preserve the top three and bits 2 & 3
		mov	di, [_z80iy]	; Get our value
		mov	[_orgval], di	; Store our original value
		add	di, word [_z80sp]
		lahf
		mov	[_z80iy], di	; Store our register back
		mov	di, [_orgval]	; Get original
		xor	di, word [_z80iy] ; XOR It with our computed value
		xor	di, word [_z80sp]
		and	di, 1000h	; Just our half carry
		or		dx, di	; Or in our flags
		and	ah, 01h	; Just carry
		or	ah, dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst44:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80iy + 1]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst45:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	ch, byte [_z80iy + 0]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst46:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned348	; Nope!
		dec	dh			; Make it FFable
notSigned348:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop349:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr349		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine349

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead349
nextAddr349:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop349

callRoutine349:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead349
memoryRead349:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	ch, [edi + edx]	; Get our data

		jmp	short readExit349

callRead349:
		call	ReadMemoryByte	; Standard read routine
		mov	ch, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit349:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst4c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80iy + 1]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst4d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	cl, byte [_z80iy + 0]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst4e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned351	; Nope!
		dec	dh			; Make it FFable
notSigned351:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop352:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr352		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine352

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead352
nextAddr352:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop352

callRoutine352:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead352
memoryRead352:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	cl, [edi + edx]	; Get our data

		jmp	short readExit352

callRead352:
		call	ReadMemoryByte	; Standard read routine
		mov	cl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit352:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst54:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80iy + 1]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst55:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dh, byte [_z80iy + 0]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst56:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned354	; Nope!
		dec	dh			; Make it FFable
notSigned354:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop355:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr355		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine355

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead355
nextAddr355:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop355

callRoutine355:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead355
memoryRead355:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de + 1], dl
		pop	edx
		jmp	short readExit355

callRead355:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit355:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst5c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80iy + 1]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst5d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dx, [_z80de]	; Get a usable copy of DE here
		mov	dl, byte [_z80iy + 0]
		mov	[_z80de], dx	; Put it back!
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst5e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned357	; Nope!
		dec	dh			; Make it FFable
notSigned357:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop358:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr358		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine358

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead358
nextAddr358:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop358

callRoutine358:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead358
memoryRead358:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80de], dl
		pop	edx
		jmp	short readExit358

callRead358:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80de], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit358:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst60:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 1], ch
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst61:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 1], cl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst62:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 1], dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst63:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 1], dl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst64:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80iy + 1]
		mov   byte [_z80iy + 1], bh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst65:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80iy]
		mov   byte [_z80iy + 1], bl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst66:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned360	; Nope!
		dec	dh			; Make it FFable
notSigned360:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop361:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr361		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine361

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead361
nextAddr361:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop361

callRoutine361:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead361
memoryRead361:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bh, [edi + edx]	; Get our data

		jmp	short readExit361

callRead361:
		call	ReadMemoryByte	; Standard read routine
		mov	bh, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit361:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst67:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 1], al
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst68:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 0], ch
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst69:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 0], cl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6a:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 0], dh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6b:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dx, [_z80de]	; Get DE
		mov   byte [_z80iy + 0], dl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dh, byte [_z80iy + 1]
		mov   byte [_z80iy + 0], bh
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
	mov	dl, byte [_z80iy]
		mov   byte [_z80iy + 0], bl
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned363	; Nope!
		dec	dh			; Make it FFable
notSigned363:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop364:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr364		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine364

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead364
nextAddr364:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop364

callRoutine364:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead364
memoryRead364:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	bl, [edi + edx]	; Get our data

		jmp	short readExit364

callRead364:
		call	ReadMemoryByte	; Standard read routine
		mov	bl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit364:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst6f:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov   byte [_z80iy + 0], al
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst70:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned366	; Nope!
		dec	dh			; Make it FFable
notSigned366:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, ch	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop367:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr367	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine367	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite367	; Yes - go write it!
nextAddr367:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop367

callRoutine367:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite367
memoryWrite367:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], ch
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit367
callWrite367:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit367:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst71:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned368	; Nope!
		dec	dh			; Make it FFable
notSigned368:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, cl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop369:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr369	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine369	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite369	; Yes - go write it!
nextAddr369:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop369

callRoutine369:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite369
memoryWrite369:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], cl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit369
callWrite369:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit369:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst72:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned370	; Nope!
		dec	dh			; Make it FFable
notSigned370:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop371:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr371	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine371	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite371	; Yes - go write it!
nextAddr371:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop371

callRoutine371:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite371
memoryWrite371:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de + 1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit371
callWrite371:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit371:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst73:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned372	; Nope!
		dec	dh			; Make it FFable
notSigned372:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80de]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop373:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr373	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine373	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite373	; Yes - go write it!
nextAddr373:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop373

callRoutine373:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite373
memoryWrite373:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80de]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit373
callWrite373:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit373:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst74:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned374	; Nope!
		dec	dh			; Make it FFable
notSigned374:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bh	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop375:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr375	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine375	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite375	; Yes - go write it!
nextAddr375:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop375

callRoutine375:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite375
memoryWrite375:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bh
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit375
callWrite375:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit375:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst75:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned376	; Nope!
		dec	dh			; Make it FFable
notSigned376:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	al, bl	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop377:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr377	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine377	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite377	; Yes - go write it!
nextAddr377:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop377

callRoutine377:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite377
memoryWrite377:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], bl
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit377
callWrite377:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit377:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst77:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned378	; Nope!
		dec	dh			; Make it FFable
notSigned378:
		add	dx, [_z80iy]	; Our offset!
		mov	[_z80af], ax	; Store AF
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop379:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr379	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine379	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite379	; Yes - go write it!
nextAddr379:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop379

callRoutine379:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite379
memoryWrite379:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	[edi + edx], al
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit379
callWrite379:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit379:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst7c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80iy + 1]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst7d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	al, byte [_z80iy + 0]
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst7e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned380	; Nope!
		dec	dh			; Make it FFable
notSigned380:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop381:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr381		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine381

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead381
nextAddr381:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop381

callRoutine381:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead381
memoryRead381:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	al, [edi + edx]	; Get our data

		jmp	short readExit381

callRead381:
		call	ReadMemoryByte	; Standard read routine
		mov	[_z80af], al	; Save our new accumulator
		mov	ax, [_z80af]	; Get our AF back
readExit381:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst84:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst85:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		add	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst86:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned383	; Nope!
		dec	dh			; Make it FFable
notSigned383:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop384:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr384		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine384

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead384
nextAddr384:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop384

callRoutine384:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead384
memoryRead384:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit384

callRead384:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit384:
		sahf
		add	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst8c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst8d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		adc	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh ; No N!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst8e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned385	; Nope!
		dec	dh			; Make it FFable
notSigned385:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop386:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr386		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine386

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead386
nextAddr386:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop386

callRoutine386:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead386
memoryRead386:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit386

callRead386:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit386:
		sahf
		adc	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		and	ah, 0fdh	; Knock out negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst94:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst95:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		sub	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst96:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned387	; Nope!
		dec	dh			; Make it FFable
notSigned387:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop388:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr388		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine388

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead388
nextAddr388:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop388

callRoutine388:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead388
memoryRead388:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit388

callRead388:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit388:
		sahf
		sub	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst9c:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst9d:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		sbb	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; N Gets set!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInst9e:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned389	; Nope!
		dec	dh			; Make it FFable
notSigned389:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop390:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr390		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine390

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead390
nextAddr390:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop390

callRoutine390:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead390
memoryRead390:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit390

callRead390:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit390:
		sahf
		sbb	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInsta4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInsta5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		and	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		or	ah, 010h	; Half carry gets set
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInsta6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned391	; Nope!
		dec	dh			; Make it FFable
notSigned391:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop392:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr392		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine392

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead392
nextAddr392:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop392

callRoutine392:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead392
memoryRead392:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit392

callRead392:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit392:
		sahf
		and	al, dl
		lahf
		and	ah,0fch	; Knock out N & C
		or	ah, 10h	; Set half carry
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstac:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstad:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		xor	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech	; Only these flags matter!
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstae:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned393	; Nope!
		dec	dh			; Make it FFable
notSigned393:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop394:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr394		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine394

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead394
nextAddr394:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop394

callRoutine394:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead394
memoryRead394:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit394

callRead394:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit394:
		sahf
		xor	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstb4:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstb5:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		or	al, dl
		lahf		; Get flags back into AH
		and	ah, 0ech ; No H, N, or C
		and	ah, 0ech ; No H, N, or C
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstb6:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned395	; Nope!
		dec	dh			; Make it FFable
notSigned395:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop396:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr396		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine396

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead396
nextAddr396:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop396

callRoutine396:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead396
memoryRead396:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit396

callRead396:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit396:
		sahf
		or	al, dl
		lahf
		and	ah, 0ech	; Knock out H, N, and C
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstbc:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy + 1]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstbd:
		sub	dword [cyclesRemaining], byte 9
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 9
		mov	dl, byte [_z80iy]
		sahf		; Store our flags in x86 flag reg
		cmp	al, dl
		lahf		; Get flags back into AH
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Negative gets set on a compare
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstbe:
		sub	dword [cyclesRemaining], byte 19
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 19
		mov	dl, [esi]	; Fetch our offset
		inc	esi		; Move past the offset
		or	dl, dl		; Is this bad boy signed?
		jns	notSigned397	; Nope!
		dec	dh			; Make it FFable
notSigned397:
		add	dx, [_z80iy]	; Our offset!
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop398:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr398		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine398

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead398
nextAddr398:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop398

callRoutine398:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead398
memoryRead398:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		mov	dl, [edi + edx]	; Get our data

		jmp	short readExit398

callRead398:
		call	ReadMemoryByte	; Standard read routine
		mov	dl, al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit398:
		sahf
		cmp	al, dl
		lahf
		o16	pushf
		and	ah, 0fbh	;	Knock out parity/overflow
		pop	dx
		and	dh, 08h ; Just the overflow
		shr	dh, 1	; Shift it into position
		or	ah, dh	; OR It in with the real flags
		xor	edx, edx
		or	ah, 02h	; Set negative
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]

FDInstcb:
		mov	[_baseFixup], dword 3
		mov	dx, [esi]	; Get our instruction (and offset)
		add	esi, 2	; Increment our PC
		mov	byte [_orgval], dl ; Store our value
		or	dl, dl
		js	notNeg399
		mov	byte [_orgval + 1], 00h;
 		jmp	short jumpHandler399
notNeg399:
		mov	byte [_orgval + 1], 0ffh;	It's negative
jumpHandler399:
		shl	ebx, 16	; Save BX away
		mov	bx, [_z80iy]
		add	[_orgval], bx
		shr	ebx, 16	; Restore BX
		mov	dl, dh	; Get our instruction
		xor	dh, dh	; Zero this
		jmp	dword [z80ddfdcbInstructions+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste1:
		sub	dword [cyclesRemaining], byte 14
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 14
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop400:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr400		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine400

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead400
nextAddr400:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop400

callRoutine400:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead400
memoryRead400:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80iy], dl
		pop	edx
		jmp	short readExit400

callRead400:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80iy], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit400:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop401:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr401		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine401

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead401
nextAddr401:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop401

callRoutine401:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead401
memoryRead401:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_z80iy + 1], dl
		pop	edx
		jmp	short readExit401

callRead401:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_z80iy + 1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit401:
		add	word [_z80sp], 2
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste3:
		sub	dword [cyclesRemaining], byte 23
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 23
		mov dx, word [_z80iy]
		push dx
		call PopWord
		mov	[_z80iy], dx
		pop dx
		mov [_wordval], dx
		call PushWord
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste5:
		sub	dword [cyclesRemaining], byte 15
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 15
		sub	word [_z80sp], 2
		mov	dx, [_z80sp]
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80iy]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop402:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr402	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine402	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite402	; Yes - go write it!
nextAddr402:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop402

callRoutine402:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite402
memoryWrite402:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80iy]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit402
callWrite402:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit402:
		inc	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_z80iy + 1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop403:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr403	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine403	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite403	; Yes - go write it!
nextAddr403:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop403

callRoutine403:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite403
memoryWrite403:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_z80iy + 1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit403
callWrite403:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit403:
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInste9:
		sub	dword [cyclesRemaining], byte 8
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 8
		mov	dx, [_z80iy]	; Get our value
		mov	esi, edx		; New PC!
		add	esi, ebp		; Add in our base
		xor	edx, edx
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

FDInstf9:
		sub	dword [cyclesRemaining], byte 10
		js	near noMoreExec2
		add	dword [dwElapsedTicks], byte 10
		mov	di, [_z80iy] ; Get our source register
		mov	word [_z80sp], di	; Store our new SP
		mov	dl, byte [esi]	; Get our next instruction
		inc	esi		; Increment PC
		jmp	dword [z80regular+edx*4]


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic read memory byte handler when a foreign
; handler is to be called

; EDI=Handler address, EDX=Address
; On return, EDX & EDI are undisturbed and AL=Byte read

ReadMemoryByte:
		mov	[_z80af], ax	; Save AF
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BC
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	edx	; And our desired address
		call	dword [edi + 8]	; Go call our handler
		pop	edx	; Restore our address
		pop	edi	; Restore our handler's address
		xor	ebx, ebx	; Zero our future HL
		xor	esi, esi	; Zero it!
		mov	ebp, [z80Base] ; Base pointer comes back
		mov	si, [_z80pc]	; Get our program counter back
		xor	ecx, ecx	; Zero our future BC
		add	esi, ebp	; Rebase it properly
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic read memory byte handler when a foreign
; handler is to be called.
; EDI=Handler address, AL=Byte to write, EDX=Address
; EDI and EDX Are undisturbed on exit

WriteMemoryByte:
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BX
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	eax	; Data to write
		push	edx	; And our desired address
		call	dword [edi + 8]	; Go call our handler
		pop	edx	; Restore our address
		pop	eax	; Restore our data written
		pop	edi	; Save our structure address
		xor	ebx, ebx	; Zero our future HL
		xor	ecx, ecx	; Zero our future BC
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		mov	ax, [_z80af]	; Get AF back
		xor	esi, esi	; Zero it!
		mov	si, [_z80pc]	; Get our program counter back
		mov	ebp, [z80Base] ; Base pointer comes back
		add	esi, ebp	; Rebase it properly
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

;
; DX=Top of SP, [_wordval]=word value to push
;

PushWord:
		mov	dx, [_z80sp]
		dec	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_wordval+1]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop404:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr404	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine404	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite404	; Yes - go write it!
nextAddr404:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop404

callRoutine404:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite404
memoryWrite404:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_wordval+1]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit404
callWrite404:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit404:
		dec	dx
		mov	[_z80af], ax	; Store AF
		mov	al, byte [_wordval]	; And our data to write
		mov	edi, [_z80MemWrite]	; Point to the write array

checkLoop405:
		cmp	dx, [edi]	; Are we smaller?
		jb	nextAddr405	; Yes... go to the next addr
		cmp	dx, [edi+4]	; Are we smaller?
		jbe	callRoutine405	; If not, go call it!

		cmp	[edi], word 0ffffh ; End of our list?
		je	memoryWrite405	; Yes - go write it!
nextAddr405:
		add	edi, 10h		; Next structure, please
		jmp	short checkLoop405

callRoutine405:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal write?
		jne	short callWrite405
memoryWrite405:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		add	edi, edx
		mov	dl, byte [_wordval]
		mov	[edi], dl
		pop	edx
		mov	ax, [_z80af] ; Get our accumulator and flags
		jmp	short WriteMacroExit405
callWrite405:
		call	WriteMemoryByte	; Go write the data!
WriteMacroExit405:
		sub	[_z80sp], word 2
		xor	edx, edx
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

;
; [_z80sp]=Top of SP, DX=Word value read
;

PopWord:
		mov	dx, [_z80sp]
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop406:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr406		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine406

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead406
nextAddr406:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop406

callRoutine406:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead406
memoryRead406:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_wordval], dl
		pop	edx
		jmp	short readExit406

callRead406:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_wordval], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit406:
		inc	dx
		mov	edi, [_z80MemRead]	; Point to the read array

checkLoop407:
		cmp	dx, [edi]		; Are we smaller?
		jb	nextAddr407		; Yes, go to the next address
		cmp	dx, [edi+4]		; Are we bigger?
		jbe	callRoutine407

		cmp	[edi], word 0ffffh	; End of the list?
		je	memoryRead407
nextAddr407:
		add	edi, 10h		; Next structure!
		jmp	short checkLoop407

callRoutine407:
		cmp	dword[edi+8],byte 0 	; [J3d!] Use internal read?
		jne	short callRead407
memoryRead407:
		mov	edi, [edi+12] 		; [J3d!] Get offset
		push	edx
		mov	dl, [edi + edx]
		mov	byte [_wordval+1], dl
		pop	edx
		jmp	short readExit407

callRead407:
		call	ReadMemoryByte	; Standard read routine
		mov	byte [_wordval+1], al	; Put our returned value here
		mov	ax, [_z80af]	; Get our AF back
readExit407:
		add	[_z80sp], word 2
		mov	dx, [_wordval]
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic I/O read byte handler for when a foreign
; handler is to be called
; EDI=Handler address, EDX=I/O Address
; On return, EDX & EDI are undisturbed and AL=Byte read

ReadIOByte:
		mov	[_z80af], ax	; Save AF
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BC
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	edx	; And our desired I/O port
		call	dword [edi + 4]	; Go call our handler
		pop	edx	; Restore our address
		pop	edi	; Restore our handler's address
		xor	ebx, ebx	; Zero our future HL
		xor	ecx, ecx	; Zero our future BC
		xor	esi, esi	; Zero it!
		mov	si, [_z80pc]	; Get our program counter back
		mov	ebp, [z80Base] ; Base pointer comes back
		add	esi, ebp	; Rebase it properly
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		ret


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

; This is a generic write I/O byte handler when a foreign handler is to
; be called
; EDI=Handler address, AL=Byte to write, EDX=I/O Address
; EDI and EDX Are undisturbed on exit

WriteIOByte:
		mov	[_z80hl], bx	; Save HL
		mov	[_z80bc], cx	; Save BX
		sub	esi, ebp	; Our program counter
		mov	[_z80pc], si	; Save our program counter
		push	edi	; Save our structure address
		push	eax	; Data to write
		push	edx	; And our desired I/O address
		call	dword [edi + 4]	; Go call our handler
		pop	edx	; Restore our address
		pop	eax	; Restore our data written
		pop	edi	; Save our structure address
		xor	ebx, ebx	; Zero our future HL
		xor	ecx, ecx	; Zero our future BC
		mov	bx, [_z80hl]	; Get HL back
		mov	cx, [_z80bc]	; Get BC back
		mov	ax, [_z80af]	; Get AF back
		xor	esi, esi	; Zero it!
		mov	si, [_z80pc]	; Get our program counter back
		mov	ebp, [z80Base] ; Base pointer comes back
		add	esi, ebp	; Rebase it properly
		ret

		global	_mz80GetContext
		global	mz80GetContext_
		global	mz80GetContext

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80GetContext_:
_mz80GetContext:
mz80GetContext:
		mov	eax, [esp+4]	; Get our context address
		push	esi		; Save registers we use
		push	edi
		push	ecx
		mov     ecx, _mz80contextEnd - _mz80contextBegin
		mov	esi, _mz80contextBegin
		mov	edi, eax	; Source address in ESI
		rep	movsb		; Move it as fast as we can!
		pop	ecx
		pop	edi
		pop	esi
		ret			; No return code
		global	_mz80SetContext
		global	mz80SetContext_
		global	mz80SetContext

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80SetContext_:
_mz80SetContext:
mz80SetContext:
		mov	eax, [esp+4]	; Get our context address
		push	esi		; Save registers we use
		push	edi
		push	ecx
		mov	edi, _mz80contextBegin
		mov	esi, eax	; Source address in ESI
		mov     ecx, _mz80contextEnd - _mz80contextBegin
		rep	movsb
		pop	ecx
		pop	edi
		pop	esi
		ret			; No return code
		global	_mz80GetContextSize
		global	mz80GetContextSize_
		global	mz80GetContextSize

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80GetContextSize_:
_mz80GetContextSize:
mz80GetContextSize:
		mov     eax, _mz80contextEnd - _mz80contextBegin
		ret

		global	_mz80GetElapsedTicks
		global	mz80GetElapsedTicks_
		global	mz80GetElapsedTicks

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80GetElapsedTicks_:
_mz80GetElapsedTicks:
mz80GetElapsedTicks:
		mov	eax, [esp+4]	; Get our context address
		or	eax, eax	; Should we clear it?
		jz	getTicks
		xor	eax, eax
		xchg	eax, [dwElapsedTicks]
		ret
getTicks:
		mov	eax, [dwElapsedTicks]
		ret
		global	_mz80ReleaseTimeslice
		global	mz80ReleaseTimeslice_
		global	mz80ReleaseTimeslice

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary


times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80ReleaseTimeslice_:
_mz80ReleaseTimeslice:
mz80ReleaseTimeslice:
		mov	eax, [cyclesRemaining]
		sub	[dwOriginalExec], eax
		mov	[cyclesRemaining], dword 1
		ret

		global	_mz80reset
		global	mz80reset_
		global	mz80reset

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80reset_:
_mz80reset:
mz80reset:
		xor	eax, eax 	; Zero AX

		mov	dword [_z80halted], eax	; We're not halted anymore!
		mov	word [_z80af], ax	; Zero A & flags
		mov	word [_z80bc], ax	; Zero BC
		mov	word [_z80de],	ax	; Zero DE
		mov	word [_z80hl], ax	; Zero HL
		mov	word [_z80afprime], ax	; Zero AF Prime
		mov	word [_z80bcprime], ax	; Zero BC prime
		mov	word [_z80deprime], ax ; Zero DE prime
		mov	word [_z80hlprime], ax ; Zero HL prime
		mov	byte [_z80i], al	; Zero Interrupt register
		mov	byte [_z80r], al	; Zero refresh register
		mov	word [_z80ix], 0ffffh	; Default mz80Index register
		mov	word [_z80iy], 0ffffh	; Default mz80Index register
		mov	word [_z80pc], ax	; Zero program counter
		mov	word [_z80sp], ax	; And the stack pointer
		mov	dword [_z80inInterrupt], eax ; Not in interrupt
		mov	dword [_z80interruptMode], eax ; Clear our interrupt mode (0)
		mov	dword [_z80interruptState], eax ; Set the state to off
		mov	word [_z80intAddr], 38h ; Set default interrupt address
		mov	word [_z80nmiAddr], 66h ; Set default nmi addr

		ret

		global	_mz80int
		global	mz80int_
		global	mz80int

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80int_:
_mz80int:
mz80int:
		mov	eax, [esp+4]	; Get our (potential) lower interrupt address
		cmp	dword [_z80interruptState], 0
		je	near alreadyInInt   ; Interrupts are disabled


		inc	dword [_z80inInterrupt]	; Set our in-interrupt semaphore
		mov	dword [_z80halted], 0	; We're not halted!

		push	ebp
		push	edi
		push	edx
		mov	ebp, [z80Base]

       pushad
		xor edx, edx
		mov	ax, [_z80pc]
		mov	[_wordval], ax
		push	ecx
		push	ebx
		push	esi
       mov ax, [_z80af]
       mov	bx, [_z80hl]
       mov	cx, [_z80bc]
		call	PushWord
		pop	esi
		pop	ebx
		pop	ecx
       popad
		cmp	dword [_z80interruptMode], 2 ; Are we lower than mode 2?
		jb		justModeTwo
		mov	ah, [_z80i]	; Get our high address here
		and	eax, 0ffffh ; Only the lower part
		mov	ax, [eax+ebp] ; Get our vector
		jmp	short setNewVector ; Go set it!
justModeTwo:
		mov	ax, word [_z80intAddr]
setNewVector:
		mov	[_z80pc], ax

		pop	edx
		pop	edi
		pop	ebp

		xor	eax, eax	; Indicate we took the interrupt
		jmp	short z80intExit

alreadyInInt:
		mov	eax, 1		; Indicate we didn't take it

z80intExit:
		ret
		global	_mz80nmi
		global	mz80nmi_
		global	mz80nmi

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80nmi_:
_mz80nmi:
mz80nmi:
		mov	dword [_z80halted], 0	; We're not halted anymore!
		mov	dword [_z80inInterrupt], 0	; We're not halted anymore!

		push	ebp
		push	edi
		mov	ebp, [z80Base]

       pushad
		push	ebx
		push	ecx
		push	edx
		push	esi
		push	eax
		xor edx, edx
		xor	eax, eax
		mov	ax, [_z80pc]
		mov	[_wordval], ax
		mov	esi, ebp
		add	esi, eax
       mov ax, [_z80af]
       mov	bx, [_z80hl]
       mov	cx, [_z80bc]
		call	PushWord
		pop	eax
		pop	esi
		pop	edx
		pop	ecx
		pop	ebx
       popad
		mov	ax, [_z80nmiAddr]
		mov	[_z80pc], ax

		pop	edi
		pop	ebp

		xor	eax, eax	; Indicate we took the interrupt
		ret
		global	_mz80_set_stop_at_int_end
		global	mz80_set_stop_at_int_end_
		global	mz80_set_stop_at_int_end

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80_set_stop_at_int_end_:
_mz80_set_stop_at_int_end:
mz80_set_stop_at_int_end:
		mov	dword [_z80stoponintend], 1
		ret
		global	_mz80exec
		global	mz80exec_
		global	mz80exec

times ($$-$) & 3 nop	; pad with NOPs to 4-byte boundary

mz80exec_:
_mz80exec:
mz80exec:
		mov	eax, [esp+4]	; Get our execution cycle count
		push	ebx			; Save all registers we use
		push	ecx
		push	edx
		push	ebp
		push	esi
		push	edi

		mov	dword [cyclesRemaining], eax	; Store # of instructions to
		mov	[dwOriginalExec], eax	; Store this!
		sub	[dwOriginalExec], dword 5	; Adjustment
						; execute
		cmp	dword [_z80halted], 0
		je	goCpu
		mov	eax, dword [cyclesRemaining]
		add	dword [dwElapsedTicks], eax
		mov	dword [cyclesRemaining], 0	; Nothing left!
		mov	eax, 80000000h	; Successful exection
		jmp	popReg
goCpu:
		cld				; Go forward!

		xor	eax, eax		; Zero EAX 'cause we use it!
		xor	ebx, ebx		; Zero EBX, too
		xor	ecx, ecx		; Zero ECX
		xor	edx, edx		; And EDX
		xor	edi, edi		; Zero EDI as well
		xor	esi, esi		; Zero our source address

		mov	ax, [_z80af]		; Accumulator & flags
		xchg	ah, al		; Swap these for later
		mov	bx, [_z80hl]		; Get our HL value
		mov	cx, [_z80bc]		; And our BC value
		mov	ebp, [z80Base]		; Get the base address
		mov	si, [_z80pc]		; Get our program counter
		add	esi, ebp		; Add in our base address
		mov	dl, [esi]
		inc	esi
		jmp	dword [z80regular+edx*4]

; We get to invalidInsWord if it's a double byte invalid opcode

invalidInsWord:
		dec	esi

; We get to invalidInsByte if it's a single byte invalid opcode

invalidInsByte:
		xchg	ah, al		; Swap them back so they look good
		mov	[_z80af], ax		; Store A & flags
		dec	esi			; Back up one instruction...
		mov	edx, esi		; Get our address in EAX
		sub	edx, ebp		; And subtract our base for
						; an invalid instruction
		jmp	short emulateEnd

noMoreExec2:
		sub	esi, [_baseFixup]
noMoreExec:
		dec	esi
		xchg	ah, al		; Swap these for later
		mov	[_z80af], ax		; Store A & flags
		mov	edx, [dwOriginalExec]	; Original exec time
		sub	edx, [cyclesRemaining]	; Subtract # of cycles remaining
		add	[dwElapsedTicks], edx	; Add our executed time
		mov	edx, 80000000h		; Indicate successful exec
		jmp	short emulateEnd	; All finished!

; Now let's tuck away the virtual registers for next time

storeFlags:
		xchg	ah, al		; Swap these for later
		mov	[_z80af], ax		; Store A & flags
emulateEnd:
		mov	[_z80hl], bx		; Store HL
		mov	[_z80bc], cx		; Store BC
		sub	esi, [z80Base]		; Knock off physical address
		mov	[_z80pc], si		; And store virtual address
		mov	eax, edx		; Result code return

popReg:
		pop	edi			; Restore registers
		pop	esi
		pop	ebp
		pop	edx
		pop	ecx
		pop	ebx

		ret

		end
